#ifndef _NAMESLAPACK_H
#define _NAMESLAPACK_H


#include "f2c.h"


/* on several architectures names of fortran routines are passed to C in 
   different ways. To cover this different architectures use in C only lower
   letters for the fortran names. Dependent on the switch you use they are
   replaced by the correct function name
*/


/* only use capital letters */
#if defined __CAPS__ && !defined __UNDERSCORE__ && !defined __2UNDERSCORES__

#define cbdsqr           CBDSQR	   
#define cgbbrd		 CGBBRD	   
#define cgbcon		 CGBCON	   
#define cgbequ		 CGBEQU	   
#define cgbrfs		 CGBRFS	   
#define cgbsv		 CGBSV	   
#define cgbsvx		 CGBSVX	   
#define cgbtf2		 CGBTF2	   
#define cgbtrf		 CGBTRF	   
#define cgbtrs		 CGBTRS	   
#define cgebak		 CGEBAK	   
#define cgebal		 CGEBAL	   
#define cgebd2		 CGEBD2	   
#define cgebrd		 CGEBRD	   
#define cgecon		 CGECON	   
#define cgeequ		 CGEEQU	   
#define cgees		 CGEES	   
#define cgeesx		 CGEESX	   
#define cgeev		 CGEEV	   
#define cgeevx		 CGEEVX	   
#define cgegs		 CGEGS	   
#define cgegv		 CGEGV	   
#define cgehd2		 CGEHD2	   
#define cgehrd		 CGEHRD	   
#define cgelq2		 CGELQ2	   
#define cgelqf		 CGELQF	   
#define cgels		 CGELS	   
#define cgelsd		 CGELSD	   
#define cgelss		 CGELSS	   
#define cgelsx		 CGELSX	   
#define cgelsy		 CGELSY	   
#define cgeql2		 CGEQL2	   
#define cgeqlf		 CGEQLF	   
#define cgeqp3		 CGEQP3	   
#define cgeqpf		 CGEQPF	   
#define cgeqr2		 CGEQR2	   
#define cgeqrf		 CGEQRF	   
#define cgerfs		 CGERFS	   
#define cgerq2		 CGERQ2	   
#define cgerqf		 CGERQF	   
#define cgesc2		 CGESC2	   
#define cgesdd		 CGESDD	   
#define cgesv		 CGESV	   
#define cgesvd		 CGESVD	   
#define cgesvx		 CGESVX	   
#define cgetc2		 CGETC2	   
#define cgetf2		 CGETF2	   
#define cgetrf		 CGETRF	   
#define cgetri		 CGETRI	   
#define cgetrs		 CGETRS	   
#define cggbak		 CGGBAK	   
#define cggbal		 CGGBAL	   
#define cgges		 CGGES	   
#define cggesx		 CGGESX	   
#define cggev		 CGGEV	   
#define cggevx		 CGGEVX	   
#define cggglm		 CGGGLM	   
#define cgghrd		 CGGHRD	   
#define cgglse		 CGGLSE	   
#define cggqrf		 CGGQRF	   
#define cggrqf		 CGGRQF	   
#define cggsvd		 CGGSVD	   
#define cggsvp		 CGGSVP	   
#define cgtcon		 CGTCON	   
#define cgtrfs		 CGTRFS	   
#define cgtsv		 CGTSV	   
#define cgtsvx		 CGTSVX	   
#define cgttrf		 CGTTRF	   
#define cgttrs		 CGTTRS	   
#define cgtts2		 CGTTS2	   
#define chbev		 CHBEV	   
#define chbevd		 CHBEVD	   
#define chbevx		 CHBEVX	   
#define chbgst		 CHBGST	   
#define chbgv		 CHBGV	   
#define chbgvd		 CHBGVD	   
#define chbgvx		 CHBGVX	   
#define chbtrd		 CHBTRD	   
#define checon		 CHECON	   
#define cheev		 CHEEV	   
#define cheevd		 CHEEVD	   
#define cheevr		 CHEEVR	   
#define cheevx		 CHEEVX	   
#define chegs2		 CHEGS2	   
#define chegst		 CHEGST	   
#define chegv		 CHEGV	   
#define chegvd		 CHEGVD	   
#define chegvx		 CHEGVX	   
#define cherfs		 CHERFS	   
#define chesv		 CHESV	   
#define chesvx		 CHESVX	   
#define chetd2		 CHETD2	   
#define chetf2		 CHETF2	   
#define chetrd		 CHETRD	   
#define chetrf		 CHETRF	   
#define chetri		 CHETRI	   
#define chetrs		 CHETRS	   
#define chgeqz		 CHGEQZ	   
#define chpcon		 CHPCON	   
#define chpev		 CHPEV	   
#define chpevd		 CHPEVD	   
#define chpevx		 CHPEVX	   
#define chpgst		 CHPGST	   
#define chpgv		 CHPGV	   
#define chpgvd		 CHPGVD	   
#define chpgvx		 CHPGVX	   
#define chprfs		 CHPRFS	   
#define chpsv		 CHPSV	   
#define chpsvx		 CHPSVX	   
#define chptrd		 CHPTRD	   
#define chptrf		 CHPTRF	   
#define chptri		 CHPTRI	   
#define chptrs		 CHPTRS	   
#define chsein		 CHSEIN	   
#define chseqr		 CHSEQR	   
#define clabrd		 CLABRD	   
#define clacgv		 CLACGV	   
#define clacon		 CLACON	   
#define clacp2		 CLACP2	   
#define clacpy		 CLACPY	   
#define clacrm		 CLACRM	   
#define clacrt		 CLACRT	   
#define cladiv		 CLADIV	   
#define claed0		 CLAED0	   
#define claed7		 CLAED7	   
#define claed8		 CLAED8	   
#define claein		 CLAEIN	   
#define claesy		 CLAESY	   
#define claev2		 CLAEV2	   
#define clags2		 CLAGS2	   
#define clagtm		 CLAGTM	   
#define clahef		 CLAHEF	   
#define clahqr		 CLAHQR	   
#define clahrd		 CLAHRD	   
#define claic1		 CLAIC1	   
#define clals0		 CLALS0	   
#define clalsa		 CLALSA	   
#define clalsd		 CLALSD	   
#define clangb		 CLANGB	   
#define clange		 CLANGE	   
#define clangt		 CLANGT	   
#define clanhb		 CLANHB	   
#define clanhe		 CLANHE	   
#define clanhp		 CLANHP	   
#define clanhs		 CLANHS	   
#define clanht		 CLANHT	   
#define clansb		 CLANSB	   
#define clansp		 CLANSP	   
#define clansy		 CLANSY	   
#define clantb		 CLANTB	   
#define clantp		 CLANTP	   
#define clantr		 CLANTR	   
#define clapll		 CLAPLL	   
#define clapmt		 CLAPMT	   
#define claqgb		 CLAQGB	   
#define claqge		 CLAQGE	   
#define claqhb		 CLAQHB	   
#define claqhe		 CLAQHE	   
#define claqhp		 CLAQHP	   
#define claqp2		 CLAQP2	   
#define claqps		 CLAQPS	   
#define claqsb		 CLAQSB	   
#define claqsp		 CLAQSP	   
#define claqsy		 CLAQSY	   
#define clar1v		 CLAR1V	   
#define clar2v		 CLAR2V	   
#define clarcm		 CLARCM	   
#define clarf		 CLARF	   
#define clarfb		 CLARFB	   
#define clarfg		 CLARFG	   
#define clarft		 CLARFT	   
#define clarfx		 CLARFX	   
#define clargv		 CLARGV	   
#define clarnv		 CLARNV	   
#define clarrv		 CLARRV	   
#define clartg		 CLARTG	   
#define clartv		 CLARTV	   
#define clarz		 CLARZ	   
#define clarzb		 CLARZB	   
#define clarzt		 CLARZT	   
#define clascl		 CLASCL	   
#define claset		 CLASET	   
#define clasr		 CLASR	   
#define classq		 CLASSQ	   
#define claswp		 CLASWP	   
#define clasyf		 CLASYF	   
#define clatbs		 CLATBS	   
#define clatdf		 CLATDF	   
#define clatps		 CLATPS	   
#define clatrd		 CLATRD	   
#define clatrs		 CLATRS	   
#define clatrz		 CLATRZ	   
#define clatzm		 CLATZM	   
#define clauu2		 CLAUU2	   
#define clauum		 CLAUUM	   
#define cpbcon		 CPBCON	   
#define cpbequ		 CPBEQU	   
#define cpbrfs		 CPBRFS	   
#define cpbstf		 CPBSTF	   
#define cpbsv		 CPBSV	   
#define cpbsvx		 CPBSVX	   
#define cpbtf2		 CPBTF2	   
#define cpbtrf		 CPBTRF	   
#define cpbtrs		 CPBTRS	   
#define cpocon		 CPOCON	   
#define cpoequ		 CPOEQU	   
#define cporfs		 CPORFS	   
#define cposv		 CPOSV	   
#define cposvx		 CPOSVX	   
#define cpotf2		 CPOTF2	   
#define cpotrf		 CPOTRF	   
#define cpotri		 CPOTRI	   
#define cpotrs		 CPOTRS	   
#define cppcon		 CPPCON	   
#define cppequ		 CPPEQU	   
#define cpprfs		 CPPRFS	   
#define cppsv		 CPPSV	   
#define cppsvx		 CPPSVX	   
#define cpptrf		 CPPTRF	   
#define cpptri		 CPPTRI	   
#define cpptrs		 CPPTRS	   
#define cptcon		 CPTCON	   
#define cpteqr		 CPTEQR	   
#define cptrfs		 CPTRFS	   
#define cptsv		 CPTSV	   
#define cptsvx		 CPTSVX	   
#define cpttrf		 CPTTRF	   
#define cpttrs		 CPTTRS	   
#define cptts2		 CPTTS2	   
#define crotn		 CROTN	   
#define cspcon		 CSPCON	   
#define cspmv		 CSPMV	   
#define cspru		 CSPRU	   
#define csprfs		 CSPRFS	   
#define cspsv		 CSPSV	   
#define cspsvx		 CSPSVX	   
#define csptrf		 CSPTRF	   
#define csptri		 CSPTRI	   
#define csptrs		 CSPTRS	   
#define csrot		 CSROT	   
#define csrscl		 CSRSCL	   
#define cstedc		 CSTEDC	   
#define cstegr		 CSTEGR	   
#define cstein		 CSTEIN	   
#define csteqr		 CSTEQR	   
#define csycon		 CSYCON	   
#define csymv		 CSYMV	   
#define csyru		 CSYRU	   
#define csyrfs		 CSYRFS	   
#define csysv		 CSYSV	   
#define csysvx		 CSYSVX	   
#define csytf2		 CSYTF2	   
#define csytrf		 CSYTRF	   
#define csytri		 CSYTRI	   
#define csytrs		 CSYTRS	   
#define ctbcon		 CTBCON	   
#define ctbrfs		 CTBRFS	   
#define ctbtrs		 CTBTRS	   
#define ctgevc		 CTGEVC	   
#define ctgex2		 CTGEX2	   
#define ctgexc		 CTGEXC	   
#define ctgsen		 CTGSEN	   
#define ctgsja		 CTGSJA	   
#define ctgsna		 CTGSNA	   
#define ctgsy2		 CTGSY2	   
#define ctgsyl		 CTGSYL	   
#define ctpcon		 CTPCON	   
#define ctprfs		 CTPRFS	   
#define ctptri		 CTPTRI	   
#define ctptrs		 CTPTRS	   
#define ctrcon		 CTRCON	   
#define ctrevc		 CTREVC	   
#define ctrexc		 CTREXC	   
#define ctrrfs		 CTRRFS	   
#define ctrsen		 CTRSEN	   
#define ctrsna		 CTRSNA	   
#define ctrsyl		 CTRSYL	   
#define ctrti2		 CTRTI2	   
#define ctrtri		 CTRTRI	   
#define ctrtrs		 CTRTRS	   
#define ctzrqf		 CTZRQF	   
#define ctzrzf		 CTZRZF	   
#define cung2l		 CUNG2L	   
#define cung2r		 CUNG2R	   
#define cungbr		 CUNGBR	   
#define cunghr		 CUNGHR	   
#define cungl2		 CUNGL2	   
#define cunglq		 CUNGLQ	   
#define cungql		 CUNGQL	   
#define cungqr		 CUNGQR	   
#define cungr2		 CUNGR2	   
#define cungrq		 CUNGRQ	   
#define cungtr		 CUNGTR	   
#define cunm2l		 CUNM2L	   
#define cunm2r		 CUNM2R	   
#define cunmbr		 CUNMBR	   
#define cunmhr		 CUNMHR	   
#define cunml2		 CUNML2	   
#define cunmlq		 CUNMLQ	   
#define cunmql		 CUNMQL	   
#define cunmqr		 CUNMQR	   
#define cunmr2		 CUNMR2	   
#define cunmr3		 CUNMR3	   
#define cunmrq		 CUNMRQ	   
#define cunmrz		 CUNMRZ	   
#define cunmtr		 CUNMTR	   
#define cupgtr		 CUPGTR	   
#define cupmtr		 CUPMTR	   
#define dbdsdc		 DBDSDC	   
#define dbdsqr		 DBDSQR	   
#define ddisna		 DDISNA	   
#define dgbbrd		 DGBBRD	   
#define dgbcon		 DGBCON	   
#define dgbequ		 DGBEQU	   
#define dgbrfs		 DGBRFS	   
#define dgbsv		 DGBSV	   
#define dgbsvx		 DGBSVX	   
#define dgbtf2		 DGBTF2	   
#define dgbtrf		 DGBTRF	   
#define dgbtrs		 DGBTRS	   
#define dgebak		 DGEBAK	   
#define dgebal		 DGEBAL	   
#define dgebd2		 DGEBD2	   
#define dgebrd		 DGEBRD	   
#define dgecon		 DGECON	   
#define dgeequ		 DGEEQU	   
#define dgees		 DGEES	   
#define dgeesx		 DGEESX	   
#define dgeev		 DGEEV	   
#define dgeevx		 DGEEVX	   
#define dgegs		 DGEGS	   
#define dgegv		 DGEGV	   
#define dgehd2		 DGEHD2	   
#define dgehrd		 DGEHRD	   
#define dgelq2		 DGELQ2	   
#define dgelqf		 DGELQF	   
#define dgels		 DGELS	   
#define dgelsd		 DGELSD	   
#define dgelss		 DGELSS	   
#define dgelsx		 DGELSX	   
#define dgelsy		 DGELSY	   
#define dgeql2		 DGEQL2	   
#define dgeqlf		 DGEQLF	   
#define dgeqp3		 DGEQP3	   
#define dgeqpf		 DGEQPF	   
#define dgeqr2		 DGEQR2	   
#define dgeqrf		 DGEQRF	   
#define dgerfs		 DGERFS	   
#define dgerq2		 DGERQ2	   
#define dgerqf		 DGERQF	   
#define dgesc2		 DGESC2	   
#define dgesdd		 DGESDD	   
#define dgesv		 DGESV	   
#define dgesvd		 DGESVD	   
#define dgesvx		 DGESVX	   
#define dgetc2		 DGETC2	   
#define dgetf2		 DGETF2	   
#define dgetrf		 DGETRF	   
#define dgetri		 DGETRI	   
#define dgetrs		 DGETRS	   
#define dggbak		 DGGBAK	   
#define dggbal		 DGGBAL	   
#define dgges		 DGGES	   
#define dggesx		 DGGESX	   
#define dggev		 DGGEV	   
#define dggevx		 DGGEVX	   
#define dggglm		 DGGGLM	   
#define dgghrd		 DGGHRD	   
#define dgglse		 DGGLSE	   
#define dggqrf		 DGGQRF	   
#define dggrqf		 DGGRQF	   
#define dggsvd		 DGGSVD	   
#define dggsvp		 DGGSVP	   
#define dgtcon		 DGTCON	   
#define dgtrfs		 DGTRFS	   
#define dgtsv		 DGTSV	   
#define dgtsvx		 DGTSVX	   
#define dgttrf		 DGTTRF	   
#define dgttrs		 DGTTRS	   
#define dgtts2		 DGTTS2	   
#define dhgeqz		 DHGEQZ	   
#define dhsein		 DHSEIN	   
#define dhseqr		 DHSEQR	   
#define dlabad		 DLABAD	   
#define dlabrd		 DLABRD	   
#define dlacon		 DLACON	   
#define dlacpy		 DLACPY	   
#define dladiv		 DLADIV	   
#define dlae2a		 DLAE2A	   
#define dlaebz		 DLAEBZ	   
#define dlaed0		 DLAED0	   
#define dlaed1		 DLAED1	   
#define dlaed2		 DLAED2	   
#define dlaed3		 DLAED3	   
#define dlaed4		 DLAED4	   
#define dlaed5		 DLAED5	   
#define dlaed6		 DLAED6	   
#define dlaed7		 DLAED7	   
#define dlaed8		 DLAED8	   
#define dlaed9		 DLAED9	   
#define dlaeda		 DLAEDA	   
#define dlaein		 DLAEIN	   
#define dlaev2		 DLAEV2	   
#define dlaexc		 DLAEXC	   
#define dlag2a		 DLAG2A	   
#define dlags2		 DLAGS2	   
#define dlagtf		 DLAGTF	   
#define dlagtm		 DLAGTM	   
#define dlagts		 DLAGTS	   
#define dlagv2		 DLAGV2	   
#define dlahqr		 DLAHQR	   
#define dlahrd		 DLAHRD	   
#define dlaic1		 DLAIC1	   
#define dlaln2		 DLALN2	   
#define dlals0		 DLALS0	   
#define dlalsa		 DLALSA	   
#define dlalsd		 DLALSD	   
#define dlamch		 DLAMCH	   
#define dlamc1		 DLAMC1	   
#define dlamc2		 DLAMC2	   
#define dlamc3		 DLAMC3	   
#define dlamc4		 DLAMC4	   
#define dlamc5		 DLAMC5	   
#define dlamrg		 DLAMRG	   
#define dlangb		 DLANGB	   
#define dlange		 DLANGE	   
#define dlangt		 DLANGT	   
#define dlanhs		 DLANHS	   
#define dlansb		 DLANSB	   
#define dlansp		 DLANSP	   
#define dlanst		 DLANST	   
#define dlansy		 DLANSY	   
#define dlantb		 DLANTB	   
#define dlantp		 DLANTP	   
#define dlantr		 DLANTR	   
#define dlanv2		 DLANV2	   
#define dlapll		 DLAPLL	   
#define dlapmt		 DLAPMT	   
#define dlapy2		 DLAPY2	   
#define dlapy3		 DLAPY3	   
#define dlaqgb		 DLAQGB	   
#define dlaqge		 DLAQGE	   
#define dlaqp2		 DLAQP2	   
#define dlaqps		 DLAQPS	   
#define dlaqsb		 DLAQSB	   
#define dlaqsp		 DLAQSP	   
#define dlaqsy		 DLAQSY	   
#define dlaqtr		 DLAQTR	   
#define dlar1v		 DLAR1V	   
#define dlar2v		 DLAR2V	   
#define dlarf		 DLARF	   
#define dlarfb		 DLARFB	   
#define dlarfg		 DLARFG	   
#define dlarft		 DLARFT	   
#define dlarfx		 DLARFX	   
#define dlargv		 DLARGV	   
#define dlarnv		 DLARNV	   
#define dlarrb		 DLARRB	   
#define dlarre		 DLARRE	   
#define dlarrf		 DLARRF	   
#define dlarrv		 DLARRV	   
#define dlartg		 DLARTG	   
#define dlartv		 DLARTV	   
#define dlaruv		 DLARUV	   
#define dlarz		 DLARZ	   
#define dlarzb		 DLARZB	   
#define dlarzt		 DLARZT	   
#define dlas2f		 DLAS2F	   
#define dlascl		 DLASCL	   
#define dlasd0		 DLASD0	   
#define dlasd1		 DLASD1	   
#define dlasd2		 DLASD2	   
#define dlasd3		 DLASD3	   
#define dlasd4		 DLASD4	   
#define dlasd5		 DLASD5	   
#define dlasd6		 DLASD6	   
#define dlasd7		 DLASD7	   
#define dlasd8		 DLASD8	   
#define dlasd9		 DLASD9	   
#define dlasda		 DLASDA	   
#define dlasdq		 DLASDQ	   
#define dlasdt		 DLASDT	   
#define dlaset		 DLASET	   
#define dlasq1		 DLASQ1	   
#define dlasq2		 DLASQ2	   
#define dlasq3		 DLASQ3	   
#define dlasq4		 DLASQ4	   
#define dlasq5		 DLASQ5	   
#define dlasq6		 DLASQ6	   
#define dlasr		 DLASR	   
#define dlasrt		 DLASRT	   
#define dlassq		 DLASSQ	   
#define dlasv2		 DLASV2	   
#define dlaswp		 DLASWP	   
#define dlasy2		 DLASY2	   
#define dlasyf		 DLASYF	   
#define dlatbs		 DLATBS	   
#define dlatdf		 DLATDF	   
#define dlatps		 DLATPS	   
#define dlatrd		 DLATRD	   
#define dlatrs		 DLATRS	   
#define dlatrz		 DLATRZ	   
#define dlatzm		 DLATZM	   
#define dlauu2		 DLAUU2	   
#define dlauum		 DLAUUM	   
#define dopgtr		 DOPGTR	   
#define dopmtr		 DOPMTR	   
#define dorg2l		 DORG2L	   
#define dorg2r		 DORG2R	   
#define dorgbr		 DORGBR	   
#define dorghr		 DORGHR	   
#define dorgl2		 DORGL2	   
#define dorglq		 DORGLQ	   
#define dorgql		 DORGQL	   
#define dorgqr		 DORGQR	   
#define dorgr2		 DORGR2	   
#define dorgrq		 DORGRQ	   
#define dorgtr		 DORGTR	   
#define dorm2l		 DORM2L	   
#define dorm2r		 DORM2R	   
#define dormbr		 DORMBR	   
#define dormhr		 DORMHR	   
#define dorml2		 DORML2	   
#define dormlq		 DORMLQ	   
#define dormql		 DORMQL	   
#define dormqr		 DORMQR	   
#define dormr2		 DORMR2	   
#define dormr3		 DORMR3	   
#define dormrq		 DORMRQ	   
#define dormrz		 DORMRZ	   
#define dormtr		 DORMTR	   
#define dpbcon		 DPBCON	   
#define dpbequ		 DPBEQU	   
#define dpbrfs		 DPBRFS	   
#define dpbstf		 DPBSTF	   
#define dpbsv		 DPBSV	   
#define dpbsvx		 DPBSVX	   
#define dpbtf2		 DPBTF2	   
#define dpbtrf		 DPBTRF	   
#define dpbtrs		 DPBTRS	   
#define dpocon		 DPOCON	   
#define dpoequ		 DPOEQU	   
#define dporfs		 DPORFS	   
#define dposv		 DPOSV	   
#define dposvx		 DPOSVX	   
#define dpotf2		 DPOTF2	   
#define dpotrf		 DPOTRF	   
#define dpotri		 DPOTRI	   
#define dpotrs		 DPOTRS	   
#define dppcon		 DPPCON	   
#define dppequ		 DPPEQU	   
#define dpprfs		 DPPRFS	   
#define dppsv		 DPPSV	   
#define dppsvx		 DPPSVX	   
#define dpptrf		 DPPTRF	   
#define dpptri		 DPPTRI	   
#define dpptrs		 DPPTRS	   
#define dptcon		 DPTCON	   
#define dpteqr		 DPTEQR	   
#define dptrfs		 DPTRFS	   
#define dptsv		 DPTSV	   
#define dptsvx		 DPTSVX	   
#define dpttrf		 DPTTRF	   
#define dpttrs		 DPTTRS	   
#define dptts2		 DPTTS2	   
#define drscl		 DRSCL	   
#define dsbev		 DSBEV	   
#define dsbevd		 DSBEVD	   
#define dsbevx		 DSBEVX	   
#define dsbgst		 DSBGST	   
#define dsbgv		 DSBGV	   
#define dsbgvd		 DSBGVD	   
#define dsbgvx		 DSBGVX	   
#define dsbtrd		 DSBTRD	   
#define dsecnd		 DSECND	   
#define dspcon		 DSPCON	   
#define dspev		 DSPEV	   
#define dspevd		 DSPEVD	   
#define dspevx		 DSPEVX	   
#define dspgst		 DSPGST	   
#define dspgv		 DSPGV	   
#define dspgvd		 DSPGVD	   
#define dspgvx		 DSPGVX	   
#define dsprfs		 DSPRFS	   
#define dspsv		 DSPSV	   
#define dspsvx		 DSPSVX	   
#define dsptrd		 DSPTRD	   
#define dsptrf		 DSPTRF	   
#define dsptri		 DSPTRI	   
#define dsptrs		 DSPTRS	   
#define dstebz		 DSTEBZ	   
#define dstedc		 DSTEDC	   
#define dstegr		 DSTEGR	   
#define dstein		 DSTEIN	   
#define dsteqr		 DSTEQR	   
#define dsterf		 DSTERF	   
#define dstev		 DSTEV	   
#define dstevd		 DSTEVD	   
#define dstevr		 DSTEVR	   
#define dstevx		 DSTEVX	   
#define dsycon		 DSYCON	   
#define dsyev		 DSYEV	   
#define dsyevd		 DSYEVD	   
#define dsyevr		 DSYEVR	   
#define dsyevx		 DSYEVX	   
#define dsygs2		 DSYGS2	   
#define dsygst		 DSYGST	   
#define dsygv		 DSYGV	   
#define dsygvd		 DSYGVD	   
#define dsygvx		 DSYGVX	   
#define dsyrfs		 DSYRFS	   
#define dsysv		 DSYSV	   
#define dsysvx		 DSYSVX	   
#define dsytd2		 DSYTD2	   
#define dsytf2		 DSYTF2	   
#define dsytrd		 DSYTRD	   
#define dsytrf		 DSYTRF	   
#define dsytri		 DSYTRI	   
#define dsytrs		 DSYTRS	   
#define dtbcon		 DTBCON	   
#define dtbrfs		 DTBRFS	   
#define dtbtrs		 DTBTRS	   
#define dtgevc		 DTGEVC	   
#define dtgex2		 DTGEX2	   
#define dtgexc		 DTGEXC	   
#define dtgsen		 DTGSEN	   
#define dtgsja		 DTGSJA	   
#define dtgsna		 DTGSNA	   
#define dtgsy2		 DTGSY2	   
#define dtgsyl		 DTGSYL	   
#define dtpcon		 DTPCON	   
#define dtprfs		 DTPRFS	   
#define dtptri		 DTPTRI	   
#define dtptrs		 DTPTRS	   
#define dtrcon		 DTRCON	   
#define dtrevc		 DTREVC	   
#define dtrexc		 DTREXC	   
#define dtrrfs		 DTRRFS	   
#define dtrsen		 DTRSEN	   
#define dtrsna		 DTRSNA	   
#define dtrsyl		 DTRSYL	   
#define dtrti2		 DTRTI2	   
#define dtrtri		 DTRTRI	   
#define dtrtrs		 DTRTRS	   
#define dtzrqf		 DTZRQF	   
#define dtzrzf		 DTZRZF	   
#define dzsum1		 DZSUM1	   
#define icmax1		 ICMAX1	   
#define ieeeck		 IEEECK	   
#define ilaenv		 ILAENV	   
#define izmax1		 IZMAX1	   
#define lsamech		 LSAMECH	   
#define lsamen		 LSAMEN	   
#define sbdsdc		 SBDSDC	   
#define sbdsqr		 SBDSQR	   
#define scsum1		 SCSUM1	   
#define sdisna		 SDISNA	   
#define secondv		 SECONDV	   
#define sgbbrd		 SGBBRD	   
#define sgbcon		 SGBCON	   
#define sgbequ		 SGBEQU	   
#define sgbrfs		 SGBRFS	   
#define sgbsv		 SGBSV	   
#define sgbsvx		 SGBSVX	   
#define sgbtf2		 SGBTF2	   
#define sgbtrf		 SGBTRF	   
#define sgbtrs		 SGBTRS	   
#define sgebak		 SGEBAK	   
#define sgebal		 SGEBAL	   
#define sgebd2		 SGEBD2	   
#define sgebrd		 SGEBRD	   
#define sgecon		 SGECON	   
#define sgeequ		 SGEEQU	   
#define sgees		 SGEES	   
#define sgeesx		 SGEESX	   
#define sgeev		 SGEEV	   
#define sgeevx		 SGEEVX	   
#define sgegs		 SGEGS	   
#define sgegv		 SGEGV	   
#define sgehd2		 SGEHD2	   
#define sgehrd		 SGEHRD	   
#define sgelq2		 SGELQ2	   
#define sgelqf		 SGELQF	   
#define sgels		 SGELS	   
#define sgelsd		 SGELSD	   
#define sgelss		 SGELSS	   
#define sgelsx		 SGELSX	   
#define sgelsy		 SGELSY	   
#define sgeql2		 SGEQL2	   
#define sgeqlf		 SGEQLF	   
#define sgeqp3		 SGEQP3	   
#define sgeqpf		 SGEQPF	   
#define sgeqr2		 SGEQR2	   
#define sgeqrf		 SGEQRF	   
#define sgerfs		 SGERFS	   
#define sgerq2		 SGERQ2	   
#define sgerqf		 SGERQF	   
#define sgesc2		 SGESC2	   
#define sgesdd		 SGESDD	   
#define sgesv		 SGESV	   
#define sgesvd		 SGESVD	   
#define sgesvx		 SGESVX	   
#define sgetc2		 SGETC2	   
#define sgetf2		 SGETF2	   
#define sgetrf		 SGETRF	   
#define sgetri		 SGETRI	   
#define sgetrs		 SGETRS	   
#define sggbak		 SGGBAK	   
#define sggbal		 SGGBAL	   
#define sgges		 SGGES	   
#define sggesx		 SGGESX	   
#define sggev		 SGGEV	   
#define sggevx		 SGGEVX	   
#define sggglm		 SGGGLM	   
#define sgghrd		 SGGHRD	   
#define sgglse		 SGGLSE	   
#define sggqrf		 SGGQRF	   
#define sggrqf		 SGGRQF	   
#define sggsvd		 SGGSVD	   
#define sggsvp		 SGGSVP	   
#define sgtcon		 SGTCON	   
#define sgtrfs		 SGTRFS	   
#define sgtsv		 SGTSV	   
#define sgtsvx		 SGTSVX	   
#define sgttrf		 SGTTRF	   
#define sgttrs		 SGTTRS	   
#define sgtts2		 SGTTS2	   
#define shgeqz		 SHGEQZ	   
#define shsein		 SHSEIN	   
#define shseqr		 SHSEQR	   
#define slabadr		 SLABADR	   
#define slabrd		 SLABRD	   
#define slacon		 SLACON	   
#define slacpy		 SLACPY	   
#define sladivr		 SLADIVR	   
#define slae2re		 SLAE2RE	   
#define slaebz		 SLAEBZ	   
#define slaed0		 SLAED0	   
#define slaed1		 SLAED1	   
#define slaed2		 SLAED2	   
#define slaed3		 SLAED3	   
#define slaed4		 SLAED4	   
#define slaed5		 SLAED5	   
#define slaed6		 SLAED6	   
#define slaed7		 SLAED7	   
#define slaed8		 SLAED8	   
#define slaed9		 SLAED9	   
#define slaeda		 SLAEDA	   
#define slaein		 SLAEIN	   
#define slaev2r		 SLAEV2R	   
#define slaexc		 SLAEXC	   
#define slag2re		 SLAG2RE	   
#define slags2		 SLAGS2	   
#define slagtf		 SLAGTF	   
#define slagtm		 SLAGTM	   
#define slagts		 SLAGTS	   
#define slagv2r		 SLAGV2R	   
#define slahqr		 SLAHQR	   
#define slahrd		 SLAHRD	   
#define slaic1		 SLAIC1	   
#define slaln2		 SLALN2	   
#define slals0		 SLALS0	   
#define slalsa		 SLALSA	   
#define slalsd		 SLALSD	   
#define slamch		 SLAMCH	   
#define slamc1		 SLAMC1	   
#define slamc2		 SLAMC2	   
#define slamc3r		 SLAMC3R	   
#define slamc4		 SLAMC4	   
#define slamc5		 SLAMC5	   
#define slamrg		 SLAMRG	   
#define slangb		 SLANGB	   
#define slange		 SLANGE	   
#define slangt		 SLANGT	   
#define slanhs		 SLANHS	   
#define slansb		 SLANSB	   
#define slansp		 SLANSP	   
#define slanst		 SLANST	   
#define slansy		 SLANSY	   
#define slantb		 SLANTB	   
#define slantp		 SLANTP	   
#define slantr		 SLANTR	   
#define slanv2r		 SLANV2R	   
#define slapll		 SLAPLL	   
#define slapmt		 SLAPMT	   
#define slapy2r		 SLAPY2R	   
#define slapy3r		 SLAPY3R	   
#define slaqgb		 SLAQGB	   
#define slaqge		 SLAQGE	   
#define slaqp2		 SLAQP2	   
#define slaqps		 SLAQPS	   
#define slaqsb		 SLAQSB	   
#define slaqsp		 SLAQSP	   
#define slaqsy		 SLAQSY	   
#define slaqtr		 SLAQTR	   
#define slar1v		 SLAR1V	   
#define slar2v		 SLAR2V	   
#define slarf		 SLARF	   
#define slarfb		 SLARFB	   
#define slarfg		 SLARFG	   
#define slarft		 SLARFT	   
#define slarfx		 SLARFX	   
#define slargv		 SLARGV	   
#define slarnv		 SLARNV	   
#define slarrb		 SLARRB	   
#define slarre		 SLARRE	   
#define slarrf		 SLARRF	   
#define slarrv		 SLARRV	   
#define slartgr		 SLARTGR	   
#define slartv		 SLARTV	   
#define slaruv		 SLARUV	   
#define slarz		 SLARZ	   
#define slarzb		 SLARZB	   
#define slarzt		 SLARZT	   
#define slas2re		 SLAS2RE	   
#define slascl		 SLASCL	   
#define slasd0		 SLASD0	   
#define slasd1		 SLASD1	   
#define slasd2		 SLASD2	   
#define slasd3		 SLASD3	   
#define slasd4		 SLASD4	   
#define slasd5		 SLASD5	   
#define slasd6		 SLASD6	   
#define slasd7		 SLASD7	   
#define slasd8		 SLASD8	   
#define slasd9		 SLASD9	   
#define slasda		 SLASDA	   
#define slasdq		 SLASDQ	   
#define slasdt		 SLASDT	   
#define slaset		 SLASET	   
#define slasq1		 SLASQ1	   
#define slasq2		 SLASQ2	   
#define slasq3		 SLASQ3	   
#define slasq4		 SLASQ4	   
#define slasq5		 SLASQ5	   
#define slasq6		 SLASQ6	   
#define slasr		 SLASR	   
#define slasrt		 SLASRT	   
#define slassq		 SLASSQ	   
#define slasv2r		 SLASV2R	   
#define slaswp		 SLASWP	   
#define slasy2		 SLASY2	   
#define slasyf		 SLASYF	   
#define slatbs		 SLATBS	   
#define slatdf		 SLATDF	   
#define slatps		 SLATPS	   
#define slatrd		 SLATRD	   
#define slatrs		 SLATRS	   
#define slatrz		 SLATRZ	   
#define slatzm		 SLATZM	   
#define slauu2		 SLAUU2	   
#define slauum		 SLAUUM	   
#define sopgtr		 SOPGTR	   
#define sopmtr		 SOPMTR	   
#define sorg2l		 SORG2L	   
#define sorg2r		 SORG2R	   
#define sorgbr		 SORGBR	   
#define sorghr		 SORGHR	   
#define sorgl2		 SORGL2	   
#define sorglq		 SORGLQ	   
#define sorgql		 SORGQL	   
#define sorgqr		 SORGQR	   
#define sorgr2		 SORGR2	   
#define sorgrq		 SORGRQ	   
#define sorgtr		 SORGTR	   
#define sorm2l		 SORM2L	   
#define sorm2r		 SORM2R	   
#define sormbr		 SORMBR	   
#define sormhr		 SORMHR	   
#define sorml2		 SORML2	   
#define sormlq		 SORMLQ	   
#define sormql		 SORMQL	   
#define sormqr		 SORMQR	   
#define sormr2		 SORMR2	   
#define sormr3		 SORMR3	   
#define sormrq		 SORMRQ	   
#define sormrz		 SORMRZ	   
#define sormtr		 SORMTR	   
#define spbcon		 SPBCON	   
#define spbequ		 SPBEQU	   
#define spbrfs		 SPBRFS	   
#define spbstf		 SPBSTF	   
#define spbsv		 SPBSV	   
#define spbsvx		 SPBSVX	   
#define spbtf2		 SPBTF2	   
#define spbtrf		 SPBTRF	   
#define spbtrs		 SPBTRS	   
#define spocon		 SPOCON	   
#define spoequ		 SPOEQU	   
#define sporfs		 SPORFS	   
#define sposv		 SPOSV	   
#define sposvx		 SPOSVX	   
#define spotf2		 SPOTF2	   
#define spotrf		 SPOTRF	   
#define spotri		 SPOTRI	   
#define spotrs		 SPOTRS	   
#define sppcon		 SPPCON	   
#define sppequ		 SPPEQU	   
#define spprfs		 SPPRFS	   
#define sppsv		 SPPSV	   
#define sppsvx		 SPPSVX	   
#define spptrf		 SPPTRF	   
#define spptri		 SPPTRI	   
#define spptrs		 SPPTRS	   
#define sptcon		 SPTCON	   
#define spteqr		 SPTEQR	   
#define sptrfs		 SPTRFS	   
#define sptsv		 SPTSV	   
#define sptsvx		 SPTSVX	   
#define spttrf		 SPTTRF	   
#define spttrs		 SPTTRS	   
#define sptts2		 SPTTS2	   
#define srscl		 SRSCL	   
#define ssbev		 SSBEV	   
#define ssbevd		 SSBEVD	   
#define ssbevx		 SSBEVX	   
#define ssbgst		 SSBGST	   
#define ssbgv		 SSBGV	   
#define ssbgvd		 SSBGVD	   
#define ssbgvx		 SSBGVX	   
#define ssbtrd		 SSBTRD	   
#define sspcon		 SSPCON	   
#define sspev		 SSPEV	   
#define sspevd		 SSPEVD	   
#define sspevx		 SSPEVX	   
#define sspgst		 SSPGST	   
#define sspgv		 SSPGV	   
#define sspgvd		 SSPGVD	   
#define sspgvx		 SSPGVX	   
#define ssprfs		 SSPRFS	   
#define sspsv		 SSPSV	   
#define sspsvx		 SSPSVX	   
#define ssptrd		 SSPTRD	   
#define ssptrf		 SSPTRF	   
#define ssptri		 SSPTRI	   
#define ssptrs		 SSPTRS	   
#define sstebz		 SSTEBZ	   
#define sstedc		 SSTEDC	   
#define sstegr		 SSTEGR	   
#define sstein		 SSTEIN	   
#define ssteqr		 SSTEQR	   
#define ssterf		 SSTERF	   
#define sstev		 SSTEV	   
#define sstevd		 SSTEVD	   
#define sstevr		 SSTEVR	   
#define sstevx		 SSTEVX	   
#define ssycon		 SSYCON	   
#define ssyev		 SSYEV	   
#define ssyevd		 SSYEVD	   
#define ssyevr		 SSYEVR	   
#define ssyevx		 SSYEVX	   
#define ssygs2		 SSYGS2	   
#define ssygst		 SSYGST	   
#define ssygv		 SSYGV	   
#define ssygvd		 SSYGVD	   
#define ssygvx		 SSYGVX	   
#define ssyrfs		 SSYRFS	   
#define ssysv		 SSYSV	   
#define ssysvx		 SSYSVX	   
#define ssytd2		 SSYTD2	   
#define ssytf2		 SSYTF2	   
#define ssytrd		 SSYTRD	   
#define ssytrf		 SSYTRF	   
#define ssytri		 SSYTRI	   
#define ssytrs		 SSYTRS	   
#define stbcon		 STBCON	   
#define stbrfs		 STBRFS	   
#define stbtrs		 STBTRS	   
#define stgevc		 STGEVC	   
#define stgex2		 STGEX2	   
#define stgexc		 STGEXC	   
#define stgsen		 STGSEN	   
#define stgsja		 STGSJA	   
#define stgsna		 STGSNA	   
#define stgsy2		 STGSY2	   
#define stgsyl		 STGSYL	   
#define stpcon		 STPCON	   
#define stprfs		 STPRFS	   
#define stptri		 STPTRI	   
#define stptrs		 STPTRS	   
#define strcon		 STRCON	   
#define strevc		 STREVC	   
#define strexc		 STREXC	   
#define strrfs		 STRRFS	   
#define strsen		 STRSEN	   
#define strsna		 STRSNA	   
#define strsyl		 STRSYL	   
#define strti2		 STRTI2	   
#define strtri		 STRTRI	   
#define strtrs		 STRTRS	   
#define stzrqf		 STZRQF	   
#define stzrzf		 STZRZF	   
#define xerbla		 XERBLA	   
#define zbdsqr		 ZBDSQR	   
#define zdrot		 ZDROT	   
#define zdrscl		 ZDRSCL	   
#define zgbbrd		 ZGBBRD	   
#define zgbcon		 ZGBCON	   
#define zgbequ		 ZGBEQU	   
#define zgbrfs		 ZGBRFS	   
#define zgbsv		 ZGBSV	   
#define zgbsvx		 ZGBSVX	   
#define zgbtf2		 ZGBTF2	   
#define zgbtrf		 ZGBTRF	   
#define zgbtrs		 ZGBTRS	   
#define zgebak		 ZGEBAK	   
#define zgebal		 ZGEBAL	   
#define zgebd2		 ZGEBD2	   
#define zgebrd		 ZGEBRD	   
#define zgecon		 ZGECON	   
#define zgeequ		 ZGEEQU	   
#define zgees		 ZGEES	   
#define zgeesx		 ZGEESX	   
#define zgeev		 ZGEEV	   
#define zgeevx		 ZGEEVX	   
#define zgegs		 ZGEGS	   
#define zgegv		 ZGEGV	   
#define zgehd2		 ZGEHD2	   
#define zgehrd		 ZGEHRD	   
#define zgelq2		 ZGELQ2	   
#define zgelqf		 ZGELQF	   
#define zgels		 ZGELS	   
#define zgelsd		 ZGELSD	   
#define zgelss		 ZGELSS	   
#define zgelsx		 ZGELSX	   
#define zgelsy		 ZGELSY	   
#define zgeql2		 ZGEQL2	   
#define zgeqlf		 ZGEQLF	   
#define zgeqp3		 ZGEQP3	   
#define zgeqpf		 ZGEQPF	   
#define zgeqr2		 ZGEQR2	   
#define zgeqrf		 ZGEQRF	   
#define zgerfs		 ZGERFS	   
#define zgerq2		 ZGERQ2	   
#define zgerqf		 ZGERQF	   
#define zgesc2		 ZGESC2	   
#define zgesdd		 ZGESDD	   
#define zgesv		 ZGESV	   
#define zgesvd		 ZGESVD	   
#define zgesvx		 ZGESVX	   
#define zgetc2		 ZGETC2	   
#define zgetf2		 ZGETF2	   
#define zgetrf		 ZGETRF	   
#define zgetri		 ZGETRI	   
#define zgetrs		 ZGETRS	   
#define zggbak		 ZGGBAK	   
#define zggbal		 ZGGBAL	   
#define zgges		 ZGGES	   
#define zggesx		 ZGGESX	   
#define zggev		 ZGGEV	   
#define zggevx		 ZGGEVX	   
#define zggglm		 ZGGGLM	   
#define zgghrd		 ZGGHRD	   
#define zgglse		 ZGGLSE	   
#define zggqrf		 ZGGQRF	   
#define zggrqf		 ZGGRQF	   
#define zggsvd		 ZGGSVD	   
#define zggsvp		 ZGGSVP	   
#define zgtcon		 ZGTCON	   
#define zgtrfs		 ZGTRFS	   
#define zgtsv		 ZGTSV	   
#define zgtsvx		 ZGTSVX	   
#define zgttrf		 ZGTTRF	   
#define zgttrs		 ZGTTRS	   
#define zgtts2		 ZGTTS2	   
#define zhbev		 ZHBEV	   
#define zhbevd		 ZHBEVD	   
#define zhbevx		 ZHBEVX	   
#define zhbgst		 ZHBGST	   
#define zhbgv		 ZHBGV	   
#define zhbgvd		 ZHBGVD	   
#define zhbgvx		 ZHBGVX	   
#define zhbtrd		 ZHBTRD	   
#define zhecon		 ZHECON	   
#define zheev		 ZHEEV	   
#define zheevd		 ZHEEVD	   
#define zheevr		 ZHEEVR	   
#define zheevx		 ZHEEVX	   
#define zhegs2		 ZHEGS2	   
#define zhegst		 ZHEGST	   
#define zhegv		 ZHEGV	   
#define zhegvd		 ZHEGVD	   
#define zhegvx		 ZHEGVX	   
#define zherfs		 ZHERFS	   
#define zhesv		 ZHESV	   
#define zhesvx		 ZHESVX	   
#define zhetd2		 ZHETD2	   
#define zhetf2		 ZHETF2	   
#define zhetrd		 ZHETRD	   
#define zhetrf		 ZHETRF	   
#define zhetri		 ZHETRI	   
#define zhetrs		 ZHETRS	   
#define zhgeqz		 ZHGEQZ	   
#define zhpcon		 ZHPCON	   
#define zhpev		 ZHPEV	   
#define zhpevd		 ZHPEVD	   
#define zhpevx		 ZHPEVX	   
#define zhpgst		 ZHPGST	   
#define zhpgv		 ZHPGV	   
#define zhpgvd		 ZHPGVD	   
#define zhpgvx		 ZHPGVX	   
#define zhprfs		 ZHPRFS	   
#define zhpsv		 ZHPSV	   
#define zhpsvx		 ZHPSVX	   
#define zhptrd		 ZHPTRD	   
#define zhptrf		 ZHPTRF	   
#define zhptri		 ZHPTRI	   
#define zhptrs		 ZHPTRS	   
#define zhsein		 ZHSEIN	   
#define zhseqr		 ZHSEQR	   
#define zlabrd		 ZLABRD	   
#define zlacgv		 ZLACGV	   
#define zlacon		 ZLACON	   
#define zlacp2		 ZLACP2	   
#define zlacpy		 ZLACPY	   
#define zlacrm		 ZLACRM	   
#define zlacrt		 ZLACRT	   
#define zladiv		 ZLADIV	   
#define zlaed0		 ZLAED0	   
#define zlaed7		 ZLAED7	   
#define zlaed8		 ZLAED8	   
#define zlaein		 ZLAEIN	   
#define zlaesy		 ZLAESY	   
#define zlaev2		 ZLAEV2	   
#define zlags2		 ZLAGS2	   
#define zlagtm		 ZLAGTM	   
#define zlahef		 ZLAHEF	   
#define zlahqr		 ZLAHQR	   
#define zlahrd		 ZLAHRD	   
#define zlaic1		 ZLAIC1	   
#define zlals0		 ZLALS0	   
#define zlalsa		 ZLALSA	   
#define zlalsd		 ZLALSD	   
#define zlangb		 ZLANGB	   
#define zlange		 ZLANGE	   
#define zlangt		 ZLANGT	   
#define zlanhb		 ZLANHB	   
#define zlanhe		 ZLANHE	   
#define zlanhp		 ZLANHP	   
#define zlanhs		 ZLANHS	   
#define zlanht		 ZLANHT	   
#define zlansb		 ZLANSB	   
#define zlansp		 ZLANSP	   
#define zlansy		 ZLANSY	   
#define zlantb		 ZLANTB	   
#define zlantp		 ZLANTP	   
#define zlantr		 ZLANTR	   
#define zlapll		 ZLAPLL	   
#define zlapmt		 ZLAPMT	   
#define zlaqgb		 ZLAQGB	   
#define zlaqge		 ZLAQGE	   
#define zlaqhb		 ZLAQHB	   
#define zlaqhe		 ZLAQHE	   
#define zlaqhp		 ZLAQHP	   
#define zlaqp2		 ZLAQP2	   
#define zlaqps		 ZLAQPS	   
#define zlaqsb		 ZLAQSB	   
#define zlaqsp		 ZLAQSP	   
#define zlaqsy		 ZLAQSY	   
#define zlar1v		 ZLAR1V	   
#define zlar2v		 ZLAR2V	   
#define zlarcm		 ZLARCM	   
#define zlarf		 ZLARF	   
#define zlarfb		 ZLARFB	   
#define zlarfg		 ZLARFG	   
#define zlarft		 ZLARFT	   
#define zlarfx		 ZLARFX	   
#define zlargv		 ZLARGV	   
#define zlarnv		 ZLARNV	   
#define zlarrv		 ZLARRV	   
#define zlartg		 ZLARTG	   
#define zlartv		 ZLARTV	   
#define zlarz		 ZLARZ	   
#define zlarzb		 ZLARZB	   
#define zlarzt		 ZLARZT	   
#define zlascl		 ZLASCL	   
#define zlaset		 ZLASET	   
#define zlasr		 ZLASR	   
#define zlassq		 ZLASSQ	   
#define zlaswp		 ZLASWP	   
#define zlasyf		 ZLASYF	   
#define zlatbs		 ZLATBS	   
#define zlatdf		 ZLATDF	   
#define zlatps		 ZLATPS	   
#define zlatrd		 ZLATRD	   
#define zlatrs		 ZLATRS	   
#define zlatrz		 ZLATRZ	   
#define zlatzm		 ZLATZM	   
#define zlauu2		 ZLAUU2	   
#define zlauum		 ZLAUUM	   
#define zpbcon		 ZPBCON	   
#define zpbequ		 ZPBEQU	   
#define zpbrfs		 ZPBRFS	   
#define zpbstf		 ZPBSTF	   
#define zpbsv		 ZPBSV	   
#define zpbsvx		 ZPBSVX	   
#define zpbtf2		 ZPBTF2	   
#define zpbtrf		 ZPBTRF	   
#define zpbtrs		 ZPBTRS	   
#define zpocon		 ZPOCON	   
#define zpoequ		 ZPOEQU	   
#define zporfs		 ZPORFS	   
#define zposv		 ZPOSV	   
#define zposvx		 ZPOSVX	   
#define zpotf2		 ZPOTF2	   
#define zpotrf		 ZPOTRF	   
#define zpotri		 ZPOTRI	   
#define zpotrs		 ZPOTRS	   
#define zppcon		 ZPPCON	   
#define zppequ		 ZPPEQU	   
#define zpprfs		 ZPPRFS	   
#define zppsv		 ZPPSV	   
#define zppsvx		 ZPPSVX	   
#define zpptrf		 ZPPTRF	   
#define zpptri		 ZPPTRI	   
#define zpptrs		 ZPPTRS	   
#define zptcon		 ZPTCON	   
#define zpteqr		 ZPTEQR	   
#define zptrfs		 ZPTRFS	   
#define zptsv		 ZPTSV	   
#define zptsvx		 ZPTSVX	   
#define zpttrf		 ZPTTRF	   
#define zpttrs		 ZPTTRS	   
#define zptts2		 ZPTTS2	   
#define zrotn		 ZROTN	   
#define zspcon		 ZSPCON	   
#define zspmv		 ZSPMV	   
#define zspru		 ZSPRU	   
#define zsprfs		 ZSPRFS	   
#define zspsv		 ZSPSV	   
#define zspsvx		 ZSPSVX	   
#define zsptrf		 ZSPTRF	   
#define zsptri		 ZSPTRI	   
#define zsptrs		 ZSPTRS	   
#define zstedc		 ZSTEDC	   
#define zstegr		 ZSTEGR	   
#define zstein		 ZSTEIN	   
#define zsteqr		 ZSTEQR	   
#define zsycon		 ZSYCON	   
#define zsymv		 ZSYMV	   
#define zsyru		 ZSYRU	   
#define zsyrfs		 ZSYRFS	   
#define zsysv		 ZSYSV	   
#define zsysvx		 ZSYSVX	   
#define zsytf2		 ZSYTF2	   
#define zsytrf		 ZSYTRF	   
#define zsytri		 ZSYTRI	   
#define zsytrs		 ZSYTRS	   
#define ztbcon		 ZTBCON	   
#define ztbrfs		 ZTBRFS	   
#define ztbtrs		 ZTBTRS	   
#define ztgevc		 ZTGEVC	   
#define ztgex2		 ZTGEX2	   
#define ztgexc		 ZTGEXC	   
#define ztgsen		 ZTGSEN	   
#define ztgsja		 ZTGSJA	   
#define ztgsna		 ZTGSNA	   
#define ztgsy2		 ZTGSY2	   
#define ztgsyl		 ZTGSYL	   
#define ztpcon		 ZTPCON	   
#define ztprfs		 ZTPRFS	   
#define ztptri		 ZTPTRI	   
#define ztptrs		 ZTPTRS	   
#define ztrcon		 ZTRCON	   
#define ztrevc		 ZTREVC	   
#define ztrexc		 ZTREXC	   
#define ztrrfs		 ZTRRFS	   
#define ztrsen		 ZTRSEN	   
#define ztrsna		 ZTRSNA	   
#define ztrsyl		 ZTRSYL	   
#define ztrti2		 ZTRTI2	   
#define ztrtri		 ZTRTRI	   
#define ztrtrs		 ZTRTRS	   
#define ztzrqf		 ZTZRQF	   
#define ztzrzf		 ZTZRZF	   
#define zung2l		 ZUNG2L	   
#define zung2r		 ZUNG2R	   
#define zungbr		 ZUNGBR	   
#define zunghr		 ZUNGHR	   
#define zungl2		 ZUNGL2	   
#define zunglq		 ZUNGLQ	   
#define zungql		 ZUNGQL	   
#define zungqr		 ZUNGQR	   
#define zungr2		 ZUNGR2	   
#define zungrq		 ZUNGRQ	   
#define zungtr		 ZUNGTR	   
#define zunm2l		 ZUNM2L	   
#define zunm2r		 ZUNM2R	   
#define zunmbr		 ZUNMBR	   
#define zunmhr		 ZUNMHR	   
#define zunml2		 ZUNML2	   
#define zunmlq		 ZUNMLQ	   
#define zunmql		 ZUNMQL	   
#define zunmqr		 ZUNMQR	   
#define zunmr2		 ZUNMR2	   
#define zunmr3		 ZUNMR3	   
#define zunmrq		 ZUNMRQ	   
#define zunmrz		 ZUNMRZ	   
#define zunmtr		 ZUNMTR	   
#define zupgtr		 ZUPGTR	   
#define zupmtr		 ZUPMTR     


/* no capital letters */
#elif defined __UNDERSCORE__ && !defined __CAPS__ && !defined __2UNDERSCORES__

#define cbdsqr     cbdsqr_	    
#define cgbbrd	   cgbbrd_	    
#define cgbcon	   cgbcon_	    
#define cgbequ	   cgbequ_	    
#define cgbrfs	   cgbrfs_	    
#define cgbsv	   cgbsv_	    
#define cgbsvx	   cgbsvx_	    
#define cgbtf2	   cgbtf2_	    
#define cgbtrf	   cgbtrf_	    
#define cgbtrs	   cgbtrs_	    
#define cgebak	   cgebak_	    
#define cgebal	   cgebal_	    
#define cgebd2	   cgebd2_	    
#define cgebrd	   cgebrd_	    
#define cgecon	   cgecon_	    
#define cgeequ	   cgeequ_	    
#define cgees	   cgees_	    
#define cgeesx	   cgeesx_	    
#define cgeev	   cgeev_	    
#define cgeevx	   cgeevx_	    
#define cgegs	   cgegs_	    
#define cgegv	   cgegv_	    
#define cgehd2	   cgehd2_	    
#define cgehrd	   cgehrd_	    
#define cgelq2	   cgelq2_	    
#define cgelqf	   cgelqf_	    
#define cgels	   cgels_	    
#define cgelsd	   cgelsd_	    
#define cgelss	   cgelss_	    
#define cgelsx	   cgelsx_	    
#define cgelsy	   cgelsy_	    
#define cgeql2	   cgeql2_	    
#define cgeqlf	   cgeqlf_	    
#define cgeqp3	   cgeqp3_	    
#define cgeqpf	   cgeqpf_	    
#define cgeqr2	   cgeqr2_	    
#define cgeqrf	   cgeqrf_	    
#define cgerfs	   cgerfs_	    
#define cgerq2	   cgerq2_	    
#define cgerqf	   cgerqf_	    
#define cgesc2	   cgesc2_	    
#define cgesdd	   cgesdd_	    
#define cgesv	   cgesv_	    
#define cgesvd	   cgesvd_	    
#define cgesvx	   cgesvx_	    
#define cgetc2	   cgetc2_	    
#define cgetf2	   cgetf2_	    
#define cgetrf	   cgetrf_	    
#define cgetri	   cgetri_	    
#define cgetrs	   cgetrs_	    
#define cggbak	   cggbak_	    
#define cggbal	   cggbal_	    
#define cgges	   cgges_	    
#define cggesx	   cggesx_	    
#define cggev	   cggev_	    
#define cggevx	   cggevx_	    
#define cggglm	   cggglm_	    
#define cgghrd	   cgghrd_	    
#define cgglse	   cgglse_	    
#define cggqrf	   cggqrf_	    
#define cggrqf	   cggrqf_	    
#define cggsvd	   cggsvd_	    
#define cggsvp	   cggsvp_	    
#define cgtcon	   cgtcon_	    
#define cgtrfs	   cgtrfs_	    
#define cgtsv	   cgtsv_	    
#define cgtsvx	   cgtsvx_	    
#define cgttrf	   cgttrf_	    
#define cgttrs	   cgttrs_	    
#define cgtts2	   cgtts2_	    
#define chbev	   chbev_	    
#define chbevd	   chbevd_	    
#define chbevx	   chbevx_	    
#define chbgst	   chbgst_	    
#define chbgv	   chbgv_	    
#define chbgvd	   chbgvd_	    
#define chbgvx	   chbgvx_	    
#define chbtrd	   chbtrd_	    
#define checon	   checon_	    
#define cheev	   cheev_	    
#define cheevd	   cheevd_	    
#define cheevr	   cheevr_	    
#define cheevx	   cheevx_	    
#define chegs2	   chegs2_	    
#define chegst	   chegst_	    
#define chegv	   chegv_	    
#define chegvd	   chegvd_	    
#define chegvx	   chegvx_	    
#define cherfs	   cherfs_	    
#define chesv	   chesv_	    
#define chesvx	   chesvx_	    
#define chetd2	   chetd2_	    
#define chetf2	   chetf2_	    
#define chetrd	   chetrd_	    
#define chetrf	   chetrf_	    
#define chetri	   chetri_	    
#define chetrs	   chetrs_	    
#define chgeqz	   chgeqz_	    
#define chpcon	   chpcon_	    
#define chpev	   chpev_	    
#define chpevd	   chpevd_	    
#define chpevx	   chpevx_	    
#define chpgst	   chpgst_	    
#define chpgv	   chpgv_	    
#define chpgvd	   chpgvd_	    
#define chpgvx	   chpgvx_	    
#define chprfs	   chprfs_	    
#define chpsv	   chpsv_	    
#define chpsvx	   chpsvx_	    
#define chptrd	   chptrd_	    
#define chptrf	   chptrf_	    
#define chptri	   chptri_	    
#define chptrs	   chptrs_	    
#define chsein	   chsein_	    
#define chseqr	   chseqr_	    
#define clabrd	   clabrd_	    
#define clacgv	   clacgv_	    
#define clacon	   clacon_	    
#define clacp2	   clacp2_	    
#define clacpy	   clacpy_	    
#define clacrm	   clacrm_	    
#define clacrt	   clacrt_	    
#define cladiv	   cladiv_	    
#define claed0	   claed0_	    
#define claed7	   claed7_	    
#define claed8	   claed8_	    
#define claein	   claein_	    
#define claesy	   claesy_	    
#define claev2	   claev2_	    
#define clags2	   clags2_	    
#define clagtm	   clagtm_	    
#define clahef	   clahef_	    
#define clahqr	   clahqr_	    
#define clahrd	   clahrd_	    
#define claic1	   claic1_	    
#define clals0	   clals0_	    
#define clalsa	   clalsa_	    
#define clalsd	   clalsd_	    
#define clangb	   clangb_	    
#define clange	   clange_	    
#define clangt	   clangt_	    
#define clanhb	   clanhb_	    
#define clanhe	   clanhe_	    
#define clanhp	   clanhp_	    
#define clanhs	   clanhs_	    
#define clanht	   clanht_	    
#define clansb	   clansb_	    
#define clansp	   clansp_	    
#define clansy	   clansy_	    
#define clantb	   clantb_	    
#define clantp	   clantp_	    
#define clantr	   clantr_	    
#define clapll	   clapll_	    
#define clapmt	   clapmt_	    
#define claqgb	   claqgb_	    
#define claqge	   claqge_	    
#define claqhb	   claqhb_	    
#define claqhe	   claqhe_	    
#define claqhp	   claqhp_	    
#define claqp2	   claqp2_	    
#define claqps	   claqps_	    
#define claqsb	   claqsb_	    
#define claqsp	   claqsp_	    
#define claqsy	   claqsy_	    
#define clar1v	   clar1v_	    
#define clar2v	   clar2v_	    
#define clarcm	   clarcm_	    
#define clarf	   clarf_	    
#define clarfb	   clarfb_	    
#define clarfg	   clarfg_	    
#define clarft	   clarft_	    
#define clarfx	   clarfx_	    
#define clargv	   clargv_	    
#define clarnv	   clarnv_	    
#define clarrv	   clarrv_	    
#define clartg	   clartg_	    
#define clartv	   clartv_	    
#define clarz	   clarz_	    
#define clarzb	   clarzb_	    
#define clarzt	   clarzt_	    
#define clascl	   clascl_	    
#define claset	   claset_	    
#define clasr	   clasr_	    
#define classq	   classq_	    
#define claswp	   claswp_	    
#define clasyf	   clasyf_	    
#define clatbs	   clatbs_	    
#define clatdf	   clatdf_	    
#define clatps	   clatps_	    
#define clatrd	   clatrd_	    
#define clatrs	   clatrs_	    
#define clatrz	   clatrz_	    
#define clatzm	   clatzm_	    
#define clauu2	   clauu2_	    
#define clauum	   clauum_	    
#define cpbcon	   cpbcon_	    
#define cpbequ	   cpbequ_	    
#define cpbrfs	   cpbrfs_	    
#define cpbstf	   cpbstf_	    
#define cpbsv	   cpbsv_	    
#define cpbsvx	   cpbsvx_	    
#define cpbtf2	   cpbtf2_	    
#define cpbtrf	   cpbtrf_	    
#define cpbtrs	   cpbtrs_	    
#define cpocon	   cpocon_	    
#define cpoequ	   cpoequ_	    
#define cporfs	   cporfs_	    
#define cposv	   cposv_	    
#define cposvx	   cposvx_	    
#define cpotf2	   cpotf2_	    
#define cpotrf	   cpotrf_	    
#define cpotri	   cpotri_	    
#define cpotrs	   cpotrs_	    
#define cppcon	   cppcon_	    
#define cppequ	   cppequ_	    
#define cpprfs	   cpprfs_	    
#define cppsv	   cppsv_	    
#define cppsvx	   cppsvx_	    
#define cpptrf	   cpptrf_	    
#define cpptri	   cpptri_	    
#define cpptrs	   cpptrs_	    
#define cptcon	   cptcon_	    
#define cpteqr	   cpteqr_	    
#define cptrfs	   cptrfs_	    
#define cptsv	   cptsv_	    
#define cptsvx	   cptsvx_	    
#define cpttrf	   cpttrf_	    
#define cpttrs	   cpttrs_	    
#define cptts2	   cptts2_	    
#define crotn	   crotn_	    
#define cspcon	   cspcon_	    
#define cspmv	   cspmv_	    
#define cspru	   cspru_	    
#define csprfs	   csprfs_	    
#define cspsv	   cspsv_	    
#define cspsvx	   cspsvx_	    
#define csptrf	   csptrf_	    
#define csptri	   csptri_	    
#define csptrs	   csptrs_	    
#define csrot	   csrot_	    
#define csrscl	   csrscl_	    
#define cstedc	   cstedc_	    
#define cstegr	   cstegr_	    
#define cstein	   cstein_	    
#define csteqr	   csteqr_	    
#define csycon	   csycon_	    
#define csymv	   csymv_	    
#define csyru	   csyru_	    
#define csyrfs	   csyrfs_	    
#define csysv	   csysv_	    
#define csysvx	   csysvx_	    
#define csytf2	   csytf2_	    
#define csytrf	   csytrf_	    
#define csytri	   csytri_	    
#define csytrs	   csytrs_	    
#define ctbcon	   ctbcon_	    
#define ctbrfs	   ctbrfs_	    
#define ctbtrs	   ctbtrs_	    
#define ctgevc	   ctgevc_	    
#define ctgex2	   ctgex2_	    
#define ctgexc	   ctgexc_	    
#define ctgsen	   ctgsen_	    
#define ctgsja	   ctgsja_	    
#define ctgsna	   ctgsna_	    
#define ctgsy2	   ctgsy2_	    
#define ctgsyl	   ctgsyl_	    
#define ctpcon	   ctpcon_	    
#define ctprfs	   ctprfs_	    
#define ctptri	   ctptri_	    
#define ctptrs	   ctptrs_	    
#define ctrcon	   ctrcon_	    
#define ctrevc	   ctrevc_	    
#define ctrexc	   ctrexc_	    
#define ctrrfs	   ctrrfs_	    
#define ctrsen	   ctrsen_	    
#define ctrsna	   ctrsna_	    
#define ctrsyl	   ctrsyl_	    
#define ctrti2	   ctrti2_	    
#define ctrtri	   ctrtri_	    
#define ctrtrs	   ctrtrs_	    
#define ctzrqf	   ctzrqf_	    
#define ctzrzf	   ctzrzf_	    
#define cung2l	   cung2l_	    
#define cung2r	   cung2r_	    
#define cungbr	   cungbr_	    
#define cunghr	   cunghr_	    
#define cungl2	   cungl2_	    
#define cunglq	   cunglq_	    
#define cungql	   cungql_	    
#define cungqr	   cungqr_	    
#define cungr2	   cungr2_	    
#define cungrq	   cungrq_	    
#define cungtr	   cungtr_	    
#define cunm2l	   cunm2l_	    
#define cunm2r	   cunm2r_	    
#define cunmbr	   cunmbr_	    
#define cunmhr	   cunmhr_	    
#define cunml2	   cunml2_	    
#define cunmlq	   cunmlq_	    
#define cunmql	   cunmql_	    
#define cunmqr	   cunmqr_	    
#define cunmr2	   cunmr2_	    
#define cunmr3	   cunmr3_	    
#define cunmrq	   cunmrq_	    
#define cunmrz	   cunmrz_	    
#define cunmtr	   cunmtr_	    
#define cupgtr	   cupgtr_	    
#define cupmtr	   cupmtr_	    
#define dbdsdc	   dbdsdc_	    
#define dbdsqr	   dbdsqr_	    
#define ddisna	   ddisna_	    
#define dgbbrd	   dgbbrd_	    
#define dgbcon	   dgbcon_	    
#define dgbequ	   dgbequ_	    
#define dgbrfs	   dgbrfs_	    
#define dgbsv	   dgbsv_	    
#define dgbsvx	   dgbsvx_	    
#define dgbtf2	   dgbtf2_	    
#define dgbtrf	   dgbtrf_	    
#define dgbtrs	   dgbtrs_	    
#define dgebak	   dgebak_	    
#define dgebal	   dgebal_	    
#define dgebd2	   dgebd2_	    
#define dgebrd	   dgebrd_	    
#define dgecon	   dgecon_	    
#define dgeequ	   dgeequ_	    
#define dgees	   dgees_	    
#define dgeesx	   dgeesx_	    
#define dgeev	   dgeev_	    
#define dgeevx	   dgeevx_	    
#define dgegs	   dgegs_	    
#define dgegv	   dgegv_	    
#define dgehd2	   dgehd2_	    
#define dgehrd	   dgehrd_	    
#define dgelq2	   dgelq2_	    
#define dgelqf	   dgelqf_	    
#define dgels	   dgels_	    
#define dgelsd	   dgelsd_	    
#define dgelss	   dgelss_	    
#define dgelsx	   dgelsx_	    
#define dgelsy	   dgelsy_	    
#define dgeql2	   dgeql2_	    
#define dgeqlf	   dgeqlf_	    
#define dgeqp3	   dgeqp3_	    
#define dgeqpf	   dgeqpf_	    
#define dgeqr2	   dgeqr2_	    
#define dgeqrf	   dgeqrf_	    
#define dgerfs	   dgerfs_	    
#define dgerq2	   dgerq2_	    
#define dgerqf	   dgerqf_	    
#define dgesc2	   dgesc2_	    
#define dgesdd	   dgesdd_	    
#define dgesv	   dgesv_	    
#define dgesvd	   dgesvd_	    
#define dgesvx	   dgesvx_	    
#define dgetc2	   dgetc2_	    
#define dgetf2	   dgetf2_	    
#define dgetrf	   dgetrf_	    
#define dgetri	   dgetri_	    
#define dgetrs	   dgetrs_	    
#define dggbak	   dggbak_	    
#define dggbal	   dggbal_	    
#define dgges	   dgges_	    
#define dggesx	   dggesx_	    
#define dggev	   dggev_	    
#define dggevx	   dggevx_	    
#define dggglm	   dggglm_	    
#define dgghrd	   dgghrd_	    
#define dgglse	   dgglse_	    
#define dggqrf	   dggqrf_	    
#define dggrqf	   dggrqf_	    
#define dggsvd	   dggsvd_	    
#define dggsvp	   dggsvp_	    
#define dgtcon	   dgtcon_	    
#define dgtrfs	   dgtrfs_	    
#define dgtsv	   dgtsv_	    
#define dgtsvx	   dgtsvx_	    
#define dgttrf	   dgttrf_	    
#define dgttrs	   dgttrs_	    
#define dgtts2	   dgtts2_	    
#define dhgeqz	   dhgeqz_	    
#define dhsein	   dhsein_	    
#define dhseqr	   dhseqr_	    
#define dlabad	   dlabad_	    
#define dlabrd	   dlabrd_	    
#define dlacon	   dlacon_	    
#define dlacpy	   dlacpy_	    
#define dladiv	   dladiv_	    
#define dlae2a	   dlae2a_	    
#define dlaebz	   dlaebz_	    
#define dlaed0	   dlaed0_	    
#define dlaed1	   dlaed1_	    
#define dlaed2	   dlaed2_	    
#define dlaed3	   dlaed3_	    
#define dlaed4	   dlaed4_	    
#define dlaed5	   dlaed5_	    
#define dlaed6	   dlaed6_	    
#define dlaed7	   dlaed7_	    
#define dlaed8	   dlaed8_	    
#define dlaed9	   dlaed9_	    
#define dlaeda	   dlaeda_	    
#define dlaein	   dlaein_	    
#define dlaev2	   dlaev2_	    
#define dlaexc	   dlaexc_	    
#define dlag2a	   dlag2a_	    
#define dlags2	   dlags2_	    
#define dlagtf	   dlagtf_	    
#define dlagtm	   dlagtm_	    
#define dlagts	   dlagts_	    
#define dlagv2	   dlagv2_	    
#define dlahqr	   dlahqr_	    
#define dlahrd	   dlahrd_	    
#define dlaic1	   dlaic1_	    
#define dlaln2	   dlaln2_	    
#define dlals0	   dlals0_	    
#define dlalsa	   dlalsa_	    
#define dlalsd	   dlalsd_	    
#define dlamch	   dlamch_	    
#define dlamc1	   dlamc1_	    
#define dlamc2	   dlamc2_	    
#define dlamc3	   dlamc3_	    
#define dlamc4	   dlamc4_	    
#define dlamc5	   dlamc5_	    
#define dlamrg	   dlamrg_	    
#define dlangb	   dlangb_	    
#define dlange	   dlange_	    
#define dlangt	   dlangt_	    
#define dlanhs	   dlanhs_	    
#define dlansb	   dlansb_	    
#define dlansp	   dlansp_	    
#define dlanst	   dlanst_	    
#define dlansy	   dlansy_	    
#define dlantb	   dlantb_	    
#define dlantp	   dlantp_	    
#define dlantr	   dlantr_	    
#define dlanv2	   dlanv2_	    
#define dlapll	   dlapll_	    
#define dlapmt	   dlapmt_	    
#define dlapy2	   dlapy2_	    
#define dlapy3	   dlapy3_	    
#define dlaqgb	   dlaqgb_	    
#define dlaqge	   dlaqge_	    
#define dlaqp2	   dlaqp2_	    
#define dlaqps	   dlaqps_	    
#define dlaqsb	   dlaqsb_	    
#define dlaqsp	   dlaqsp_	    
#define dlaqsy	   dlaqsy_	    
#define dlaqtr	   dlaqtr_	    
#define dlar1v	   dlar1v_	    
#define dlar2v	   dlar2v_	    
#define dlarf	   dlarf_	    
#define dlarfb	   dlarfb_	    
#define dlarfg	   dlarfg_	    
#define dlarft	   dlarft_	    
#define dlarfx	   dlarfx_	    
#define dlargv	   dlargv_	    
#define dlarnv	   dlarnv_	    
#define dlarrb	   dlarrb_	    
#define dlarre	   dlarre_	    
#define dlarrf	   dlarrf_	    
#define dlarrv	   dlarrv_	    
#define dlartg	   dlartg_	    
#define dlartv	   dlartv_	    
#define dlaruv	   dlaruv_	    
#define dlarz	   dlarz_	    
#define dlarzb	   dlarzb_	    
#define dlarzt	   dlarzt_	    
#define dlas2f	   dlas2f_	    
#define dlascl	   dlascl_	    
#define dlasd0	   dlasd0_	    
#define dlasd1	   dlasd1_	    
#define dlasd2	   dlasd2_	    
#define dlasd3	   dlasd3_	    
#define dlasd4	   dlasd4_	    
#define dlasd5	   dlasd5_	    
#define dlasd6	   dlasd6_	    
#define dlasd7	   dlasd7_	    
#define dlasd8	   dlasd8_	    
#define dlasd9	   dlasd9_	    
#define dlasda	   dlasda_	    
#define dlasdq	   dlasdq_	    
#define dlasdt	   dlasdt_	    
#define dlaset	   dlaset_	    
#define dlasq1	   dlasq1_	    
#define dlasq2	   dlasq2_	    
#define dlasq3	   dlasq3_	    
#define dlasq4	   dlasq4_	    
#define dlasq5	   dlasq5_	    
#define dlasq6	   dlasq6_	    
#define dlasr	   dlasr_	    
#define dlasrt	   dlasrt_	    
#define dlassq	   dlassq_	    
#define dlasv2	   dlasv2_	    
#define dlaswp	   dlaswp_	    
#define dlasy2	   dlasy2_	    
#define dlasyf	   dlasyf_	    
#define dlatbs	   dlatbs_	    
#define dlatdf	   dlatdf_	    
#define dlatps	   dlatps_	    
#define dlatrd	   dlatrd_	    
#define dlatrs	   dlatrs_	    
#define dlatrz	   dlatrz_	    
#define dlatzm	   dlatzm_	    
#define dlauu2	   dlauu2_	    
#define dlauum	   dlauum_	    
#define dopgtr	   dopgtr_	    
#define dopmtr	   dopmtr_	    
#define dorg2l	   dorg2l_	    
#define dorg2r	   dorg2r_	    
#define dorgbr	   dorgbr_	    
#define dorghr	   dorghr_	    
#define dorgl2	   dorgl2_	    
#define dorglq	   dorglq_	    
#define dorgql	   dorgql_	    
#define dorgqr	   dorgqr_	    
#define dorgr2	   dorgr2_	    
#define dorgrq	   dorgrq_	    
#define dorgtr	   dorgtr_	    
#define dorm2l	   dorm2l_	    
#define dorm2r	   dorm2r_	    
#define dormbr	   dormbr_	    
#define dormhr	   dormhr_	    
#define dorml2	   dorml2_	    
#define dormlq	   dormlq_	    
#define dormql	   dormql_	    
#define dormqr	   dormqr_	    
#define dormr2	   dormr2_	    
#define dormr3	   dormr3_	    
#define dormrq	   dormrq_	    
#define dormrz	   dormrz_	    
#define dormtr	   dormtr_	    
#define dpbcon	   dpbcon_	    
#define dpbequ	   dpbequ_	    
#define dpbrfs	   dpbrfs_	    
#define dpbstf	   dpbstf_	    
#define dpbsv	   dpbsv_	    
#define dpbsvx	   dpbsvx_	    
#define dpbtf2	   dpbtf2_	    
#define dpbtrf	   dpbtrf_	    
#define dpbtrs	   dpbtrs_	    
#define dpocon	   dpocon_	    
#define dpoequ	   dpoequ_	    
#define dporfs	   dporfs_	    
#define dposv	   dposv_	    
#define dposvx	   dposvx_	    
#define dpotf2	   dpotf2_	    
#define dpotrf	   dpotrf_	    
#define dpotri	   dpotri_	    
#define dpotrs	   dpotrs_	    
#define dppcon	   dppcon_	    
#define dppequ	   dppequ_	    
#define dpprfs	   dpprfs_	    
#define dppsv	   dppsv_	    
#define dppsvx	   dppsvx_	    
#define dpptrf	   dpptrf_	    
#define dpptri	   dpptri_	    
#define dpptrs	   dpptrs_	    
#define dptcon	   dptcon_	    
#define dpteqr	   dpteqr_	    
#define dptrfs	   dptrfs_	    
#define dptsv	   dptsv_	    
#define dptsvx	   dptsvx_	    
#define dpttrf	   dpttrf_	    
#define dpttrs	   dpttrs_	    
#define dptts2	   dptts2_	    
#define drscl	   drscl_	    
#define dsbev	   dsbev_	    
#define dsbevd	   dsbevd_	    
#define dsbevx	   dsbevx_	    
#define dsbgst	   dsbgst_	    
#define dsbgv	   dsbgv_	    
#define dsbgvd	   dsbgvd_	    
#define dsbgvx	   dsbgvx_	    
#define dsbtrd	   dsbtrd_	    
#define dsecnd	   dsecnd_	    
#define dspcon	   dspcon_	    
#define dspev	   dspev_	    
#define dspevd	   dspevd_	    
#define dspevx	   dspevx_	    
#define dspgst	   dspgst_	    
#define dspgv	   dspgv_	    
#define dspgvd	   dspgvd_	    
#define dspgvx	   dspgvx_	    
#define dsprfs	   dsprfs_	    
#define dspsv	   dspsv_	    
#define dspsvx	   dspsvx_	    
#define dsptrd	   dsptrd_	    
#define dsptrf	   dsptrf_	    
#define dsptri	   dsptri_	    
#define dsptrs	   dsptrs_	    
#define dstebz	   dstebz_	    
#define dstedc	   dstedc_	    
#define dstegr	   dstegr_	    
#define dstein	   dstein_	    
#define dsteqr	   dsteqr_	    
#define dsterf	   dsterf_	    
#define dstev	   dstev_	    
#define dstevd	   dstevd_	    
#define dstevr	   dstevr_	    
#define dstevx	   dstevx_	    
#define dsycon	   dsycon_	    
#define dsyev	   dsyev_	    
#define dsyevd	   dsyevd_	    
#define dsyevr	   dsyevr_	    
#define dsyevx	   dsyevx_	    
#define dsygs2	   dsygs2_	    
#define dsygst	   dsygst_	    
#define dsygv	   dsygv_	    
#define dsygvd	   dsygvd_	    
#define dsygvx	   dsygvx_	    
#define dsyrfs	   dsyrfs_	    
#define dsysv	   dsysv_	    
#define dsysvx	   dsysvx_	    
#define dsytd2	   dsytd2_	    
#define dsytf2	   dsytf2_	    
#define dsytrd	   dsytrd_	    
#define dsytrf	   dsytrf_	    
#define dsytri	   dsytri_	    
#define dsytrs	   dsytrs_	    
#define dtbcon	   dtbcon_	    
#define dtbrfs	   dtbrfs_	    
#define dtbtrs	   dtbtrs_	    
#define dtgevc	   dtgevc_	    
#define dtgex2	   dtgex2_	    
#define dtgexc	   dtgexc_	    
#define dtgsen	   dtgsen_	    
#define dtgsja	   dtgsja_	    
#define dtgsna	   dtgsna_	    
#define dtgsy2	   dtgsy2_	    
#define dtgsyl	   dtgsyl_	    
#define dtpcon	   dtpcon_	    
#define dtprfs	   dtprfs_	    
#define dtptri	   dtptri_	    
#define dtptrs	   dtptrs_	    
#define dtrcon	   dtrcon_	    
#define dtrevc	   dtrevc_	    
#define dtrexc	   dtrexc_	    
#define dtrrfs	   dtrrfs_	    
#define dtrsen	   dtrsen_	    
#define dtrsna	   dtrsna_	    
#define dtrsyl	   dtrsyl_	    
#define dtrti2	   dtrti2_	    
#define dtrtri	   dtrtri_	    
#define dtrtrs	   dtrtrs_	    
#define dtzrqf	   dtzrqf_	    
#define dtzrzf	   dtzrzf_	    
#define dzsum1	   dzsum1_	    
#define icmax1	   icmax1_	    
#define ieeeck	   ieeeck_	    
#define ilaenv	   ilaenv_	    
#define izmax1	   izmax1_	    
#define lsamech	   lsamech_    
#define lsamen	   lsamen_	    
#define sbdsdc	   sbdsdc_	    
#define sbdsqr	   sbdsqr_	    
#define scsum1	   scsum1_	    
#define sdisna	   sdisna_	    
#define secondv	   secondv_    
#define sgbbrd	   sgbbrd_	    
#define sgbcon	   sgbcon_	    
#define sgbequ	   sgbequ_	    
#define sgbrfs	   sgbrfs_	    
#define sgbsv	   sgbsv_	    
#define sgbsvx	   sgbsvx_	    
#define sgbtf2	   sgbtf2_	    
#define sgbtrf	   sgbtrf_	    
#define sgbtrs	   sgbtrs_	    
#define sgebak	   sgebak_	    
#define sgebal	   sgebal_	    
#define sgebd2	   sgebd2_	    
#define sgebrd	   sgebrd_	    
#define sgecon	   sgecon_	    
#define sgeequ	   sgeequ_	    
#define sgees	   sgees_	    
#define sgeesx	   sgeesx_	    
#define sgeev	   sgeev_	    
#define sgeevx	   sgeevx_	    
#define sgegs	   sgegs_	    
#define sgegv	   sgegv_	    
#define sgehd2	   sgehd2_	    
#define sgehrd	   sgehrd_	    
#define sgelq2	   sgelq2_	    
#define sgelqf	   sgelqf_	    
#define sgels	   sgels_	    
#define sgelsd	   sgelsd_	    
#define sgelss	   sgelss_	    
#define sgelsx	   sgelsx_	    
#define sgelsy	   sgelsy_	    
#define sgeql2	   sgeql2_	    
#define sgeqlf	   sgeqlf_	    
#define sgeqp3	   sgeqp3_	    
#define sgeqpf	   sgeqpf_	    
#define sgeqr2	   sgeqr2_	    
#define sgeqrf	   sgeqrf_	    
#define sgerfs	   sgerfs_	    
#define sgerq2	   sgerq2_	    
#define sgerqf	   sgerqf_	    
#define sgesc2	   sgesc2_	    
#define sgesdd	   sgesdd_	    
#define sgesv	   sgesv_	    
#define sgesvd	   sgesvd_	    
#define sgesvx	   sgesvx_	    
#define sgetc2	   sgetc2_	    
#define sgetf2	   sgetf2_	    
#define sgetrf	   sgetrf_	    
#define sgetri	   sgetri_	    
#define sgetrs	   sgetrs_	    
#define sggbak	   sggbak_	    
#define sggbal	   sggbal_	    
#define sgges	   sgges_	    
#define sggesx	   sggesx_	    
#define sggev	   sggev_	    
#define sggevx	   sggevx_	    
#define sggglm	   sggglm_	    
#define sgghrd	   sgghrd_	    
#define sgglse	   sgglse_	    
#define sggqrf	   sggqrf_	    
#define sggrqf	   sggrqf_	    
#define sggsvd	   sggsvd_	    
#define sggsvp	   sggsvp_	    
#define sgtcon	   sgtcon_	    
#define sgtrfs	   sgtrfs_	    
#define sgtsv	   sgtsv_	    
#define sgtsvx	   sgtsvx_	    
#define sgttrf	   sgttrf_	    
#define sgttrs	   sgttrs_	    
#define sgtts2	   sgtts2_	    
#define shgeqz	   shgeqz_	    
#define shsein	   shsein_	    
#define shseqr	   shseqr_	    
#define slabadr	   slabadr_    
#define slabrd	   slabrd_	    
#define slacon	   slacon_	    
#define slacpy	   slacpy_	    
#define sladivr	   sladivr_    
#define slae2re	   slae2re_    
#define slaebz	   slaebz_	    
#define slaed0	   slaed0_	    
#define slaed1	   slaed1_	    
#define slaed2	   slaed2_	    
#define slaed3	   slaed3_	    
#define slaed4	   slaed4_	    
#define slaed5	   slaed5_	    
#define slaed6	   slaed6_	    
#define slaed7	   slaed7_	    
#define slaed8	   slaed8_	    
#define slaed9	   slaed9_	    
#define slaeda	   slaeda_	    
#define slaein	   slaein_	    
#define slaev2r	   slaev2r_    
#define slaexc	   slaexc_	    
#define slag2re	   slag2re_    
#define slags2	   slags2_	    
#define slagtf	   slagtf_	    
#define slagtm	   slagtm_	    
#define slagts	   slagts_	    
#define slagv2r	   slagv2r_    
#define slahqr	   slahqr_	    
#define slahrd	   slahrd_	    
#define slaic1	   slaic1_	    
#define slaln2	   slaln2_	    
#define slals0	   slals0_	    
#define slalsa	   slalsa_	    
#define slalsd	   slalsd_	    
#define slamch	   slamch_	    
#define slamc1	   slamc1_	    
#define slamc2	   slamc2_	    
#define slamc3r	   slamc3r_    
#define slamc4	   slamc4_	    
#define slamc5	   slamc5_	    
#define slamrg	   slamrg_	    
#define slangb	   slangb_	    
#define slange	   slange_	    
#define slangt	   slangt_	    
#define slanhs	   slanhs_	    
#define slansb	   slansb_	    
#define slansp	   slansp_	    
#define slanst	   slanst_	    
#define slansy	   slansy_	    
#define slantb	   slantb_	    
#define slantp	   slantp_	    
#define slantr	   slantr_	    
#define slanv2r	   slanv2r_    
#define slapll	   slapll_	    
#define slapmt	   slapmt_	    
#define slapy2r	   slapy2r_    
#define slapy3r	   slapy3r_    
#define slaqgb	   slaqgb_	    
#define slaqge	   slaqge_	    
#define slaqp2	   slaqp2_	    
#define slaqps	   slaqps_	    
#define slaqsb	   slaqsb_	    
#define slaqsp	   slaqsp_	    
#define slaqsy	   slaqsy_	    
#define slaqtr	   slaqtr_	    
#define slar1v	   slar1v_	    
#define slar2v	   slar2v_	    
#define slarf	   slarf_	    
#define slarfb	   slarfb_	    
#define slarfg	   slarfg_	    
#define slarft	   slarft_	    
#define slarfx	   slarfx_	    
#define slargv	   slargv_	    
#define slarnv	   slarnv_	    
#define slarrb	   slarrb_	    
#define slarre	   slarre_	    
#define slarrf	   slarrf_	    
#define slarrv	   slarrv_	    
#define slartgr	   slartgr_    
#define slartv	   slartv_	    
#define slaruv	   slaruv_	    
#define slarz	   slarz_	    
#define slarzb	   slarzb_	    
#define slarzt	   slarzt_	    
#define slas2re	   slas2re_    
#define slascl	   slascl_	    
#define slasd0	   slasd0_	    
#define slasd1	   slasd1_	    
#define slasd2	   slasd2_	    
#define slasd3	   slasd3_	    
#define slasd4	   slasd4_	    
#define slasd5	   slasd5_	    
#define slasd6	   slasd6_	    
#define slasd7	   slasd7_	    
#define slasd8	   slasd8_	    
#define slasd9	   slasd9_	    
#define slasda	   slasda_	    
#define slasdq	   slasdq_	    
#define slasdt	   slasdt_	    
#define slaset	   slaset_	    
#define slasq1	   slasq1_	    
#define slasq2	   slasq2_	    
#define slasq3	   slasq3_	    
#define slasq4	   slasq4_	    
#define slasq5	   slasq5_	    
#define slasq6	   slasq6_	    
#define slasr	   slasr_	    
#define slasrt	   slasrt_	    
#define slassq	   slassq_	    
#define slasv2r	   slasv2r_    
#define slaswp	   slaswp_	    
#define slasy2	   slasy2_	    
#define slasyf	   slasyf_	    
#define slatbs	   slatbs_	    
#define slatdf	   slatdf_	    
#define slatps	   slatps_	    
#define slatrd	   slatrd_	    
#define slatrs	   slatrs_	    
#define slatrz	   slatrz_	    
#define slatzm	   slatzm_	    
#define slauu2	   slauu2_	    
#define slauum	   slauum_	    
#define sopgtr	   sopgtr_	    
#define sopmtr	   sopmtr_	    
#define sorg2l	   sorg2l_	    
#define sorg2r	   sorg2r_	    
#define sorgbr	   sorgbr_	    
#define sorghr	   sorghr_	    
#define sorgl2	   sorgl2_	    
#define sorglq	   sorglq_	    
#define sorgql	   sorgql_	    
#define sorgqr	   sorgqr_	    
#define sorgr2	   sorgr2_	    
#define sorgrq	   sorgrq_	    
#define sorgtr	   sorgtr_	    
#define sorm2l	   sorm2l_	    
#define sorm2r	   sorm2r_	    
#define sormbr	   sormbr_	    
#define sormhr	   sormhr_	    
#define sorml2	   sorml2_	    
#define sormlq	   sormlq_	    
#define sormql	   sormql_	    
#define sormqr	   sormqr_	    
#define sormr2	   sormr2_	    
#define sormr3	   sormr3_	    
#define sormrq	   sormrq_	    
#define sormrz	   sormrz_	    
#define sormtr	   sormtr_	    
#define spbcon	   spbcon_	    
#define spbequ	   spbequ_	    
#define spbrfs	   spbrfs_	    
#define spbstf	   spbstf_	    
#define spbsv	   spbsv_	    
#define spbsvx	   spbsvx_	    
#define spbtf2	   spbtf2_	    
#define spbtrf	   spbtrf_	    
#define spbtrs	   spbtrs_	    
#define spocon	   spocon_	    
#define spoequ	   spoequ_	    
#define sporfs	   sporfs_	    
#define sposv	   sposv_	    
#define sposvx	   sposvx_	    
#define spotf2	   spotf2_	    
#define spotrf	   spotrf_	    
#define spotri	   spotri_	    
#define spotrs	   spotrs_	    
#define sppcon	   sppcon_	    
#define sppequ	   sppequ_	    
#define spprfs	   spprfs_	    
#define sppsv	   sppsv_	    
#define sppsvx	   sppsvx_	    
#define spptrf	   spptrf_	    
#define spptri	   spptri_	    
#define spptrs	   spptrs_	    
#define sptcon	   sptcon_	    
#define spteqr	   spteqr_	    
#define sptrfs	   sptrfs_	    
#define sptsv	   sptsv_	    
#define sptsvx	   sptsvx_	    
#define spttrf	   spttrf_	    
#define spttrs	   spttrs_	    
#define sptts2	   sptts2_	    
#define srscl	   srscl_	    
#define ssbev	   ssbev_	    
#define ssbevd	   ssbevd_	    
#define ssbevx	   ssbevx_	    
#define ssbgst	   ssbgst_	    
#define ssbgv	   ssbgv_	    
#define ssbgvd	   ssbgvd_	    
#define ssbgvx	   ssbgvx_	    
#define ssbtrd	   ssbtrd_	    
#define sspcon	   sspcon_	    
#define sspev	   sspev_	    
#define sspevd	   sspevd_	    
#define sspevx	   sspevx_	    
#define sspgst	   sspgst_	    
#define sspgv	   sspgv_	    
#define sspgvd	   sspgvd_	    
#define sspgvx	   sspgvx_	    
#define ssprfs	   ssprfs_	    
#define sspsv	   sspsv_	    
#define sspsvx	   sspsvx_	    
#define ssptrd	   ssptrd_	    
#define ssptrf	   ssptrf_	    
#define ssptri	   ssptri_	    
#define ssptrs	   ssptrs_	    
#define sstebz	   sstebz_	    
#define sstedc	   sstedc_	    
#define sstegr	   sstegr_	    
#define sstein	   sstein_	    
#define ssteqr	   ssteqr_	    
#define ssterf	   ssterf_	    
#define sstev	   sstev_	    
#define sstevd	   sstevd_	    
#define sstevr	   sstevr_	    
#define sstevx	   sstevx_	    
#define ssycon	   ssycon_	    
#define ssyev	   ssyev_	    
#define ssyevd	   ssyevd_	    
#define ssyevr	   ssyevr_	    
#define ssyevx	   ssyevx_	    
#define ssygs2	   ssygs2_	    
#define ssygst	   ssygst_	    
#define ssygv	   ssygv_	    
#define ssygvd	   ssygvd_	    
#define ssygvx	   ssygvx_	    
#define ssyrfs	   ssyrfs_	    
#define ssysv	   ssysv_	    
#define ssysvx	   ssysvx_	    
#define ssytd2	   ssytd2_	    
#define ssytf2	   ssytf2_	    
#define ssytrd	   ssytrd_	    
#define ssytrf	   ssytrf_	    
#define ssytri	   ssytri_	    
#define ssytrs	   ssytrs_	    
#define stbcon	   stbcon_	    
#define stbrfs	   stbrfs_	    
#define stbtrs	   stbtrs_	    
#define stgevc	   stgevc_	    
#define stgex2	   stgex2_	    
#define stgexc	   stgexc_	    
#define stgsen	   stgsen_	    
#define stgsja	   stgsja_	    
#define stgsna	   stgsna_	    
#define stgsy2	   stgsy2_	    
#define stgsyl	   stgsyl_	    
#define stpcon	   stpcon_	    
#define stprfs	   stprfs_	    
#define stptri	   stptri_	    
#define stptrs	   stptrs_	    
#define strcon	   strcon_	    
#define strevc	   strevc_	    
#define strexc	   strexc_	    
#define strrfs	   strrfs_	    
#define strsen	   strsen_	    
#define strsna	   strsna_	    
#define strsyl	   strsyl_	    
#define strti2	   strti2_	    
#define strtri	   strtri_	    
#define strtrs	   strtrs_	    
#define stzrqf	   stzrqf_	    
#define stzrzf	   stzrzf_	    
#define xerbla	   xerbla_	    
#define zbdsqr	   zbdsqr_	    
#define zdrot	   zdrot_	    
#define zdrscl	   zdrscl_	    
#define zgbbrd	   zgbbrd_	    
#define zgbcon	   zgbcon_	    
#define zgbequ	   zgbequ_	    
#define zgbrfs	   zgbrfs_	    
#define zgbsv	   zgbsv_	    
#define zgbsvx	   zgbsvx_	    
#define zgbtf2	   zgbtf2_	    
#define zgbtrf	   zgbtrf_	    
#define zgbtrs	   zgbtrs_	    
#define zgebak	   zgebak_	    
#define zgebal	   zgebal_	    
#define zgebd2	   zgebd2_	    
#define zgebrd	   zgebrd_	    
#define zgecon	   zgecon_	    
#define zgeequ	   zgeequ_	    
#define zgees	   zgees_	    
#define zgeesx	   zgeesx_	    
#define zgeev	   zgeev_	    
#define zgeevx	   zgeevx_	    
#define zgegs	   zgegs_	    
#define zgegv	   zgegv_	    
#define zgehd2	   zgehd2_	    
#define zgehrd	   zgehrd_	    
#define zgelq2	   zgelq2_	    
#define zgelqf	   zgelqf_	    
#define zgels	   zgels_	    
#define zgelsd	   zgelsd_	    
#define zgelss	   zgelss_	    
#define zgelsx	   zgelsx_	    
#define zgelsy	   zgelsy_	    
#define zgeql2	   zgeql2_	    
#define zgeqlf	   zgeqlf_	    
#define zgeqp3	   zgeqp3_	    
#define zgeqpf	   zgeqpf_	    
#define zgeqr2	   zgeqr2_	    
#define zgeqrf	   zgeqrf_	    
#define zgerfs	   zgerfs_	    
#define zgerq2	   zgerq2_	    
#define zgerqf	   zgerqf_	    
#define zgesc2	   zgesc2_	    
#define zgesdd	   zgesdd_	    
#define zgesv	   zgesv_	    
#define zgesvd	   zgesvd_	    
#define zgesvx	   zgesvx_	    
#define zgetc2	   zgetc2_	    
#define zgetf2	   zgetf2_	    
#define zgetrf	   zgetrf_	    
#define zgetri	   zgetri_	    
#define zgetrs	   zgetrs_	    
#define zggbak	   zggbak_	    
#define zggbal	   zggbal_	    
#define zgges	   zgges_	    
#define zggesx	   zggesx_	    
#define zggev	   zggev_	    
#define zggevx	   zggevx_	    
#define zggglm	   zggglm_	    
#define zgghrd	   zgghrd_	    
#define zgglse	   zgglse_	    
#define zggqrf	   zggqrf_	    
#define zggrqf	   zggrqf_	    
#define zggsvd	   zggsvd_	    
#define zggsvp	   zggsvp_	    
#define zgtcon	   zgtcon_	    
#define zgtrfs	   zgtrfs_	    
#define zgtsv	   zgtsv_	    
#define zgtsvx	   zgtsvx_	    
#define zgttrf	   zgttrf_	    
#define zgttrs	   zgttrs_	    
#define zgtts2	   zgtts2_	    
#define zhbev	   zhbev_	    
#define zhbevd	   zhbevd_	    
#define zhbevx	   zhbevx_	    
#define zhbgst	   zhbgst_	    
#define zhbgv	   zhbgv_	    
#define zhbgvd	   zhbgvd_	    
#define zhbgvx	   zhbgvx_	    
#define zhbtrd	   zhbtrd_	    
#define zhecon	   zhecon_	    
#define zheev	   zheev_	    
#define zheevd	   zheevd_	    
#define zheevr	   zheevr_	    
#define zheevx	   zheevx_	    
#define zhegs2	   zhegs2_	    
#define zhegst	   zhegst_	    
#define zhegv	   zhegv_	    
#define zhegvd	   zhegvd_	    
#define zhegvx	   zhegvx_	    
#define zherfs	   zherfs_	    
#define zhesv	   zhesv_	    
#define zhesvx	   zhesvx_	    
#define zhetd2	   zhetd2_	    
#define zhetf2	   zhetf2_	    
#define zhetrd	   zhetrd_	    
#define zhetrf	   zhetrf_	    
#define zhetri	   zhetri_	    
#define zhetrs	   zhetrs_	    
#define zhgeqz	   zhgeqz_	    
#define zhpcon	   zhpcon_	    
#define zhpev	   zhpev_	    
#define zhpevd	   zhpevd_	    
#define zhpevx	   zhpevx_	    
#define zhpgst	   zhpgst_	    
#define zhpgv	   zhpgv_	    
#define zhpgvd	   zhpgvd_	    
#define zhpgvx	   zhpgvx_	    
#define zhprfs	   zhprfs_	    
#define zhpsv	   zhpsv_	    
#define zhpsvx	   zhpsvx_	    
#define zhptrd	   zhptrd_	    
#define zhptrf	   zhptrf_	    
#define zhptri	   zhptri_	    
#define zhptrs	   zhptrs_	    
#define zhsein	   zhsein_	    
#define zhseqr	   zhseqr_	    
#define zlabrd	   zlabrd_	    
#define zlacgv	   zlacgv_	    
#define zlacon	   zlacon_	    
#define zlacp2	   zlacp2_	    
#define zlacpy	   zlacpy_	    
#define zlacrm	   zlacrm_	    
#define zlacrt	   zlacrt_	    
#define zladiv	   zladiv_	    
#define zlaed0	   zlaed0_	    
#define zlaed7	   zlaed7_	    
#define zlaed8	   zlaed8_	    
#define zlaein	   zlaein_	    
#define zlaesy	   zlaesy_	    
#define zlaev2	   zlaev2_	    
#define zlags2	   zlags2_	    
#define zlagtm	   zlagtm_	    
#define zlahef	   zlahef_	    
#define zlahqr	   zlahqr_	    
#define zlahrd	   zlahrd_	    
#define zlaic1	   zlaic1_	    
#define zlals0	   zlals0_	    
#define zlalsa	   zlalsa_	    
#define zlalsd	   zlalsd_	    
#define zlangb	   zlangb_	    
#define zlange	   zlange_	    
#define zlangt	   zlangt_	    
#define zlanhb	   zlanhb_	    
#define zlanhe	   zlanhe_	    
#define zlanhp	   zlanhp_	    
#define zlanhs	   zlanhs_	    
#define zlanht	   zlanht_	    
#define zlansb	   zlansb_	    
#define zlansp	   zlansp_	    
#define zlansy	   zlansy_	    
#define zlantb	   zlantb_	    
#define zlantp	   zlantp_	    
#define zlantr	   zlantr_	    
#define zlapll	   zlapll_	    
#define zlapmt	   zlapmt_	    
#define zlaqgb	   zlaqgb_	    
#define zlaqge	   zlaqge_	    
#define zlaqhb	   zlaqhb_	    
#define zlaqhe	   zlaqhe_	    
#define zlaqhp	   zlaqhp_	    
#define zlaqp2	   zlaqp2_	    
#define zlaqps	   zlaqps_	    
#define zlaqsb	   zlaqsb_	    
#define zlaqsp	   zlaqsp_	    
#define zlaqsy	   zlaqsy_	    
#define zlar1v	   zlar1v_	    
#define zlar2v	   zlar2v_	    
#define zlarcm	   zlarcm_	    
#define zlarf	   zlarf_	    
#define zlarfb	   zlarfb_	    
#define zlarfg	   zlarfg_	    
#define zlarft	   zlarft_	    
#define zlarfx	   zlarfx_	    
#define zlargv	   zlargv_	    
#define zlarnv	   zlarnv_	    
#define zlarrv	   zlarrv_	    
#define zlartg	   zlartg_	    
#define zlartv	   zlartv_	    
#define zlarz	   zlarz_	    
#define zlarzb	   zlarzb_	    
#define zlarzt	   zlarzt_	    
#define zlascl	   zlascl_	    
#define zlaset	   zlaset_	    
#define zlasr	   zlasr_	    
#define zlassq	   zlassq_	    
#define zlaswp	   zlaswp_	    
#define zlasyf	   zlasyf_	    
#define zlatbs	   zlatbs_	    
#define zlatdf	   zlatdf_	    
#define zlatps	   zlatps_	    
#define zlatrd	   zlatrd_	    
#define zlatrs	   zlatrs_	    
#define zlatrz	   zlatrz_	    
#define zlatzm	   zlatzm_	    
#define zlauu2	   zlauu2_	    
#define zlauum	   zlauum_	    
#define zpbcon	   zpbcon_	    
#define zpbequ	   zpbequ_	    
#define zpbrfs	   zpbrfs_	    
#define zpbstf	   zpbstf_	    
#define zpbsv	   zpbsv_	    
#define zpbsvx	   zpbsvx_	    
#define zpbtf2	   zpbtf2_	    
#define zpbtrf	   zpbtrf_	    
#define zpbtrs	   zpbtrs_	    
#define zpocon	   zpocon_	    
#define zpoequ	   zpoequ_	    
#define zporfs	   zporfs_	    
#define zposv	   zposv_	    
#define zposvx	   zposvx_	    
#define zpotf2	   zpotf2_	    
#define zpotrf	   zpotrf_	    
#define zpotri	   zpotri_	    
#define zpotrs	   zpotrs_	    
#define zppcon	   zppcon_	    
#define zppequ	   zppequ_	    
#define zpprfs	   zpprfs_	    
#define zppsv	   zppsv_	    
#define zppsvx	   zppsvx_	    
#define zpptrf	   zpptrf_	    
#define zpptri	   zpptri_	    
#define zpptrs	   zpptrs_	    
#define zptcon	   zptcon_	    
#define zpteqr	   zpteqr_	    
#define zptrfs	   zptrfs_	    
#define zptsv	   zptsv_	    
#define zptsvx	   zptsvx_	    
#define zpttrf	   zpttrf_	    
#define zpttrs	   zpttrs_	    
#define zptts2	   zptts2_	    
#define zrotn	   zrotn_	    
#define zspcon	   zspcon_	    
#define zspmv	   zspmv_	    
#define zspru	   zspru_	    
#define zsprfs	   zsprfs_	    
#define zspsv	   zspsv_	    
#define zspsvx	   zspsvx_	    
#define zsptrf	   zsptrf_	    
#define zsptri	   zsptri_	    
#define zsptrs	   zsptrs_	    
#define zstedc	   zstedc_	    
#define zstegr	   zstegr_	    
#define zstein	   zstein_	    
#define zsteqr	   zsteqr_	    
#define zsycon	   zsycon_	    
#define zsymv	   zsymv_	    
#define zsyru	   zsyru_	    
#define zsyrfs	   zsyrfs_	    
#define zsysv	   zsysv_	    
#define zsysvx	   zsysvx_	    
#define zsytf2	   zsytf2_	    
#define zsytrf	   zsytrf_	    
#define zsytri	   zsytri_	    
#define zsytrs	   zsytrs_	    
#define ztbcon	   ztbcon_	    
#define ztbrfs	   ztbrfs_	    
#define ztbtrs	   ztbtrs_	    
#define ztgevc	   ztgevc_	    
#define ztgex2	   ztgex2_	    
#define ztgexc	   ztgexc_	    
#define ztgsen	   ztgsen_	    
#define ztgsja	   ztgsja_	    
#define ztgsna	   ztgsna_	    
#define ztgsy2	   ztgsy2_	    
#define ztgsyl	   ztgsyl_	    
#define ztpcon	   ztpcon_	    
#define ztprfs	   ztprfs_	    
#define ztptri	   ztptri_	    
#define ztptrs	   ztptrs_	    
#define ztrcon	   ztrcon_	    
#define ztrevc	   ztrevc_	    
#define ztrexc	   ztrexc_	    
#define ztrrfs	   ztrrfs_	    
#define ztrsen	   ztrsen_	    
#define ztrsna	   ztrsna_	    
#define ztrsyl	   ztrsyl_	    
#define ztrti2	   ztrti2_	    
#define ztrtri	   ztrtri_	    
#define ztrtrs	   ztrtrs_	    
#define ztzrqf	   ztzrqf_	    
#define ztzrzf	   ztzrzf_	    
#define zung2l	   zung2l_	    
#define zung2r	   zung2r_	    
#define zungbr	   zungbr_	    
#define zunghr	   zunghr_	    
#define zungl2	   zungl2_	    
#define zunglq	   zunglq_	    
#define zungql	   zungql_	    
#define zungqr	   zungqr_	    
#define zungr2	   zungr2_	    
#define zungrq	   zungrq_	    
#define zungtr	   zungtr_	    
#define zunm2l	   zunm2l_	    
#define zunm2r	   zunm2r_	    
#define zunmbr	   zunmbr_	    
#define zunmhr	   zunmhr_	    
#define zunml2	   zunml2_	    
#define zunmlq	   zunmlq_	    
#define zunmql	   zunmql_	    
#define zunmqr	   zunmqr_	    
#define zunmr2	   zunmr2_	    
#define zunmr3	   zunmr3_	    
#define zunmrq	   zunmrq_	    
#define zunmrz	   zunmrz_	    
#define zunmtr	   zunmtr_	    
#define zupgtr	   zupgtr_	    
#define zupmtr	   zupmtr_     


/* both are defined */
#elif defined __CAPS__ && defined __UNDERSCORE__ && !defined __2UNDERSCORES__

#define cbdsqr     CBDSQR_	    
#define cgbbrd	   CGBBRD_	    
#define cgbcon	   CGBCON_	    
#define cgbequ	   CGBEQU_	    
#define cgbrfs	   CGBRFS_	    
#define cgbsv	   CGBSV_	    
#define cgbsvx	   CGBSVX_	    
#define cgbtf2	   CGBTF2_	    
#define cgbtrf	   CGBTRF_	    
#define cgbtrs	   CGBTRS_	    
#define cgebak	   CGEBAK_	    
#define cgebal	   CGEBAL_	    
#define cgebd2	   CGEBD2_	    
#define cgebrd	   CGEBRD_	    
#define cgecon	   CGECON_	    
#define cgeequ	   CGEEQU_	    
#define cgees	   CGEES_	    
#define cgeesx	   CGEESX_	    
#define cgeev	   CGEEV_	    
#define cgeevx	   CGEEVX_	    
#define cgegs	   CGEGS_	    
#define cgegv	   CGEGV_	    
#define cgehd2	   CGEHD2_	    
#define cgehrd	   CGEHRD_	    
#define cgelq2	   CGELQ2_	    
#define cgelqf	   CGELQF_	    
#define cgels	   CGELS_	    
#define cgelsd	   CGELSD_	    
#define cgelss	   CGELSS_	    
#define cgelsx	   CGELSX_	    
#define cgelsy	   CGELSY_	    
#define cgeql2	   CGEQL2_	    
#define cgeqlf	   CGEQLF_	    
#define cgeqp3	   CGEQP3_	    
#define cgeqpf	   CGEQPF_	    
#define cgeqr2	   CGEQR2_	    
#define cgeqrf	   CGEQRF_	    
#define cgerfs	   CGERFS_	    
#define cgerq2	   CGERQ2_	    
#define cgerqf	   CGERQF_	    
#define cgesc2	   CGESC2_	    
#define cgesdd	   CGESDD_	    
#define cgesv	   CGESV_	    
#define cgesvd	   CGESVD_	    
#define cgesvx	   CGESVX_	    
#define cgetc2	   CGETC2_	    
#define cgetf2	   CGETF2_	    
#define cgetrf	   CGETRF_	    
#define cgetri	   CGETRI_	    
#define cgetrs	   CGETRS_	    
#define cggbak	   CGGBAK_	    
#define cggbal	   CGGBAL_	    
#define cgges	   CGGES_	    
#define cggesx	   CGGESX_	    
#define cggev	   CGGEV_	    
#define cggevx	   CGGEVX_	    
#define cggglm	   CGGGLM_	    
#define cgghrd	   CGGHRD_	    
#define cgglse	   CGGLSE_	    
#define cggqrf	   CGGQRF_	    
#define cggrqf	   CGGRQF_	    
#define cggsvd	   CGGSVD_	    
#define cggsvp	   CGGSVP_	    
#define cgtcon	   CGTCON_	    
#define cgtrfs	   CGTRFS_	    
#define cgtsv	   CGTSV_	    
#define cgtsvx	   CGTSVX_	    
#define cgttrf	   CGTTRF_	    
#define cgttrs	   CGTTRS_	    
#define cgtts2	   CGTTS2_	    
#define chbev	   CHBEV_	    
#define chbevd	   CHBEVD_	    
#define chbevx	   CHBEVX_	    
#define chbgst	   CHBGST_	    
#define chbgv	   CHBGV_	    
#define chbgvd	   CHBGVD_	    
#define chbgvx	   CHBGVX_	    
#define chbtrd	   CHBTRD_	    
#define checon	   CHECON_	    
#define cheev	   CHEEV_	    
#define cheevd	   CHEEVD_	    
#define cheevr	   CHEEVR_	    
#define cheevx	   CHEEVX_	    
#define chegs2	   CHEGS2_	    
#define chegst	   CHEGST_	    
#define chegv	   CHEGV_	    
#define chegvd	   CHEGVD_	    
#define chegvx	   CHEGVX_	    
#define cherfs	   CHERFS_	    
#define chesv	   CHESV_	    
#define chesvx	   CHESVX_	    
#define chetd2	   CHETD2_	    
#define chetf2	   CHETF2_	    
#define chetrd	   CHETRD_	    
#define chetrf	   CHETRF_	    
#define chetri	   CHETRI_	    
#define chetrs	   CHETRS_	    
#define chgeqz	   CHGEQZ_	    
#define chpcon	   CHPCON_	    
#define chpev	   CHPEV_	    
#define chpevd	   CHPEVD_	    
#define chpevx	   CHPEVX_	    
#define chpgst	   CHPGST_	    
#define chpgv	   CHPGV_	    
#define chpgvd	   CHPGVD_	    
#define chpgvx	   CHPGVX_	    
#define chprfs	   CHPRFS_	    
#define chpsv	   CHPSV_	    
#define chpsvx	   CHPSVX_	    
#define chptrd	   CHPTRD_	    
#define chptrf	   CHPTRF_	    
#define chptri	   CHPTRI_	    
#define chptrs	   CHPTRS_	    
#define chsein	   CHSEIN_	    
#define chseqr	   CHSEQR_	    
#define clabrd	   CLABRD_	    
#define clacgv	   CLACGV_	    
#define clacon	   CLACON_	    
#define clacp2	   CLACP2_	    
#define clacpy	   CLACPY_	    
#define clacrm	   CLACRM_	    
#define clacrt	   CLACRT_	    
#define cladiv	   CLADIV_	    
#define claed0	   CLAED0_	    
#define claed7	   CLAED7_	    
#define claed8	   CLAED8_	    
#define claein	   CLAEIN_	    
#define claesy	   CLAESY_	    
#define claev2	   CLAEV2_	    
#define clags2	   CLAGS2_	    
#define clagtm	   CLAGTM_	    
#define clahef	   CLAHEF_	    
#define clahqr	   CLAHQR_	    
#define clahrd	   CLAHRD_	    
#define claic1	   CLAIC1_	    
#define clals0	   CLALS0_	    
#define clalsa	   CLALSA_	    
#define clalsd	   CLALSD_	    
#define clangb	   CLANGB_	    
#define clange	   CLANGE_	    
#define clangt	   CLANGT_	    
#define clanhb	   CLANHB_	    
#define clanhe	   CLANHE_	    
#define clanhp	   CLANHP_	    
#define clanhs	   CLANHS_	    
#define clanht	   CLANHT_	    
#define clansb	   CLANSB_	    
#define clansp	   CLANSP_	    
#define clansy	   CLANSY_	    
#define clantb	   CLANTB_	    
#define clantp	   CLANTP_	    
#define clantr	   CLANTR_	    
#define clapll	   CLAPLL_	    
#define clapmt	   CLAPMT_	    
#define claqgb	   CLAQGB_	    
#define claqge	   CLAQGE_	    
#define claqhb	   CLAQHB_	    
#define claqhe	   CLAQHE_	    
#define claqhp	   CLAQHP_	    
#define claqp2	   CLAQP2_	    
#define claqps	   CLAQPS_	    
#define claqsb	   CLAQSB_	    
#define claqsp	   CLAQSP_	    
#define claqsy	   CLAQSY_	    
#define clar1v	   CLAR1V_	    
#define clar2v	   CLAR2V_	    
#define clarcm	   CLARCM_	    
#define clarf	   CLARF_	    
#define clarfb	   CLARFB_	    
#define clarfg	   CLARFG_	    
#define clarft	   CLARFT_	    
#define clarfx	   CLARFX_	    
#define clargv	   CLARGV_	    
#define clarnv	   CLARNV_	    
#define clarrv	   CLARRV_	    
#define clartg	   CLARTG_	    
#define clartv	   CLARTV_	    
#define clarz	   CLARZ_	    
#define clarzb	   CLARZB_	    
#define clarzt	   CLARZT_	    
#define clascl	   CLASCL_	    
#define claset	   CLASET_	    
#define clasr	   CLASR_	    
#define classq	   CLASSQ_	    
#define claswp	   CLASWP_	    
#define clasyf	   CLASYF_	    
#define clatbs	   CLATBS_	    
#define clatdf	   CLATDF_	    
#define clatps	   CLATPS_	    
#define clatrd	   CLATRD_	    
#define clatrs	   CLATRS_	    
#define clatrz	   CLATRZ_	    
#define clatzm	   CLATZM_	    
#define clauu2	   CLAUU2_	    
#define clauum	   CLAUUM_	    
#define cpbcon	   CPBCON_	    
#define cpbequ	   CPBEQU_	    
#define cpbrfs	   CPBRFS_	    
#define cpbstf	   CPBSTF_	    
#define cpbsv	   CPBSV_	    
#define cpbsvx	   CPBSVX_	    
#define cpbtf2	   CPBTF2_	    
#define cpbtrf	   CPBTRF_	    
#define cpbtrs	   CPBTRS_	    
#define cpocon	   CPOCON_	    
#define cpoequ	   CPOEQU_	    
#define cporfs	   CPORFS_	    
#define cposv	   CPOSV_	    
#define cposvx	   CPOSVX_	    
#define cpotf2	   CPOTF2_	    
#define cpotrf	   CPOTRF_	    
#define cpotri	   CPOTRI_	    
#define cpotrs	   CPOTRS_	    
#define cppcon	   CPPCON_	    
#define cppequ	   CPPEQU_	    
#define cpprfs	   CPPRFS_	    
#define cppsv	   CPPSV_	    
#define cppsvx	   CPPSVX_	    
#define cpptrf	   CPPTRF_	    
#define cpptri	   CPPTRI_	    
#define cpptrs	   CPPTRS_	    
#define cptcon	   CPTCON_	    
#define cpteqr	   CPTEQR_	    
#define cptrfs	   CPTRFS_	    
#define cptsv	   CPTSV_	    
#define cptsvx	   CPTSVX_	    
#define cpttrf	   CPTTRF_	    
#define cpttrs	   CPTTRS_	    
#define cptts2	   CPTTS2_	    
#define crotn	   CROTN_	    
#define cspcon	   CSPCON_	    
#define cspmv	   CSPMV_	    
#define cspru	   CSPRU_	    
#define csprfs	   CSPRFS_	    
#define cspsv	   CSPSV_	    
#define cspsvx	   CSPSVX_	    
#define csptrf	   CSPTRF_	    
#define csptri	   CSPTRI_	    
#define csptrs	   CSPTRS_	    
#define csrot	   CSROT_	    
#define csrscl	   CSRSCL_	    
#define cstedc	   CSTEDC_	    
#define cstegr	   CSTEGR_	    
#define cstein	   CSTEIN_	    
#define csteqr	   CSTEQR_	    
#define csycon	   CSYCON_	    
#define csymv	   CSYMV_	    
#define csyru	   CSYRU_	    
#define csyrfs	   CSYRFS_	    
#define csysv	   CSYSV_	    
#define csysvx	   CSYSVX_	    
#define csytf2	   CSYTF2_	    
#define csytrf	   CSYTRF_	    
#define csytri	   CSYTRI_	    
#define csytrs	   CSYTRS_	    
#define ctbcon	   CTBCON_	    
#define ctbrfs	   CTBRFS_	    
#define ctbtrs	   CTBTRS_	    
#define ctgevc	   CTGEVC_	    
#define ctgex2	   CTGEX2_	    
#define ctgexc	   CTGEXC_	    
#define ctgsen	   CTGSEN_	    
#define ctgsja	   CTGSJA_	    
#define ctgsna	   CTGSNA_	    
#define ctgsy2	   CTGSY2_	    
#define ctgsyl	   CTGSYL_	    
#define ctpcon	   CTPCON_	    
#define ctprfs	   CTPRFS_	    
#define ctptri	   CTPTRI_	    
#define ctptrs	   CTPTRS_	    
#define ctrcon	   CTRCON_	    
#define ctrevc	   CTREVC_	    
#define ctrexc	   CTREXC_	    
#define ctrrfs	   CTRRFS_	    
#define ctrsen	   CTRSEN_	    
#define ctrsna	   CTRSNA_	    
#define ctrsyl	   CTRSYL_	    
#define ctrti2	   CTRTI2_	    
#define ctrtri	   CTRTRI_	    
#define ctrtrs	   CTRTRS_	    
#define ctzrqf	   CTZRQF_	    
#define ctzrzf	   CTZRZF_	    
#define cung2l	   CUNG2L_	    
#define cung2r	   CUNG2R_	    
#define cungbr	   CUNGBR_	    
#define cunghr	   CUNGHR_	    
#define cungl2	   CUNGL2_	    
#define cunglq	   CUNGLQ_	    
#define cungql	   CUNGQL_	    
#define cungqr	   CUNGQR_	    
#define cungr2	   CUNGR2_	    
#define cungrq	   CUNGRQ_	    
#define cungtr	   CUNGTR_	    
#define cunm2l	   CUNM2L_	    
#define cunm2r	   CUNM2R_	    
#define cunmbr	   CUNMBR_	    
#define cunmhr	   CUNMHR_	    
#define cunml2	   CUNML2_	    
#define cunmlq	   CUNMLQ_	    
#define cunmql	   CUNMQL_	    
#define cunmqr	   CUNMQR_	    
#define cunmr2	   CUNMR2_	    
#define cunmr3	   CUNMR3_	    
#define cunmrq	   CUNMRQ_	    
#define cunmrz	   CUNMRZ_	    
#define cunmtr	   CUNMTR_	    
#define cupgtr	   CUPGTR_	    
#define cupmtr	   CUPMTR_	    
#define dbdsdc	   DBDSDC_	    
#define dbdsqr	   DBDSQR_	    
#define ddisna	   DDISNA_	    
#define dgbbrd	   DGBBRD_	    
#define dgbcon	   DGBCON_	    
#define dgbequ	   DGBEQU_	    
#define dgbrfs	   DGBRFS_	    
#define dgbsv	   DGBSV_	    
#define dgbsvx	   DGBSVX_	    
#define dgbtf2	   DGBTF2_	    
#define dgbtrf	   DGBTRF_	    
#define dgbtrs	   DGBTRS_	    
#define dgebak	   DGEBAK_	    
#define dgebal	   DGEBAL_	    
#define dgebd2	   DGEBD2_	    
#define dgebrd	   DGEBRD_	    
#define dgecon	   DGECON_	    
#define dgeequ	   DGEEQU_	    
#define dgees	   DGEES_	    
#define dgeesx	   DGEESX_	    
#define dgeev	   DGEEV_	    
#define dgeevx	   DGEEVX_	    
#define dgegs	   DGEGS_	    
#define dgegv	   DGEGV_	    
#define dgehd2	   DGEHD2_	    
#define dgehrd	   DGEHRD_	    
#define dgelq2	   DGELQ2_	    
#define dgelqf	   DGELQF_	    
#define dgels	   DGELS_	    
#define dgelsd	   DGELSD_	    
#define dgelss	   DGELSS_	    
#define dgelsx	   DGELSX_	    
#define dgelsy	   DGELSY_	    
#define dgeql2	   DGEQL2_	    
#define dgeqlf	   DGEQLF_	    
#define dgeqp3	   DGEQP3_	    
#define dgeqpf	   DGEQPF_	    
#define dgeqr2	   DGEQR2_	    
#define dgeqrf	   DGEQRF_	    
#define dgerfs	   DGERFS_	    
#define dgerq2	   DGERQ2_	    
#define dgerqf	   DGERQF_	    
#define dgesc2	   DGESC2_	    
#define dgesdd	   DGESDD_	    
#define dgesv	   DGESV_	    
#define dgesvd	   DGESVD_	    
#define dgesvx	   DGESVX_	    
#define dgetc2	   DGETC2_	    
#define dgetf2	   DGETF2_	    
#define dgetrf	   DGETRF_	    
#define dgetri	   DGETRI_	    
#define dgetrs	   DGETRS_	    
#define dggbak	   DGGBAK_	    
#define dggbal	   DGGBAL_	    
#define dgges	   DGGES_	    
#define dggesx	   DGGESX_	    
#define dggev	   DGGEV_	    
#define dggevx	   DGGEVX_	    
#define dggglm	   DGGGLM_	    
#define dgghrd	   DGGHRD_	    
#define dgglse	   DGGLSE_	    
#define dggqrf	   DGGQRF_	    
#define dggrqf	   DGGRQF_	    
#define dggsvd	   DGGSVD_	    
#define dggsvp	   DGGSVP_	    
#define dgtcon	   DGTCON_	    
#define dgtrfs	   DGTRFS_	    
#define dgtsv	   DGTSV_	    
#define dgtsvx	   DGTSVX_	    
#define dgttrf	   DGTTRF_	    
#define dgttrs	   DGTTRS_	    
#define dgtts2	   DGTTS2_	    
#define dhgeqz	   DHGEQZ_	    
#define dhsein	   DHSEIN_	    
#define dhseqr	   DHSEQR_	    
#define dlabad	   DLABAD_	    
#define dlabrd	   DLABRD_	    
#define dlacon	   DLACON_	    
#define dlacpy	   DLACPY_	    
#define dladiv	   DLADIV_	    
#define dlae2a	   DLAE2A_	    
#define dlaebz	   DLAEBZ_	    
#define dlaed0	   DLAED0_	    
#define dlaed1	   DLAED1_	    
#define dlaed2	   DLAED2_	    
#define dlaed3	   DLAED3_	    
#define dlaed4	   DLAED4_	    
#define dlaed5	   DLAED5_	    
#define dlaed6	   DLAED6_	    
#define dlaed7	   DLAED7_	    
#define dlaed8	   DLAED8_	    
#define dlaed9	   DLAED9_	    
#define dlaeda	   DLAEDA_	    
#define dlaein	   DLAEIN_	    
#define dlaev2	   DLAEV2_	    
#define dlaexc	   DLAEXC_	    
#define dlag2a	   DLAG2A_	    
#define dlags2	   DLAGS2_	    
#define dlagtf	   DLAGTF_	    
#define dlagtm	   DLAGTM_	    
#define dlagts	   DLAGTS_	    
#define dlagv2	   DLAGV2_	    
#define dlahqr	   DLAHQR_	    
#define dlahrd	   DLAHRD_	    
#define dlaic1	   DLAIC1_	    
#define dlaln2	   DLALN2_	    
#define dlals0	   DLALS0_	    
#define dlalsa	   DLALSA_	    
#define dlalsd	   DLALSD_	    
#define dlamch	   DLAMCH_	    
#define dlamc1	   DLAMC1_	    
#define dlamc2	   DLAMC2_	    
#define dlamc3	   DLAMC3_	    
#define dlamc4	   DLAMC4_	    
#define dlamc5	   DLAMC5_	    
#define dlamrg	   DLAMRG_	    
#define dlangb	   DLANGB_	    
#define dlange	   DLANGE_	    
#define dlangt	   DLANGT_	    
#define dlanhs	   DLANHS_	    
#define dlansb	   DLANSB_	    
#define dlansp	   DLANSP_	    
#define dlanst	   DLANST_	    
#define dlansy	   DLANSY_	    
#define dlantb	   DLANTB_	    
#define dlantp	   DLANTP_	    
#define dlantr	   DLANTR_	    
#define dlanv2	   DLANV2_	    
#define dlapll	   DLAPLL_	    
#define dlapmt	   DLAPMT_	    
#define dlapy2	   DLAPY2_	    
#define dlapy3	   DLAPY3_	    
#define dlaqgb	   DLAQGB_	    
#define dlaqge	   DLAQGE_	    
#define dlaqp2	   DLAQP2_	    
#define dlaqps	   DLAQPS_	    
#define dlaqsb	   DLAQSB_	    
#define dlaqsp	   DLAQSP_	    
#define dlaqsy	   DLAQSY_	    
#define dlaqtr	   DLAQTR_	    
#define dlar1v	   DLAR1V_	    
#define dlar2v	   DLAR2V_	    
#define dlarf	   DLARF_	    
#define dlarfb	   DLARFB_	    
#define dlarfg	   DLARFG_	    
#define dlarft	   DLARFT_	    
#define dlarfx	   DLARFX_	    
#define dlargv	   DLARGV_	    
#define dlarnv	   DLARNV_	    
#define dlarrb	   DLARRB_	    
#define dlarre	   DLARRE_	    
#define dlarrf	   DLARRF_	    
#define dlarrv	   DLARRV_	    
#define dlartg	   DLARTG_	    
#define dlartv	   DLARTV_	    
#define dlaruv	   DLARUV_	    
#define dlarz	   DLARZ_	    
#define dlarzb	   DLARZB_	    
#define dlarzt	   DLARZT_	    
#define dlas2f	   DLAS2F_	    
#define dlascl	   DLASCL_	    
#define dlasd0	   DLASD0_	    
#define dlasd1	   DLASD1_	    
#define dlasd2	   DLASD2_	    
#define dlasd3	   DLASD3_	    
#define dlasd4	   DLASD4_	    
#define dlasd5	   DLASD5_	    
#define dlasd6	   DLASD6_	    
#define dlasd7	   DLASD7_	    
#define dlasd8	   DLASD8_	    
#define dlasd9	   DLASD9_	    
#define dlasda	   DLASDA_	    
#define dlasdq	   DLASDQ_	    
#define dlasdt	   DLASDT_	    
#define dlaset	   DLASET_	    
#define dlasq1	   DLASQ1_	    
#define dlasq2	   DLASQ2_	    
#define dlasq3	   DLASQ3_	    
#define dlasq4	   DLASQ4_	    
#define dlasq5	   DLASQ5_	    
#define dlasq6	   DLASQ6_	    
#define dlasr	   DLASR_	    
#define dlasrt	   DLASRT_	    
#define dlassq	   DLASSQ_	    
#define dlasv2	   DLASV2_	    
#define dlaswp	   DLASWP_	    
#define dlasy2	   DLASY2_	    
#define dlasyf	   DLASYF_	    
#define dlatbs	   DLATBS_	    
#define dlatdf	   DLATDF_	    
#define dlatps	   DLATPS_	    
#define dlatrd	   DLATRD_	    
#define dlatrs	   DLATRS_	    
#define dlatrz	   DLATRZ_	    
#define dlatzm	   DLATZM_	    
#define dlauu2	   DLAUU2_	    
#define dlauum	   DLAUUM_	    
#define dopgtr	   DOPGTR_	    
#define dopmtr	   DOPMTR_	    
#define dorg2l	   DORG2L_	    
#define dorg2r	   DORG2R_	    
#define dorgbr	   DORGBR_	    
#define dorghr	   DORGHR_	    
#define dorgl2	   DORGL2_	    
#define dorglq	   DORGLQ_	    
#define dorgql	   DORGQL_	    
#define dorgqr	   DORGQR_	    
#define dorgr2	   DORGR2_	    
#define dorgrq	   DORGRQ_	    
#define dorgtr	   DORGTR_	    
#define dorm2l	   DORM2L_	    
#define dorm2r	   DORM2R_	    
#define dormbr	   DORMBR_	    
#define dormhr	   DORMHR_	    
#define dorml2	   DORML2_	    
#define dormlq	   DORMLQ_	    
#define dormql	   DORMQL_	    
#define dormqr	   DORMQR_	    
#define dormr2	   DORMR2_	    
#define dormr3	   DORMR3_	    
#define dormrq	   DORMRQ_	    
#define dormrz	   DORMRZ_	    
#define dormtr	   DORMTR_	    
#define dpbcon	   DPBCON_	    
#define dpbequ	   DPBEQU_	    
#define dpbrfs	   DPBRFS_	    
#define dpbstf	   DPBSTF_	    
#define dpbsv	   DPBSV_	    
#define dpbsvx	   DPBSVX_	    
#define dpbtf2	   DPBTF2_	    
#define dpbtrf	   DPBTRF_	    
#define dpbtrs	   DPBTRS_	    
#define dpocon	   DPOCON_	    
#define dpoequ	   DPOEQU_	    
#define dporfs	   DPORFS_	    
#define dposv	   DPOSV_	    
#define dposvx	   DPOSVX_	    
#define dpotf2	   DPOTF2_	    
#define dpotrf	   DPOTRF_	    
#define dpotri	   DPOTRI_	    
#define dpotrs	   DPOTRS_	    
#define dppcon	   DPPCON_	    
#define dppequ	   DPPEQU_	    
#define dpprfs	   DPPRFS_	    
#define dppsv	   DPPSV_	    
#define dppsvx	   DPPSVX_	    
#define dpptrf	   DPPTRF_	    
#define dpptri	   DPPTRI_	    
#define dpptrs	   DPPTRS_	    
#define dptcon	   DPTCON_	    
#define dpteqr	   DPTEQR_	    
#define dptrfs	   DPTRFS_	    
#define dptsv	   DPTSV_	    
#define dptsvx	   DPTSVX_	    
#define dpttrf	   DPTTRF_	    
#define dpttrs	   DPTTRS_	    
#define dptts2	   DPTTS2_	    
#define drscl	   DRSCL_	    
#define dsbev	   DSBEV_	    
#define dsbevd	   DSBEVD_	    
#define dsbevx	   DSBEVX_	    
#define dsbgst	   DSBGST_	    
#define dsbgv	   DSBGV_	    
#define dsbgvd	   DSBGVD_	    
#define dsbgvx	   DSBGVX_	    
#define dsbtrd	   DSBTRD_	    
#define dsecnd	   DSECND_	    
#define dspcon	   DSPCON_	    
#define dspev	   DSPEV_	    
#define dspevd	   DSPEVD_	    
#define dspevx	   DSPEVX_	    
#define dspgst	   DSPGST_	    
#define dspgv	   DSPGV_	    
#define dspgvd	   DSPGVD_	    
#define dspgvx	   DSPGVX_	    
#define dsprfs	   DSPRFS_	    
#define dspsv	   DSPSV_	    
#define dspsvx	   DSPSVX_	    
#define dsptrd	   DSPTRD_	    
#define dsptrf	   DSPTRF_	    
#define dsptri	   DSPTRI_	    
#define dsptrs	   DSPTRS_	    
#define dstebz	   DSTEBZ_	    
#define dstedc	   DSTEDC_	    
#define dstegr	   DSTEGR_	    
#define dstein	   DSTEIN_	    
#define dsteqr	   DSTEQR_	    
#define dsterf	   DSTERF_	    
#define dstev	   DSTEV_	    
#define dstevd	   DSTEVD_	    
#define dstevr	   DSTEVR_	    
#define dstevx	   DSTEVX_	    
#define dsycon	   DSYCON_	    
#define dsyev	   DSYEV_	    
#define dsyevd	   DSYEVD_	    
#define dsyevr	   DSYEVR_	    
#define dsyevx	   DSYEVX_	    
#define dsygs2	   DSYGS2_	    
#define dsygst	   DSYGST_	    
#define dsygv	   DSYGV_	    
#define dsygvd	   DSYGVD_	    
#define dsygvx	   DSYGVX_	    
#define dsyrfs	   DSYRFS_	    
#define dsysv	   DSYSV_	    
#define dsysvx	   DSYSVX_	    
#define dsytd2	   DSYTD2_	    
#define dsytf2	   DSYTF2_	    
#define dsytrd	   DSYTRD_	    
#define dsytrf	   DSYTRF_	    
#define dsytri	   DSYTRI_	    
#define dsytrs	   DSYTRS_	    
#define dtbcon	   DTBCON_	    
#define dtbrfs	   DTBRFS_	    
#define dtbtrs	   DTBTRS_	    
#define dtgevc	   DTGEVC_	    
#define dtgex2	   DTGEX2_	    
#define dtgexc	   DTGEXC_	    
#define dtgsen	   DTGSEN_	    
#define dtgsja	   DTGSJA_	    
#define dtgsna	   DTGSNA_	    
#define dtgsy2	   DTGSY2_	    
#define dtgsyl	   DTGSYL_	    
#define dtpcon	   DTPCON_	    
#define dtprfs	   DTPRFS_	    
#define dtptri	   DTPTRI_	    
#define dtptrs	   DTPTRS_	    
#define dtrcon	   DTRCON_	    
#define dtrevc	   DTREVC_	    
#define dtrexc	   DTREXC_	    
#define dtrrfs	   DTRRFS_	    
#define dtrsen	   DTRSEN_	    
#define dtrsna	   DTRSNA_	    
#define dtrsyl	   DTRSYL_	    
#define dtrti2	   DTRTI2_	    
#define dtrtri	   DTRTRI_	    
#define dtrtrs	   DTRTRS_	    
#define dtzrqf	   DTZRQF_	    
#define dtzrzf	   DTZRZF_	    
#define dzsum1	   DZSUM1_	    
#define icmax1	   ICMAX1_	    
#define ieeeck	   IEEECK_	    
#define ilaenv	   ILAENV_	    
#define izmax1	   IZMAX1_	    
#define lsamech	   LSAMECH_    
#define lsamen	   LSAMEN_	    
#define sbdsdc	   SBDSDC_	    
#define sbdsqr	   SBDSQR_	    
#define scsum1	   SCSUM1_	    
#define sdisna	   SDISNA_	    
#define secondv	   SECONDV_    
#define sgbbrd	   SGBBRD_	    
#define sgbcon	   SGBCON_	    
#define sgbequ	   SGBEQU_	    
#define sgbrfs	   SGBRFS_	    
#define sgbsv	   SGBSV_	    
#define sgbsvx	   SGBSVX_	    
#define sgbtf2	   SGBTF2_	    
#define sgbtrf	   SGBTRF_	    
#define sgbtrs	   SGBTRS_	    
#define sgebak	   SGEBAK_	    
#define sgebal	   SGEBAL_	    
#define sgebd2	   SGEBD2_	    
#define sgebrd	   SGEBRD_	    
#define sgecon	   SGECON_	    
#define sgeequ	   SGEEQU_	    
#define sgees	   SGEES_	    
#define sgeesx	   SGEESX_	    
#define sgeev	   SGEEV_	    
#define sgeevx	   SGEEVX_	    
#define sgegs	   SGEGS_	    
#define sgegv	   SGEGV_	    
#define sgehd2	   SGEHD2_	    
#define sgehrd	   SGEHRD_	    
#define sgelq2	   SGELQ2_	    
#define sgelqf	   SGELQF_	    
#define sgels	   SGELS_	    
#define sgelsd	   SGELSD_	    
#define sgelss	   SGELSS_	    
#define sgelsx	   SGELSX_	    
#define sgelsy	   SGELSY_	    
#define sgeql2	   SGEQL2_	    
#define sgeqlf	   SGEQLF_	    
#define sgeqp3	   SGEQP3_	    
#define sgeqpf	   SGEQPF_	    
#define sgeqr2	   SGEQR2_	    
#define sgeqrf	   SGEQRF_	    
#define sgerfs	   SGERFS_	    
#define sgerq2	   SGERQ2_	    
#define sgerqf	   SGERQF_	    
#define sgesc2	   SGESC2_	    
#define sgesdd	   SGESDD_	    
#define sgesv	   SGESV_	    
#define sgesvd	   SGESVD_	    
#define sgesvx	   SGESVX_	    
#define sgetc2	   SGETC2_	    
#define sgetf2	   SGETF2_	    
#define sgetrf	   SGETRF_	    
#define sgetri	   SGETRI_	    
#define sgetrs	   SGETRS_	    
#define sggbak	   SGGBAK_	    
#define sggbal	   SGGBAL_	    
#define sgges	   SGGES_	    
#define sggesx	   SGGESX_	    
#define sggev	   SGGEV_	    
#define sggevx	   SGGEVX_	    
#define sggglm	   SGGGLM_	    
#define sgghrd	   SGGHRD_	    
#define sgglse	   SGGLSE_	    
#define sggqrf	   SGGQRF_	    
#define sggrqf	   SGGRQF_	    
#define sggsvd	   SGGSVD_	    
#define sggsvp	   SGGSVP_	    
#define sgtcon	   SGTCON_	    
#define sgtrfs	   SGTRFS_	    
#define sgtsv	   SGTSV_	    
#define sgtsvx	   SGTSVX_	    
#define sgttrf	   SGTTRF_	    
#define sgttrs	   SGTTRS_	    
#define sgtts2	   SGTTS2_	    
#define shgeqz	   SHGEQZ_	    
#define shsein	   SHSEIN_	    
#define shseqr	   SHSEQR_	    
#define slabadr	   SLABADR_    
#define slabrd	   SLABRD_	    
#define slacon	   SLACON_	    
#define slacpy	   SLACPY_	    
#define sladivr	   SLADIVR_    
#define slae2re	   SLAE2RE_    
#define slaebz	   SLAEBZ_	    
#define slaed0	   SLAED0_	    
#define slaed1	   SLAED1_	    
#define slaed2	   SLAED2_	    
#define slaed3	   SLAED3_	    
#define slaed4	   SLAED4_	    
#define slaed5	   SLAED5_	    
#define slaed6	   SLAED6_	    
#define slaed7	   SLAED7_	    
#define slaed8	   SLAED8_	    
#define slaed9	   SLAED9_	    
#define slaeda	   SLAEDA_	    
#define slaein	   SLAEIN_	    
#define slaev2r	   SLAEV2R_    
#define slaexc	   SLAEXC_	    
#define slag2re	   SLAG2RE_    
#define slags2	   SLAGS2_	    
#define slagtf	   SLAGTF_	    
#define slagtm	   SLAGTM_	    
#define slagts	   SLAGTS_	    
#define slagv2r	   SLAGV2R_    
#define slahqr	   SLAHQR_	    
#define slahrd	   SLAHRD_	    
#define slaic1	   SLAIC1_	    
#define slaln2	   SLALN2_	    
#define slals0	   SLALS0_	    
#define slalsa	   SLALSA_	    
#define slalsd	   SLALSD_	    
#define slamch	   SLAMCH_	    
#define slamc1	   SLAMC1_	    
#define slamc2	   SLAMC2_	    
#define slamc3r	   SLAMC3R_    
#define slamc4	   SLAMC4_	    
#define slamc5	   SLAMC5_	    
#define slamrg	   SLAMRG_	    
#define slangb	   SLANGB_	    
#define slange	   SLANGE_	    
#define slangt	   SLANGT_	    
#define slanhs	   SLANHS_	    
#define slansb	   SLANSB_	    
#define slansp	   SLANSP_	    
#define slanst	   SLANST_	    
#define slansy	   SLANSY_	    
#define slantb	   SLANTB_	    
#define slantp	   SLANTP_	    
#define slantr	   SLANTR_	    
#define slanv2r	   SLANV2R_    
#define slapll	   SLAPLL_	    
#define slapmt	   SLAPMT_	    
#define slapy2r	   SLAPY2R_    
#define slapy3r	   SLAPY3R_    
#define slaqgb	   SLAQGB_	    
#define slaqge	   SLAQGE_	    
#define slaqp2	   SLAQP2_	    
#define slaqps	   SLAQPS_	    
#define slaqsb	   SLAQSB_	    
#define slaqsp	   SLAQSP_	    
#define slaqsy	   SLAQSY_	    
#define slaqtr	   SLAQTR_	    
#define slar1v	   SLAR1V_	    
#define slar2v	   SLAR2V_	    
#define slarf	   SLARF_	    
#define slarfb	   SLARFB_	    
#define slarfg	   SLARFG_	    
#define slarft	   SLARFT_	    
#define slarfx	   SLARFX_	    
#define slargv	   SLARGV_	    
#define slarnv	   SLARNV_	    
#define slarrb	   SLARRB_	    
#define slarre	   SLARRE_	    
#define slarrf	   SLARRF_	    
#define slarrv	   SLARRV_	    
#define slartgr	   SLARTGR_    
#define slartv	   SLARTV_	    
#define slaruv	   SLARUV_	    
#define slarz	   SLARZ_	    
#define slarzb	   SLARZB_	    
#define slarzt	   SLARZT_	    
#define slas2re	   SLAS2RE_    
#define slascl	   SLASCL_	    
#define slasd0	   SLASD0_	    
#define slasd1	   SLASD1_	    
#define slasd2	   SLASD2_	    
#define slasd3	   SLASD3_	    
#define slasd4	   SLASD4_	    
#define slasd5	   SLASD5_	    
#define slasd6	   SLASD6_	    
#define slasd7	   SLASD7_	    
#define slasd8	   SLASD8_	    
#define slasd9	   SLASD9_	    
#define slasda	   SLASDA_	    
#define slasdq	   SLASDQ_	    
#define slasdt	   SLASDT_	    
#define slaset	   SLASET_	    
#define slasq1	   SLASQ1_	    
#define slasq2	   SLASQ2_	    
#define slasq3	   SLASQ3_	    
#define slasq4	   SLASQ4_	    
#define slasq5	   SLASQ5_	    
#define slasq6	   SLASQ6_	    
#define slasr	   SLASR_	    
#define slasrt	   SLASRT_	    
#define slassq	   SLASSQ_	    
#define slasv2r	   SLASV2R_    
#define slaswp	   SLASWP_	    
#define slasy2	   SLASY2_	    
#define slasyf	   SLASYF_	    
#define slatbs	   SLATBS_	    
#define slatdf	   SLATDF_	    
#define slatps	   SLATPS_	    
#define slatrd	   SLATRD_	    
#define slatrs	   SLATRS_	    
#define slatrz	   SLATRZ_	    
#define slatzm	   SLATZM_	    
#define slauu2	   SLAUU2_	    
#define slauum	   SLAUUM_	    
#define sopgtr	   SOPGTR_	    
#define sopmtr	   SOPMTR_	    
#define sorg2l	   SORG2L_	    
#define sorg2r	   SORG2R_	    
#define sorgbr	   SORGBR_	    
#define sorghr	   SORGHR_	    
#define sorgl2	   SORGL2_	    
#define sorglq	   SORGLQ_	    
#define sorgql	   SORGQL_	    
#define sorgqr	   SORGQR_	    
#define sorgr2	   SORGR2_	    
#define sorgrq	   SORGRQ_	    
#define sorgtr	   SORGTR_	    
#define sorm2l	   SORM2L_	    
#define sorm2r	   SORM2R_	    
#define sormbr	   SORMBR_	    
#define sormhr	   SORMHR_	    
#define sorml2	   SORML2_	    
#define sormlq	   SORMLQ_	    
#define sormql	   SORMQL_	    
#define sormqr	   SORMQR_	    
#define sormr2	   SORMR2_	    
#define sormr3	   SORMR3_	    
#define sormrq	   SORMRQ_	    
#define sormrz	   SORMRZ_	    
#define sormtr	   SORMTR_	    
#define spbcon	   SPBCON_	    
#define spbequ	   SPBEQU_	    
#define spbrfs	   SPBRFS_	    
#define spbstf	   SPBSTF_	    
#define spbsv	   SPBSV_	    
#define spbsvx	   SPBSVX_	    
#define spbtf2	   SPBTF2_	    
#define spbtrf	   SPBTRF_	    
#define spbtrs	   SPBTRS_	    
#define spocon	   SPOCON_	    
#define spoequ	   SPOEQU_	    
#define sporfs	   SPORFS_	    
#define sposv	   SPOSV_	    
#define sposvx	   SPOSVX_	    
#define spotf2	   SPOTF2_	    
#define spotrf	   SPOTRF_	    
#define spotri	   SPOTRI_	    
#define spotrs	   SPOTRS_	    
#define sppcon	   SPPCON_	    
#define sppequ	   SPPEQU_	    
#define spprfs	   SPPRFS_	    
#define sppsv	   SPPSV_	    
#define sppsvx	   SPPSVX_	    
#define spptrf	   SPPTRF_	    
#define spptri	   SPPTRI_	    
#define spptrs	   SPPTRS_	    
#define sptcon	   SPTCON_	    
#define spteqr	   SPTEQR_	    
#define sptrfs	   SPTRFS_	    
#define sptsv	   SPTSV_	    
#define sptsvx	   SPTSVX_	    
#define spttrf	   SPTTRF_	    
#define spttrs	   SPTTRS_	    
#define sptts2	   SPTTS2_	    
#define srscl	   SRSCL_	    
#define ssbev	   SSBEV_	    
#define ssbevd	   SSBEVD_	    
#define ssbevx	   SSBEVX_	    
#define ssbgst	   SSBGST_	    
#define ssbgv	   SSBGV_	    
#define ssbgvd	   SSBGVD_	    
#define ssbgvx	   SSBGVX_	    
#define ssbtrd	   SSBTRD_	    
#define sspcon	   SSPCON_	    
#define sspev	   SSPEV_	    
#define sspevd	   SSPEVD_	    
#define sspevx	   SSPEVX_	    
#define sspgst	   SSPGST_	    
#define sspgv	   SSPGV_	    
#define sspgvd	   SSPGVD_	    
#define sspgvx	   SSPGVX_	    
#define ssprfs	   SSPRFS_	    
#define sspsv	   SSPSV_	    
#define sspsvx	   SSPSVX_	    
#define ssptrd	   SSPTRD_	    
#define ssptrf	   SSPTRF_	    
#define ssptri	   SSPTRI_	    
#define ssptrs	   SSPTRS_	    
#define sstebz	   SSTEBZ_	    
#define sstedc	   SSTEDC_	    
#define sstegr	   SSTEGR_	    
#define sstein	   SSTEIN_	    
#define ssteqr	   SSTEQR_	    
#define ssterf	   SSTERF_	    
#define sstev	   SSTEV_	    
#define sstevd	   SSTEVD_	    
#define sstevr	   SSTEVR_	    
#define sstevx	   SSTEVX_	    
#define ssycon	   SSYCON_	    
#define ssyev	   SSYEV_	    
#define ssyevd	   SSYEVD_	    
#define ssyevr	   SSYEVR_	    
#define ssyevx	   SSYEVX_	    
#define ssygs2	   SSYGS2_	    
#define ssygst	   SSYGST_	    
#define ssygv	   SSYGV_	    
#define ssygvd	   SSYGVD_	    
#define ssygvx	   SSYGVX_	    
#define ssyrfs	   SSYRFS_	    
#define ssysv	   SSYSV_	    
#define ssysvx	   SSYSVX_	    
#define ssytd2	   SSYTD2_	    
#define ssytf2	   SSYTF2_	    
#define ssytrd	   SSYTRD_	    
#define ssytrf	   SSYTRF_	    
#define ssytri	   SSYTRI_	    
#define ssytrs	   SSYTRS_	    
#define stbcon	   STBCON_	    
#define stbrfs	   STBRFS_	    
#define stbtrs	   STBTRS_	    
#define stgevc	   STGEVC_	    
#define stgex2	   STGEX2_	    
#define stgexc	   STGEXC_	    
#define stgsen	   STGSEN_	    
#define stgsja	   STGSJA_	    
#define stgsna	   STGSNA_	    
#define stgsy2	   STGSY2_	    
#define stgsyl	   STGSYL_	    
#define stpcon	   STPCON_	    
#define stprfs	   STPRFS_	    
#define stptri	   STPTRI_	    
#define stptrs	   STPTRS_	    
#define strcon	   STRCON_	    
#define strevc	   STREVC_	    
#define strexc	   STREXC_	    
#define strrfs	   STRRFS_	    
#define strsen	   STRSEN_	    
#define strsna	   STRSNA_	    
#define strsyl	   STRSYL_	    
#define strti2	   STRTI2_	    
#define strtri	   STRTRI_	    
#define strtrs	   STRTRS_	    
#define stzrqf	   STZRQF_	    
#define stzrzf	   STZRZF_	    
#define xerbla	   XERBLA_	    
#define zbdsqr	   ZBDSQR_	    
#define zdrot	   ZDROT_	    
#define zdrscl	   ZDRSCL_	    
#define zgbbrd	   ZGBBRD_	    
#define zgbcon	   ZGBCON_	    
#define zgbequ	   ZGBEQU_	    
#define zgbrfs	   ZGBRFS_	    
#define zgbsv	   ZGBSV_	    
#define zgbsvx	   ZGBSVX_	    
#define zgbtf2	   ZGBTF2_	    
#define zgbtrf	   ZGBTRF_	    
#define zgbtrs	   ZGBTRS_	    
#define zgebak	   ZGEBAK_	    
#define zgebal	   ZGEBAL_	    
#define zgebd2	   ZGEBD2_	    
#define zgebrd	   ZGEBRD_	    
#define zgecon	   ZGECON_	    
#define zgeequ	   ZGEEQU_	    
#define zgees	   ZGEES_	    
#define zgeesx	   ZGEESX_	    
#define zgeev	   ZGEEV_	    
#define zgeevx	   ZGEEVX_	    
#define zgegs	   ZGEGS_	    
#define zgegv	   ZGEGV_	    
#define zgehd2	   ZGEHD2_	    
#define zgehrd	   ZGEHRD_	    
#define zgelq2	   ZGELQ2_	    
#define zgelqf	   ZGELQF_	    
#define zgels	   ZGELS_	    
#define zgelsd	   ZGELSD_	    
#define zgelss	   ZGELSS_	    
#define zgelsx	   ZGELSX_	    
#define zgelsy	   ZGELSY_	    
#define zgeql2	   ZGEQL2_	    
#define zgeqlf	   ZGEQLF_	    
#define zgeqp3	   ZGEQP3_	    
#define zgeqpf	   ZGEQPF_	    
#define zgeqr2	   ZGEQR2_	    
#define zgeqrf	   ZGEQRF_	    
#define zgerfs	   ZGERFS_	    
#define zgerq2	   ZGERQ2_	    
#define zgerqf	   ZGERQF_	    
#define zgesc2	   ZGESC2_	    
#define zgesdd	   ZGESDD_	    
#define zgesv	   ZGESV_	    
#define zgesvd	   ZGESVD_	    
#define zgesvx	   ZGESVX_	    
#define zgetc2	   ZGETC2_	    
#define zgetf2	   ZGETF2_	    
#define zgetrf	   ZGETRF_	    
#define zgetri	   ZGETRI_	    
#define zgetrs	   ZGETRS_	    
#define zggbak	   ZGGBAK_	    
#define zggbal	   ZGGBAL_	    
#define zgges	   ZGGES_	    
#define zggesx	   ZGGESX_	    
#define zggev	   ZGGEV_	    
#define zggevx	   ZGGEVX_	    
#define zggglm	   ZGGGLM_	    
#define zgghrd	   ZGGHRD_	    
#define zgglse	   ZGGLSE_	    
#define zggqrf	   ZGGQRF_	    
#define zggrqf	   ZGGRQF_	    
#define zggsvd	   ZGGSVD_	    
#define zggsvp	   ZGGSVP_	    
#define zgtcon	   ZGTCON_	    
#define zgtrfs	   ZGTRFS_	    
#define zgtsv	   ZGTSV_	    
#define zgtsvx	   ZGTSVX_	    
#define zgttrf	   ZGTTRF_	    
#define zgttrs	   ZGTTRS_	    
#define zgtts2	   ZGTTS2_	    
#define zhbev	   ZHBEV_	    
#define zhbevd	   ZHBEVD_	    
#define zhbevx	   ZHBEVX_	    
#define zhbgst	   ZHBGST_	    
#define zhbgv	   ZHBGV_	    
#define zhbgvd	   ZHBGVD_	    
#define zhbgvx	   ZHBGVX_	    
#define zhbtrd	   ZHBTRD_	    
#define zhecon	   ZHECON_	    
#define zheev	   ZHEEV_	    
#define zheevd	   ZHEEVD_	    
#define zheevr	   ZHEEVR_	    
#define zheevx	   ZHEEVX_	    
#define zhegs2	   ZHEGS2_	    
#define zhegst	   ZHEGST_	    
#define zhegv	   ZHEGV_	    
#define zhegvd	   ZHEGVD_	    
#define zhegvx	   ZHEGVX_	    
#define zherfs	   ZHERFS_	    
#define zhesv	   ZHESV_	    
#define zhesvx	   ZHESVX_	    
#define zhetd2	   ZHETD2_	    
#define zhetf2	   ZHETF2_	    
#define zhetrd	   ZHETRD_	    
#define zhetrf	   ZHETRF_	    
#define zhetri	   ZHETRI_	    
#define zhetrs	   ZHETRS_	    
#define zhgeqz	   ZHGEQZ_	    
#define zhpcon	   ZHPCON_	    
#define zhpev	   ZHPEV_	    
#define zhpevd	   ZHPEVD_	    
#define zhpevx	   ZHPEVX_	    
#define zhpgst	   ZHPGST_	    
#define zhpgv	   ZHPGV_	    
#define zhpgvd	   ZHPGVD_	    
#define zhpgvx	   ZHPGVX_	    
#define zhprfs	   ZHPRFS_	    
#define zhpsv	   ZHPSV_	    
#define zhpsvx	   ZHPSVX_	    
#define zhptrd	   ZHPTRD_	    
#define zhptrf	   ZHPTRF_	    
#define zhptri	   ZHPTRI_	    
#define zhptrs	   ZHPTRS_	    
#define zhsein	   ZHSEIN_	    
#define zhseqr	   ZHSEQR_	    
#define zlabrd	   ZLABRD_	    
#define zlacgv	   ZLACGV_	    
#define zlacon	   ZLACON_	    
#define zlacp2	   ZLACP2_	    
#define zlacpy	   ZLACPY_	    
#define zlacrm	   ZLACRM_	    
#define zlacrt	   ZLACRT_	    
#define zladiv	   ZLADIV_	    
#define zlaed0	   ZLAED0_	    
#define zlaed7	   ZLAED7_	    
#define zlaed8	   ZLAED8_	    
#define zlaein	   ZLAEIN_	    
#define zlaesy	   ZLAESY_	    
#define zlaev2	   ZLAEV2_	    
#define zlags2	   ZLAGS2_	    
#define zlagtm	   ZLAGTM_	    
#define zlahef	   ZLAHEF_	    
#define zlahqr	   ZLAHQR_	    
#define zlahrd	   ZLAHRD_	    
#define zlaic1	   ZLAIC1_	    
#define zlals0	   ZLALS0_	    
#define zlalsa	   ZLALSA_	    
#define zlalsd	   ZLALSD_	    
#define zlangb	   ZLANGB_	    
#define zlange	   ZLANGE_	    
#define zlangt	   ZLANGT_	    
#define zlanhb	   ZLANHB_	    
#define zlanhe	   ZLANHE_	    
#define zlanhp	   ZLANHP_	    
#define zlanhs	   ZLANHS_	    
#define zlanht	   ZLANHT_	    
#define zlansb	   ZLANSB_	    
#define zlansp	   ZLANSP_	    
#define zlansy	   ZLANSY_	    
#define zlantb	   ZLANTB_	    
#define zlantp	   ZLANTP_	    
#define zlantr	   ZLANTR_	    
#define zlapll	   ZLAPLL_	    
#define zlapmt	   ZLAPMT_	    
#define zlaqgb	   ZLAQGB_	    
#define zlaqge	   ZLAQGE_	    
#define zlaqhb	   ZLAQHB_	    
#define zlaqhe	   ZLAQHE_	    
#define zlaqhp	   ZLAQHP_	    
#define zlaqp2	   ZLAQP2_	    
#define zlaqps	   ZLAQPS_	    
#define zlaqsb	   ZLAQSB_	    
#define zlaqsp	   ZLAQSP_	    
#define zlaqsy	   ZLAQSY_	    
#define zlar1v	   ZLAR1V_	    
#define zlar2v	   ZLAR2V_	    
#define zlarcm	   ZLARCM_	    
#define zlarf	   ZLARF_	    
#define zlarfb	   ZLARFB_	    
#define zlarfg	   ZLARFG_	    
#define zlarft	   ZLARFT_	    
#define zlarfx	   ZLARFX_	    
#define zlargv	   ZLARGV_	    
#define zlarnv	   ZLARNV_	    
#define zlarrv	   ZLARRV_	    
#define zlartg	   ZLARTG_	    
#define zlartv	   ZLARTV_	    
#define zlarz	   ZLARZ_	    
#define zlarzb	   ZLARZB_	    
#define zlarzt	   ZLARZT_	    
#define zlascl	   ZLASCL_	    
#define zlaset	   ZLASET_	    
#define zlasr	   ZLASR_	    
#define zlassq	   ZLASSQ_	    
#define zlaswp	   ZLASWP_	    
#define zlasyf	   ZLASYF_	    
#define zlatbs	   ZLATBS_	    
#define zlatdf	   ZLATDF_	    
#define zlatps	   ZLATPS_	    
#define zlatrd	   ZLATRD_	    
#define zlatrs	   ZLATRS_	    
#define zlatrz	   ZLATRZ_	    
#define zlatzm	   ZLATZM_	    
#define zlauu2	   ZLAUU2_	    
#define zlauum	   ZLAUUM_	    
#define zpbcon	   ZPBCON_	    
#define zpbequ	   ZPBEQU_	    
#define zpbrfs	   ZPBRFS_	    
#define zpbstf	   ZPBSTF_	    
#define zpbsv	   ZPBSV_	    
#define zpbsvx	   ZPBSVX_	    
#define zpbtf2	   ZPBTF2_	    
#define zpbtrf	   ZPBTRF_	    
#define zpbtrs	   ZPBTRS_	    
#define zpocon	   ZPOCON_	    
#define zpoequ	   ZPOEQU_	    
#define zporfs	   ZPORFS_	    
#define zposv	   ZPOSV_	    
#define zposvx	   ZPOSVX_	    
#define zpotf2	   ZPOTF2_	    
#define zpotrf	   ZPOTRF_	    
#define zpotri	   ZPOTRI_	    
#define zpotrs	   ZPOTRS_	    
#define zppcon	   ZPPCON_	    
#define zppequ	   ZPPEQU_	    
#define zpprfs	   ZPPRFS_	    
#define zppsv	   ZPPSV_	    
#define zppsvx	   ZPPSVX_	    
#define zpptrf	   ZPPTRF_	    
#define zpptri	   ZPPTRI_	    
#define zpptrs	   ZPPTRS_	    
#define zptcon	   ZPTCON_	    
#define zpteqr	   ZPTEQR_	    
#define zptrfs	   ZPTRFS_	    
#define zptsv	   ZPTSV_	    
#define zptsvx	   ZPTSVX_	    
#define zpttrf	   ZPTTRF_	    
#define zpttrs	   ZPTTRS_	    
#define zptts2	   ZPTTS2_	    
#define zrotn	   ZROTN_	    
#define zspcon	   ZSPCON_	    
#define zspmv	   ZSPMV_	    
#define zspru	   ZSPRU_	    
#define zsprfs	   ZSPRFS_	    
#define zspsv	   ZSPSV_	    
#define zspsvx	   ZSPSVX_	    
#define zsptrf	   ZSPTRF_	    
#define zsptri	   ZSPTRI_	    
#define zsptrs	   ZSPTRS_	    
#define zstedc	   ZSTEDC_	    
#define zstegr	   ZSTEGR_	    
#define zstein	   ZSTEIN_	    
#define zsteqr	   ZSTEQR_	    
#define zsycon	   ZSYCON_	    
#define zsymv	   ZSYMV_	    
#define zsyru	   ZSYRU_	    
#define zsyrfs	   ZSYRFS_	    
#define zsysv	   ZSYSV_	    
#define zsysvx	   ZSYSVX_	    
#define zsytf2	   ZSYTF2_	    
#define zsytrf	   ZSYTRF_	    
#define zsytri	   ZSYTRI_	    
#define zsytrs	   ZSYTRS_	    
#define ztbcon	   ZTBCON_	    
#define ztbrfs	   ZTBRFS_	    
#define ztbtrs	   ZTBTRS_	    
#define ztgevc	   ZTGEVC_	    
#define ztgex2	   ZTGEX2_	    
#define ztgexc	   ZTGEXC_	    
#define ztgsen	   ZTGSEN_	    
#define ztgsja	   ZTGSJA_	    
#define ztgsna	   ZTGSNA_	    
#define ztgsy2	   ZTGSY2_	    
#define ztgsyl	   ZTGSYL_	    
#define ztpcon	   ZTPCON_	    
#define ztprfs	   ZTPRFS_	    
#define ztptri	   ZTPTRI_	    
#define ztptrs	   ZTPTRS_	    
#define ztrcon	   ZTRCON_	    
#define ztrevc	   ZTREVC_	    
#define ztrexc	   ZTREXC_	    
#define ztrrfs	   ZTRRFS_	    
#define ztrsen	   ZTRSEN_	    
#define ztrsna	   ZTRSNA_	    
#define ztrsyl	   ZTRSYL_	    
#define ztrti2	   ZTRTI2_	    
#define ztrtri	   ZTRTRI_	    
#define ztrtrs	   ZTRTRS_	    
#define ztzrqf	   ZTZRQF_	    
#define ztzrzf	   ZTZRZF_	    
#define zung2l	   ZUNG2L_	    
#define zung2r	   ZUNG2R_	    
#define zungbr	   ZUNGBR_	    
#define zunghr	   ZUNGHR_	    
#define zungl2	   ZUNGL2_	    
#define zunglq	   ZUNGLQ_	    
#define zungql	   ZUNGQL_	    
#define zungqr	   ZUNGQR_	    
#define zungr2	   ZUNGR2_	    
#define zungrq	   ZUNGRQ_	    
#define zungtr	   ZUNGTR_	    
#define zunm2l	   ZUNM2L_	    
#define zunm2r	   ZUNM2R_	    
#define zunmbr	   ZUNMBR_	    
#define zunmhr	   ZUNMHR_	    
#define zunml2	   ZUNML2_	    
#define zunmlq	   ZUNMLQ_	    
#define zunmql	   ZUNMQL_	    
#define zunmqr	   ZUNMQR_	    
#define zunmr2	   ZUNMR2_	    
#define zunmr3	   ZUNMR3_	    
#define zunmrq	   ZUNMRQ_	    
#define zunmrz	   ZUNMRZ_	    
#define zunmtr	   ZUNMTR_	    
#define zupgtr	   ZUPGTR_	    
#define zupmtr	   ZUPMTR_     

/* CAPS and 2 underscores are defined */
#elif defined __CAPS__ && defined __2UNDERSCORES__

#define cbdsqr          CBDSQR__     
#define cgbbrd		CGBBRD__     
#define cgbcon		CGBCON__     
#define cgbequ		CGBEQU__     
#define cgbrfs		CGBRFS__     
#define cgbsv		CGBSV__	     
#define cgbsvx		CGBSVX__     
#define cgbtf2		CGBTF2__     
#define cgbtrf		CGBTRF__     
#define cgbtrs		CGBTRS__     
#define cgebak		CGEBAK__     
#define cgebal		CGEBAL__     
#define cgebd2		CGEBD2__     
#define cgebrd		CGEBRD__     
#define cgecon		CGECON__     
#define cgeequ		CGEEQU__     
#define cgees		CGEES__	     
#define cgeesx		CGEESX__     
#define cgeev		CGEEV__	     
#define cgeevx		CGEEVX__     
#define cgegs		CGEGS__	     
#define cgegv		CGEGV__	     
#define cgehd2		CGEHD2__     
#define cgehrd		CGEHRD__     
#define cgelq2		CGELQ2__     
#define cgelqf		CGELQF__     
#define cgels		CGELS__	     
#define cgelsd		CGELSD__     
#define cgelss		CGELSS__     
#define cgelsx		CGELSX__     
#define cgelsy		CGELSY__     
#define cgeql2		CGEQL2__     
#define cgeqlf		CGEQLF__     
#define cgeqp3		CGEQP3__     
#define cgeqpf		CGEQPF__     
#define cgeqr2		CGEQR2__     
#define cgeqrf		CGEQRF__     
#define cgerfs		CGERFS__     
#define cgerq2		CGERQ2__     
#define cgerqf		CGERQF__     
#define cgesc2		CGESC2__     
#define cgesdd		CGESDD__     
#define cgesv		CGESV__	     
#define cgesvd		CGESVD__     
#define cgesvx		CGESVX__     
#define cgetc2		CGETC2__     
#define cgetf2		CGETF2__     
#define cgetrf		CGETRF__     
#define cgetri		CGETRI__     
#define cgetrs		CGETRS__     
#define cggbak		CGGBAK__     
#define cggbal		CGGBAL__     
#define cgges		CGGES__	     
#define cggesx		CGGESX__     
#define cggev		CGGEV__	     
#define cggevx		CGGEVX__     
#define cggglm		CGGGLM__     
#define cgghrd		CGGHRD__     
#define cgglse		CGGLSE__     
#define cggqrf		CGGQRF__     
#define cggrqf		CGGRQF__     
#define cggsvd		CGGSVD__     
#define cggsvp		CGGSVP__     
#define cgtcon		CGTCON__     
#define cgtrfs		CGTRFS__     
#define cgtsv		CGTSV__	     
#define cgtsvx		CGTSVX__     
#define cgttrf		CGTTRF__     
#define cgttrs		CGTTRS__     
#define cgtts2		CGTTS2__     
#define chbev		CHBEV__	     
#define chbevd		CHBEVD__     
#define chbevx		CHBEVX__     
#define chbgst		CHBGST__     
#define chbgv		CHBGV__	     
#define chbgvd		CHBGVD__     
#define chbgvx		CHBGVX__     
#define chbtrd		CHBTRD__     
#define checon		CHECON__     
#define cheev		CHEEV__	     
#define cheevd		CHEEVD__     
#define cheevr		CHEEVR__     
#define cheevx		CHEEVX__     
#define chegs2		CHEGS2__     
#define chegst		CHEGST__     
#define chegv		CHEGV__	     
#define chegvd		CHEGVD__     
#define chegvx		CHEGVX__     
#define cherfs		CHERFS__     
#define chesv		CHESV__	     
#define chesvx		CHESVX__     
#define chetd2		CHETD2__     
#define chetf2		CHETF2__     
#define chetrd		CHETRD__     
#define chetrf		CHETRF__     
#define chetri		CHETRI__     
#define chetrs		CHETRS__     
#define chgeqz		CHGEQZ__     
#define chpcon		CHPCON__     
#define chpev		CHPEV__	     
#define chpevd		CHPEVD__     
#define chpevx		CHPEVX__     
#define chpgst		CHPGST__     
#define chpgv		CHPGV__	     
#define chpgvd		CHPGVD__     
#define chpgvx		CHPGVX__     
#define chprfs		CHPRFS__     
#define chpsv		CHPSV__	     
#define chpsvx		CHPSVX__     
#define chptrd		CHPTRD__     
#define chptrf		CHPTRF__     
#define chptri		CHPTRI__     
#define chptrs		CHPTRS__     
#define chsein		CHSEIN__     
#define chseqr		CHSEQR__     
#define clabrd		CLABRD__     
#define clacgv		CLACGV__     
#define clacon		CLACON__     
#define clacp2		CLACP2__     
#define clacpy		CLACPY__     
#define clacrm		CLACRM__     
#define clacrt		CLACRT__     
#define cladiv		CLADIV__     
#define claed0		CLAED0__     
#define claed7		CLAED7__     
#define claed8		CLAED8__     
#define claein		CLAEIN__     
#define claesy		CLAESY__     
#define claev2		CLAEV2__     
#define clags2		CLAGS2__     
#define clagtm		CLAGTM__     
#define clahef		CLAHEF__     
#define clahqr		CLAHQR__     
#define clahrd		CLAHRD__     
#define claic1		CLAIC1__     
#define clals0		CLALS0__     
#define clalsa		CLALSA__     
#define clalsd		CLALSD__     
#define clangb		CLANGB__     
#define clange		CLANGE__     
#define clangt		CLANGT__     
#define clanhb		CLANHB__     
#define clanhe		CLANHE__     
#define clanhp		CLANHP__     
#define clanhs		CLANHS__     
#define clanht		CLANHT__     
#define clansb		CLANSB__     
#define clansp		CLANSP__     
#define clansy		CLANSY__     
#define clantb		CLANTB__     
#define clantp		CLANTP__     
#define clantr		CLANTR__     
#define clapll		CLAPLL__     
#define clapmt		CLAPMT__     
#define claqgb		CLAQGB__     
#define claqge		CLAQGE__     
#define claqhb		CLAQHB__     
#define claqhe		CLAQHE__     
#define claqhp		CLAQHP__     
#define claqp2		CLAQP2__     
#define claqps		CLAQPS__     
#define claqsb		CLAQSB__     
#define claqsp		CLAQSP__     
#define claqsy		CLAQSY__     
#define clar1v		CLAR1V__     
#define clar2v		CLAR2V__     
#define clarcm		CLARCM__     
#define clarf		CLARF__	     
#define clarfb		CLARFB__     
#define clarfg		CLARFG__     
#define clarft		CLARFT__     
#define clarfx		CLARFX__     
#define clargv		CLARGV__     
#define clarnv		CLARNV__     
#define clarrv		CLARRV__     
#define clartg		CLARTG__     
#define clartv		CLARTV__     
#define clarz		CLARZ__	     
#define clarzb		CLARZB__     
#define clarzt		CLARZT__     
#define clascl		CLASCL__     
#define claset		CLASET__     
#define clasr		CLASR__	     
#define classq		CLASSQ__     
#define claswp		CLASWP__     
#define clasyf		CLASYF__     
#define clatbs		CLATBS__     
#define clatdf		CLATDF__     
#define clatps		CLATPS__     
#define clatrd		CLATRD__     
#define clatrs		CLATRS__     
#define clatrz		CLATRZ__     
#define clatzm		CLATZM__     
#define clauu2		CLAUU2__     
#define clauum		CLAUUM__     
#define cpbcon		CPBCON__     
#define cpbequ		CPBEQU__     
#define cpbrfs		CPBRFS__     
#define cpbstf		CPBSTF__     
#define cpbsv		CPBSV__	     
#define cpbsvx		CPBSVX__     
#define cpbtf2		CPBTF2__     
#define cpbtrf		CPBTRF__     
#define cpbtrs		CPBTRS__     
#define cpocon		CPOCON__     
#define cpoequ		CPOEQU__     
#define cporfs		CPORFS__     
#define cposv		CPOSV__	     
#define cposvx		CPOSVX__     
#define cpotf2		CPOTF2__     
#define cpotrf		CPOTRF__     
#define cpotri		CPOTRI__     
#define cpotrs		CPOTRS__     
#define cppcon		CPPCON__     
#define cppequ		CPPEQU__     
#define cpprfs		CPPRFS__     
#define cppsv		CPPSV__	     
#define cppsvx		CPPSVX__     
#define cpptrf		CPPTRF__     
#define cpptri		CPPTRI__     
#define cpptrs		CPPTRS__     
#define cptcon		CPTCON__     
#define cpteqr		CPTEQR__     
#define cptrfs		CPTRFS__     
#define cptsv		CPTSV__	     
#define cptsvx		CPTSVX__     
#define cpttrf		CPTTRF__     
#define cpttrs		CPTTRS__     
#define cptts2		CPTTS2__     
#define crotn		CROTN__	     
#define cspcon		CSPCON__     
#define cspmv		CSPMV__	     
#define cspru		CSPRU__	     
#define csprfs		CSPRFS__     
#define cspsv		CSPSV__	     
#define cspsvx		CSPSVX__     
#define csptrf		CSPTRF__     
#define csptri		CSPTRI__     
#define csptrs		CSPTRS__     
#define csrot		CSROT__	     
#define csrscl		CSRSCL__     
#define cstedc		CSTEDC__     
#define cstegr		CSTEGR__     
#define cstein		CSTEIN__     
#define csteqr		CSTEQR__     
#define csycon		CSYCON__     
#define csymv		CSYMV__	     
#define csyru		CSYRU__	     
#define csyrfs		CSYRFS__     
#define csysv		CSYSV__	     
#define csysvx		CSYSVX__     
#define csytf2		CSYTF2__     
#define csytrf		CSYTRF__     
#define csytri		CSYTRI__     
#define csytrs		CSYTRS__     
#define ctbcon		CTBCON__     
#define ctbrfs		CTBRFS__     
#define ctbtrs		CTBTRS__     
#define ctgevc		CTGEVC__     
#define ctgex2		CTGEX2__     
#define ctgexc		CTGEXC__     
#define ctgsen		CTGSEN__     
#define ctgsja		CTGSJA__     
#define ctgsna		CTGSNA__     
#define ctgsy2		CTGSY2__     
#define ctgsyl		CTGSYL__     
#define ctpcon		CTPCON__     
#define ctprfs		CTPRFS__     
#define ctptri		CTPTRI__     
#define ctptrs		CTPTRS__     
#define ctrcon		CTRCON__     
#define ctrevc		CTREVC__     
#define ctrexc		CTREXC__     
#define ctrrfs		CTRRFS__     
#define ctrsen		CTRSEN__     
#define ctrsna		CTRSNA__     
#define ctrsyl		CTRSYL__     
#define ctrti2		CTRTI2__     
#define ctrtri		CTRTRI__     
#define ctrtrs		CTRTRS__     
#define ctzrqf		CTZRQF__     
#define ctzrzf		CTZRZF__     
#define cung2l		CUNG2L__     
#define cung2r		CUNG2R__     
#define cungbr		CUNGBR__     
#define cunghr		CUNGHR__     
#define cungl2		CUNGL2__     
#define cunglq		CUNGLQ__     
#define cungql		CUNGQL__     
#define cungqr		CUNGQR__     
#define cungr2		CUNGR2__     
#define cungrq		CUNGRQ__     
#define cungtr		CUNGTR__     
#define cunm2l		CUNM2L__     
#define cunm2r		CUNM2R__     
#define cunmbr		CUNMBR__     
#define cunmhr		CUNMHR__     
#define cunml2		CUNML2__     
#define cunmlq		CUNMLQ__     
#define cunmql		CUNMQL__     
#define cunmqr		CUNMQR__     
#define cunmr2		CUNMR2__     
#define cunmr3		CUNMR3__     
#define cunmrq		CUNMRQ__     
#define cunmrz		CUNMRZ__     
#define cunmtr		CUNMTR__     
#define cupgtr		CUPGTR__     
#define cupmtr		CUPMTR__     
#define dbdsdc		DBDSDC__     
#define dbdsqr		DBDSQR__     
#define ddisna		DDISNA__     
#define dgbbrd		DGBBRD__     
#define dgbcon		DGBCON__     
#define dgbequ		DGBEQU__     
#define dgbrfs		DGBRFS__     
#define dgbsv		DGBSV__	     
#define dgbsvx		DGBSVX__     
#define dgbtf2		DGBTF2__     
#define dgbtrf		DGBTRF__     
#define dgbtrs		DGBTRS__     
#define dgebak		DGEBAK__     
#define dgebal		DGEBAL__     
#define dgebd2		DGEBD2__     
#define dgebrd		DGEBRD__     
#define dgecon		DGECON__     
#define dgeequ		DGEEQU__     
#define dgees		DGEES__	     
#define dgeesx		DGEESX__     
#define dgeev		DGEEV__	     
#define dgeevx		DGEEVX__     
#define dgegs		DGEGS__	     
#define dgegv		DGEGV__	     
#define dgehd2		DGEHD2__     
#define dgehrd		DGEHRD__     
#define dgelq2		DGELQ2__     
#define dgelqf		DGELQF__     
#define dgels		DGELS__	     
#define dgelsd		DGELSD__     
#define dgelss		DGELSS__     
#define dgelsx		DGELSX__     
#define dgelsy		DGELSY__     
#define dgeql2		DGEQL2__     
#define dgeqlf		DGEQLF__     
#define dgeqp3		DGEQP3__     
#define dgeqpf		DGEQPF__     
#define dgeqr2		DGEQR2__     
#define dgeqrf		DGEQRF__     
#define dgerfs		DGERFS__     
#define dgerq2		DGERQ2__     
#define dgerqf		DGERQF__     
#define dgesc2		DGESC2__     
#define dgesdd		DGESDD__     
#define dgesv		DGESV__	     
#define dgesvd		DGESVD__     
#define dgesvx		DGESVX__     
#define dgetc2		DGETC2__     
#define dgetf2		DGETF2__     
#define dgetrf		DGETRF__     
#define dgetri		DGETRI__     
#define dgetrs		DGETRS__     
#define dggbak		DGGBAK__     
#define dggbal		DGGBAL__     
#define dgges		DGGES__	     
#define dggesx		DGGESX__     
#define dggev		DGGEV__	     
#define dggevx		DGGEVX__     
#define dggglm		DGGGLM__     
#define dgghrd		DGGHRD__     
#define dgglse		DGGLSE__     
#define dggqrf		DGGQRF__     
#define dggrqf		DGGRQF__     
#define dggsvd		DGGSVD__     
#define dggsvp		DGGSVP__     
#define dgtcon		DGTCON__     
#define dgtrfs		DGTRFS__     
#define dgtsv		DGTSV__	     
#define dgtsvx		DGTSVX__     
#define dgttrf		DGTTRF__     
#define dgttrs		DGTTRS__     
#define dgtts2		DGTTS2__     
#define dhgeqz		DHGEQZ__     
#define dhsein		DHSEIN__     
#define dhseqr		DHSEQR__     
#define dlabad		DLABAD__     
#define dlabrd		DLABRD__     
#define dlacon		DLACON__     
#define dlacpy		DLACPY__     
#define dladiv		DLADIV__     
#define dlae2a		DLAE2A__     
#define dlaebz		DLAEBZ__     
#define dlaed0		DLAED0__     
#define dlaed1		DLAED1__     
#define dlaed2		DLAED2__     
#define dlaed3		DLAED3__     
#define dlaed4		DLAED4__     
#define dlaed5		DLAED5__     
#define dlaed6		DLAED6__     
#define dlaed7		DLAED7__     
#define dlaed8		DLAED8__     
#define dlaed9		DLAED9__     
#define dlaeda		DLAEDA__     
#define dlaein		DLAEIN__     
#define dlaev2		DLAEV2__     
#define dlaexc		DLAEXC__     
#define dlag2a		DLAG2A__     
#define dlags2		DLAGS2__     
#define dlagtf		DLAGTF__     
#define dlagtm		DLAGTM__     
#define dlagts		DLAGTS__     
#define dlagv2		DLAGV2__     
#define dlahqr		DLAHQR__     
#define dlahrd		DLAHRD__     
#define dlaic1		DLAIC1__     
#define dlaln2		DLALN2__     
#define dlals0		DLALS0__     
#define dlalsa		DLALSA__     
#define dlalsd		DLALSD__     
#define dlamch		DLAMCH__     
#define dlamc1		DLAMC1__     
#define dlamc2		DLAMC2__     
#define dlamc3		DLAMC3__     
#define dlamc4		DLAMC4__     
#define dlamc5		DLAMC5__     
#define dlamrg		DLAMRG__     
#define dlangb		DLANGB__     
#define dlange		DLANGE__     
#define dlangt		DLANGT__     
#define dlanhs		DLANHS__     
#define dlansb		DLANSB__     
#define dlansp		DLANSP__     
#define dlanst		DLANST__     
#define dlansy		DLANSY__     
#define dlantb		DLANTB__     
#define dlantp		DLANTP__     
#define dlantr		DLANTR__     
#define dlanv2		DLANV2__     
#define dlapll		DLAPLL__     
#define dlapmt		DLAPMT__     
#define dlapy2		DLAPY2__     
#define dlapy3		DLAPY3__     
#define dlaqgb		DLAQGB__     
#define dlaqge		DLAQGE__     
#define dlaqp2		DLAQP2__     
#define dlaqps		DLAQPS__     
#define dlaqsb		DLAQSB__     
#define dlaqsp		DLAQSP__     
#define dlaqsy		DLAQSY__     
#define dlaqtr		DLAQTR__     
#define dlar1v		DLAR1V__     
#define dlar2v		DLAR2V__     
#define dlarf		DLARF__	     
#define dlarfb		DLARFB__     
#define dlarfg		DLARFG__     
#define dlarft		DLARFT__     
#define dlarfx		DLARFX__     
#define dlargv		DLARGV__     
#define dlarnv		DLARNV__     
#define dlarrb		DLARRB__     
#define dlarre		DLARRE__     
#define dlarrf		DLARRF__     
#define dlarrv		DLARRV__     
#define dlartg		DLARTG__     
#define dlartv		DLARTV__     
#define dlaruv		DLARUV__     
#define dlarz		DLARZ__	     
#define dlarzb		DLARZB__     
#define dlarzt		DLARZT__     
#define dlas2f		DLAS2F__     
#define dlascl		DLASCL__     
#define dlasd0		DLASD0__     
#define dlasd1		DLASD1__     
#define dlasd2		DLASD2__     
#define dlasd3		DLASD3__     
#define dlasd4		DLASD4__     
#define dlasd5		DLASD5__     
#define dlasd6		DLASD6__     
#define dlasd7		DLASD7__     
#define dlasd8		DLASD8__     
#define dlasd9		DLASD9__     
#define dlasda		DLASDA__     
#define dlasdq		DLASDQ__     
#define dlasdt		DLASDT__     
#define dlaset		DLASET__     
#define dlasq1		DLASQ1__     
#define dlasq2		DLASQ2__     
#define dlasq3		DLASQ3__     
#define dlasq4		DLASQ4__     
#define dlasq5		DLASQ5__     
#define dlasq6		DLASQ6__     
#define dlasr		DLASR__	     
#define dlasrt		DLASRT__     
#define dlassq		DLASSQ__     
#define dlasv2		DLASV2__     
#define dlaswp		DLASWP__     
#define dlasy2		DLASY2__     
#define dlasyf		DLASYF__     
#define dlatbs		DLATBS__     
#define dlatdf		DLATDF__     
#define dlatps		DLATPS__     
#define dlatrd		DLATRD__     
#define dlatrs		DLATRS__     
#define dlatrz		DLATRZ__     
#define dlatzm		DLATZM__     
#define dlauu2		DLAUU2__     
#define dlauum		DLAUUM__     
#define dopgtr		DOPGTR__     
#define dopmtr		DOPMTR__     
#define dorg2l		DORG2L__     
#define dorg2r		DORG2R__     
#define dorgbr		DORGBR__     
#define dorghr		DORGHR__     
#define dorgl2		DORGL2__     
#define dorglq		DORGLQ__     
#define dorgql		DORGQL__     
#define dorgqr		DORGQR__     
#define dorgr2		DORGR2__     
#define dorgrq		DORGRQ__     
#define dorgtr		DORGTR__     
#define dorm2l		DORM2L__     
#define dorm2r		DORM2R__     
#define dormbr		DORMBR__     
#define dormhr		DORMHR__     
#define dorml2		DORML2__     
#define dormlq		DORMLQ__     
#define dormql		DORMQL__     
#define dormqr		DORMQR__     
#define dormr2		DORMR2__     
#define dormr3		DORMR3__     
#define dormrq		DORMRQ__     
#define dormrz		DORMRZ__     
#define dormtr		DORMTR__     
#define dpbcon		DPBCON__     
#define dpbequ		DPBEQU__     
#define dpbrfs		DPBRFS__     
#define dpbstf		DPBSTF__     
#define dpbsv		DPBSV__	     
#define dpbsvx		DPBSVX__     
#define dpbtf2		DPBTF2__     
#define dpbtrf		DPBTRF__     
#define dpbtrs		DPBTRS__     
#define dpocon		DPOCON__     
#define dpoequ		DPOEQU__     
#define dporfs		DPORFS__     
#define dposv		DPOSV__	     
#define dposvx		DPOSVX__     
#define dpotf2		DPOTF2__     
#define dpotrf		DPOTRF__     
#define dpotri		DPOTRI__     
#define dpotrs		DPOTRS__     
#define dppcon		DPPCON__     
#define dppequ		DPPEQU__     
#define dpprfs		DPPRFS__     
#define dppsv		DPPSV__	     
#define dppsvx		DPPSVX__     
#define dpptrf		DPPTRF__     
#define dpptri		DPPTRI__     
#define dpptrs		DPPTRS__     
#define dptcon		DPTCON__     
#define dpteqr		DPTEQR__     
#define dptrfs		DPTRFS__     
#define dptsv		DPTSV__	     
#define dptsvx		DPTSVX__     
#define dpttrf		DPTTRF__     
#define dpttrs		DPTTRS__     
#define dptts2		DPTTS2__     
#define drscl		DRSCL__	     
#define dsbev		DSBEV__	     
#define dsbevd		DSBEVD__     
#define dsbevx		DSBEVX__     
#define dsbgst		DSBGST__     
#define dsbgv		DSBGV__	     
#define dsbgvd		DSBGVD__     
#define dsbgvx		DSBGVX__     
#define dsbtrd		DSBTRD__     
#define dsecnd		DSECND__     
#define dspcon		DSPCON__     
#define dspev		DSPEV__	     
#define dspevd		DSPEVD__     
#define dspevx		DSPEVX__     
#define dspgst		DSPGST__     
#define dspgv		DSPGV__	     
#define dspgvd		DSPGVD__     
#define dspgvx		DSPGVX__     
#define dsprfs		DSPRFS__     
#define dspsv		DSPSV__	     
#define dspsvx		DSPSVX__     
#define dsptrd		DSPTRD__     
#define dsptrf		DSPTRF__     
#define dsptri		DSPTRI__     
#define dsptrs		DSPTRS__     
#define dstebz		DSTEBZ__     
#define dstedc		DSTEDC__     
#define dstegr		DSTEGR__     
#define dstein		DSTEIN__     
#define dsteqr		DSTEQR__     
#define dsterf		DSTERF__     
#define dstev		DSTEV__	     
#define dstevd		DSTEVD__     
#define dstevr		DSTEVR__     
#define dstevx		DSTEVX__     
#define dsycon		DSYCON__     
#define dsyev		DSYEV__	     
#define dsyevd		DSYEVD__     
#define dsyevr		DSYEVR__     
#define dsyevx		DSYEVX__     
#define dsygs2		DSYGS2__     
#define dsygst		DSYGST__     
#define dsygv		DSYGV__	     
#define dsygvd		DSYGVD__     
#define dsygvx		DSYGVX__     
#define dsyrfs		DSYRFS__     
#define dsysv		DSYSV__	     
#define dsysvx		DSYSVX__     
#define dsytd2		DSYTD2__     
#define dsytf2		DSYTF2__     
#define dsytrd		DSYTRD__     
#define dsytrf		DSYTRF__     
#define dsytri		DSYTRI__     
#define dsytrs		DSYTRS__     
#define dtbcon		DTBCON__     
#define dtbrfs		DTBRFS__     
#define dtbtrs		DTBTRS__     
#define dtgevc		DTGEVC__     
#define dtgex2		DTGEX2__     
#define dtgexc		DTGEXC__     
#define dtgsen		DTGSEN__     
#define dtgsja		DTGSJA__     
#define dtgsna		DTGSNA__     
#define dtgsy2		DTGSY2__     
#define dtgsyl		DTGSYL__     
#define dtpcon		DTPCON__     
#define dtprfs		DTPRFS__     
#define dtptri		DTPTRI__     
#define dtptrs		DTPTRS__     
#define dtrcon		DTRCON__     
#define dtrevc		DTREVC__     
#define dtrexc		DTREXC__     
#define dtrrfs		DTRRFS__     
#define dtrsen		DTRSEN__     
#define dtrsna		DTRSNA__     
#define dtrsyl		DTRSYL__     
#define dtrti2		DTRTI2__     
#define dtrtri		DTRTRI__     
#define dtrtrs		DTRTRS__     
#define dtzrqf		DTZRQF__     
#define dtzrzf		DTZRZF__     
#define dzsum1		DZSUM1__     
#define icmax1		ICMAX1__     
#define ieeeck		IEEECK__     
#define ilaenv		ILAENV__     
#define izmax1		IZMAX1__     
#define lsamech		LSAMECH__    
#define lsamen		LSAMEN__     
#define sbdsdc		SBDSDC__     
#define sbdsqr		SBDSQR__     
#define scsum1		SCSUM1__     
#define sdisna		SDISNA__     
#define secondv		SECONDV__    
#define sgbbrd		SGBBRD__     
#define sgbcon		SGBCON__     
#define sgbequ		SGBEQU__     
#define sgbrfs		SGBRFS__     
#define sgbsv		SGBSV__	     
#define sgbsvx		SGBSVX__     
#define sgbtf2		SGBTF2__     
#define sgbtrf		SGBTRF__     
#define sgbtrs		SGBTRS__     
#define sgebak		SGEBAK__     
#define sgebal		SGEBAL__     
#define sgebd2		SGEBD2__     
#define sgebrd		SGEBRD__     
#define sgecon		SGECON__     
#define sgeequ		SGEEQU__     
#define sgees		SGEES__	     
#define sgeesx		SGEESX__     
#define sgeev		SGEEV__	     
#define sgeevx		SGEEVX__     
#define sgegs		SGEGS__	     
#define sgegv		SGEGV__	     
#define sgehd2		SGEHD2__     
#define sgehrd		SGEHRD__     
#define sgelq2		SGELQ2__     
#define sgelqf		SGELQF__     
#define sgels		SGELS__	     
#define sgelsd		SGELSD__     
#define sgelss		SGELSS__     
#define sgelsx		SGELSX__     
#define sgelsy		SGELSY__     
#define sgeql2		SGEQL2__     
#define sgeqlf		SGEQLF__     
#define sgeqp3		SGEQP3__     
#define sgeqpf		SGEQPF__     
#define sgeqr2		SGEQR2__     
#define sgeqrf		SGEQRF__     
#define sgerfs		SGERFS__     
#define sgerq2		SGERQ2__     
#define sgerqf		SGERQF__     
#define sgesc2		SGESC2__     
#define sgesdd		SGESDD__     
#define sgesv		SGESV__	     
#define sgesvd		SGESVD__     
#define sgesvx		SGESVX__     
#define sgetc2		SGETC2__     
#define sgetf2		SGETF2__     
#define sgetrf		SGETRF__     
#define sgetri		SGETRI__     
#define sgetrs		SGETRS__     
#define sggbak		SGGBAK__     
#define sggbal		SGGBAL__     
#define sgges		SGGES__	     
#define sggesx		SGGESX__     
#define sggev		SGGEV__	     
#define sggevx		SGGEVX__     
#define sggglm		SGGGLM__     
#define sgghrd		SGGHRD__     
#define sgglse		SGGLSE__     
#define sggqrf		SGGQRF__     
#define sggrqf		SGGRQF__     
#define sggsvd		SGGSVD__     
#define sggsvp		SGGSVP__     
#define sgtcon		SGTCON__     
#define sgtrfs		SGTRFS__     
#define sgtsv		SGTSV__	     
#define sgtsvx		SGTSVX__     
#define sgttrf		SGTTRF__     
#define sgttrs		SGTTRS__     
#define sgtts2		SGTTS2__     
#define shgeqz		SHGEQZ__     
#define shsein		SHSEIN__     
#define shseqr		SHSEQR__     
#define slabadr		SLABADR__    
#define slabrd		SLABRD__     
#define slacon		SLACON__     
#define slacpy		SLACPY__     
#define sladivr		SLADIVR__    
#define slae2re		SLAE2RE__    
#define slaebz		SLAEBZ__     
#define slaed0		SLAED0__     
#define slaed1		SLAED1__     
#define slaed2		SLAED2__     
#define slaed3		SLAED3__     
#define slaed4		SLAED4__     
#define slaed5		SLAED5__     
#define slaed6		SLAED6__     
#define slaed7		SLAED7__     
#define slaed8		SLAED8__     
#define slaed9		SLAED9__     
#define slaeda		SLAEDA__     
#define slaein		SLAEIN__     
#define slaev2r		SLAEV2R__    
#define slaexc		SLAEXC__     
#define slag2re		SLAG2RE__    
#define slags2		SLAGS2__     
#define slagtf		SLAGTF__     
#define slagtm		SLAGTM__     
#define slagts		SLAGTS__     
#define slagv2r		SLAGV2R__    
#define slahqr		SLAHQR__     
#define slahrd		SLAHRD__     
#define slaic1		SLAIC1__     
#define slaln2		SLALN2__     
#define slals0		SLALS0__     
#define slalsa		SLALSA__     
#define slalsd		SLALSD__     
#define slamch		SLAMCH__     
#define slamc1		SLAMC1__     
#define slamc2		SLAMC2__     
#define slamc3r		SLAMC3R__    
#define slamc4		SLAMC4__     
#define slamc5		SLAMC5__     
#define slamrg		SLAMRG__     
#define slangb		SLANGB__     
#define slange		SLANGE__     
#define slangt		SLANGT__     
#define slanhs		SLANHS__     
#define slansb		SLANSB__     
#define slansp		SLANSP__     
#define slanst		SLANST__     
#define slansy		SLANSY__     
#define slantb		SLANTB__     
#define slantp		SLANTP__     
#define slantr		SLANTR__     
#define slanv2r		SLANV2R__    
#define slapll		SLAPLL__     
#define slapmt		SLAPMT__     
#define slapy2r		SLAPY2R__    
#define slapy3r		SLAPY3R__    
#define slaqgb		SLAQGB__     
#define slaqge		SLAQGE__     
#define slaqp2		SLAQP2__     
#define slaqps		SLAQPS__     
#define slaqsb		SLAQSB__     
#define slaqsp		SLAQSP__     
#define slaqsy		SLAQSY__     
#define slaqtr		SLAQTR__     
#define slar1v		SLAR1V__     
#define slar2v		SLAR2V__     
#define slarf		SLARF__	     
#define slarfb		SLARFB__     
#define slarfg		SLARFG__     
#define slarft		SLARFT__     
#define slarfx		SLARFX__     
#define slargv		SLARGV__     
#define slarnv		SLARNV__     
#define slarrb		SLARRB__     
#define slarre		SLARRE__     
#define slarrf		SLARRF__     
#define slarrv		SLARRV__     
#define slartgr		SLARTGR__    
#define slartv		SLARTV__     
#define slaruv		SLARUV__     
#define slarz		SLARZ__	     
#define slarzb		SLARZB__     
#define slarzt		SLARZT__     
#define slas2re		SLAS2RE__    
#define slascl		SLASCL__     
#define slasd0		SLASD0__     
#define slasd1		SLASD1__     
#define slasd2		SLASD2__     
#define slasd3		SLASD3__     
#define slasd4		SLASD4__     
#define slasd5		SLASD5__     
#define slasd6		SLASD6__     
#define slasd7		SLASD7__     
#define slasd8		SLASD8__     
#define slasd9		SLASD9__     
#define slasda		SLASDA__     
#define slasdq		SLASDQ__     
#define slasdt		SLASDT__     
#define slaset		SLASET__     
#define slasq1		SLASQ1__     
#define slasq2		SLASQ2__     
#define slasq3		SLASQ3__     
#define slasq4		SLASQ4__     
#define slasq5		SLASQ5__     
#define slasq6		SLASQ6__     
#define slasr		SLASR__	     
#define slasrt		SLASRT__     
#define slassq		SLASSQ__     
#define slasv2r		SLASV2R__    
#define slaswp		SLASWP__     
#define slasy2		SLASY2__     
#define slasyf		SLASYF__     
#define slatbs		SLATBS__     
#define slatdf		SLATDF__     
#define slatps		SLATPS__     
#define slatrd		SLATRD__     
#define slatrs		SLATRS__     
#define slatrz		SLATRZ__     
#define slatzm		SLATZM__     
#define slauu2		SLAUU2__     
#define slauum		SLAUUM__     
#define sopgtr		SOPGTR__     
#define sopmtr		SOPMTR__     
#define sorg2l		SORG2L__     
#define sorg2r		SORG2R__     
#define sorgbr		SORGBR__     
#define sorghr		SORGHR__     
#define sorgl2		SORGL2__     
#define sorglq		SORGLQ__     
#define sorgql		SORGQL__     
#define sorgqr		SORGQR__     
#define sorgr2		SORGR2__     
#define sorgrq		SORGRQ__     
#define sorgtr		SORGTR__     
#define sorm2l		SORM2L__     
#define sorm2r		SORM2R__     
#define sormbr		SORMBR__     
#define sormhr		SORMHR__     
#define sorml2		SORML2__     
#define sormlq		SORMLQ__     
#define sormql		SORMQL__     
#define sormqr		SORMQR__     
#define sormr2		SORMR2__     
#define sormr3		SORMR3__     
#define sormrq		SORMRQ__     
#define sormrz		SORMRZ__     
#define sormtr		SORMTR__     
#define spbcon		SPBCON__     
#define spbequ		SPBEQU__     
#define spbrfs		SPBRFS__     
#define spbstf		SPBSTF__     
#define spbsv		SPBSV__	     
#define spbsvx		SPBSVX__     
#define spbtf2		SPBTF2__     
#define spbtrf		SPBTRF__     
#define spbtrs		SPBTRS__     
#define spocon		SPOCON__     
#define spoequ		SPOEQU__     
#define sporfs		SPORFS__     
#define sposv		SPOSV__	     
#define sposvx		SPOSVX__     
#define spotf2		SPOTF2__     
#define spotrf		SPOTRF__     
#define spotri		SPOTRI__     
#define spotrs		SPOTRS__     
#define sppcon		SPPCON__     
#define sppequ		SPPEQU__     
#define spprfs		SPPRFS__     
#define sppsv		SPPSV__	     
#define sppsvx		SPPSVX__     
#define spptrf		SPPTRF__     
#define spptri		SPPTRI__     
#define spptrs		SPPTRS__     
#define sptcon		SPTCON__     
#define spteqr		SPTEQR__     
#define sptrfs		SPTRFS__     
#define sptsv		SPTSV__	     
#define sptsvx		SPTSVX__     
#define spttrf		SPTTRF__     
#define spttrs		SPTTRS__     
#define sptts2		SPTTS2__     
#define srscl		SRSCL__	     
#define ssbev		SSBEV__	     
#define ssbevd		SSBEVD__     
#define ssbevx		SSBEVX__     
#define ssbgst		SSBGST__     
#define ssbgv		SSBGV__	     
#define ssbgvd		SSBGVD__     
#define ssbgvx		SSBGVX__     
#define ssbtrd		SSBTRD__     
#define sspcon		SSPCON__     
#define sspev		SSPEV__	     
#define sspevd		SSPEVD__     
#define sspevx		SSPEVX__     
#define sspgst		SSPGST__     
#define sspgv		SSPGV__	     
#define sspgvd		SSPGVD__     
#define sspgvx		SSPGVX__     
#define ssprfs		SSPRFS__     
#define sspsv		SSPSV__	     
#define sspsvx		SSPSVX__     
#define ssptrd		SSPTRD__     
#define ssptrf		SSPTRF__     
#define ssptri		SSPTRI__     
#define ssptrs		SSPTRS__     
#define sstebz		SSTEBZ__     
#define sstedc		SSTEDC__     
#define sstegr		SSTEGR__     
#define sstein		SSTEIN__     
#define ssteqr		SSTEQR__     
#define ssterf		SSTERF__     
#define sstev		SSTEV__	     
#define sstevd		SSTEVD__     
#define sstevr		SSTEVR__     
#define sstevx		SSTEVX__     
#define ssycon		SSYCON__     
#define ssyev		SSYEV__	     
#define ssyevd		SSYEVD__     
#define ssyevr		SSYEVR__     
#define ssyevx		SSYEVX__     
#define ssygs2		SSYGS2__     
#define ssygst		SSYGST__     
#define ssygv		SSYGV__	     
#define ssygvd		SSYGVD__     
#define ssygvx		SSYGVX__     
#define ssyrfs		SSYRFS__     
#define ssysv		SSYSV__	     
#define ssysvx		SSYSVX__     
#define ssytd2		SSYTD2__     
#define ssytf2		SSYTF2__     
#define ssytrd		SSYTRD__     
#define ssytrf		SSYTRF__     
#define ssytri		SSYTRI__     
#define ssytrs		SSYTRS__     
#define stbcon		STBCON__     
#define stbrfs		STBRFS__     
#define stbtrs		STBTRS__     
#define stgevc		STGEVC__     
#define stgex2		STGEX2__     
#define stgexc		STGEXC__     
#define stgsen		STGSEN__     
#define stgsja		STGSJA__     
#define stgsna		STGSNA__     
#define stgsy2		STGSY2__     
#define stgsyl		STGSYL__     
#define stpcon		STPCON__     
#define stprfs		STPRFS__     
#define stptri		STPTRI__     
#define stptrs		STPTRS__     
#define strcon		STRCON__     
#define strevc		STREVC__     
#define strexc		STREXC__     
#define strrfs		STRRFS__     
#define strsen		STRSEN__     
#define strsna		STRSNA__     
#define strsyl		STRSYL__     
#define strti2		STRTI2__     
#define strtri		STRTRI__     
#define strtrs		STRTRS__     
#define stzrqf		STZRQF__     
#define stzrzf		STZRZF__     
#define xerbla		XERBLA__     
#define zbdsqr		ZBDSQR__     
#define zdrot		ZDROT__	     
#define zdrscl		ZDRSCL__     
#define zgbbrd		ZGBBRD__     
#define zgbcon		ZGBCON__     
#define zgbequ		ZGBEQU__     
#define zgbrfs		ZGBRFS__     
#define zgbsv		ZGBSV__	     
#define zgbsvx		ZGBSVX__     
#define zgbtf2		ZGBTF2__     
#define zgbtrf		ZGBTRF__     
#define zgbtrs		ZGBTRS__     
#define zgebak		ZGEBAK__     
#define zgebal		ZGEBAL__     
#define zgebd2		ZGEBD2__     
#define zgebrd		ZGEBRD__     
#define zgecon		ZGECON__     
#define zgeequ		ZGEEQU__     
#define zgees		ZGEES__	     
#define zgeesx		ZGEESX__     
#define zgeev		ZGEEV__	     
#define zgeevx		ZGEEVX__     
#define zgegs		ZGEGS__	     
#define zgegv		ZGEGV__	     
#define zgehd2		ZGEHD2__     
#define zgehrd		ZGEHRD__     
#define zgelq2		ZGELQ2__     
#define zgelqf		ZGELQF__     
#define zgels		ZGELS__	     
#define zgelsd		ZGELSD__     
#define zgelss		ZGELSS__     
#define zgelsx		ZGELSX__     
#define zgelsy		ZGELSY__     
#define zgeql2		ZGEQL2__     
#define zgeqlf		ZGEQLF__     
#define zgeqp3		ZGEQP3__     
#define zgeqpf		ZGEQPF__     
#define zgeqr2		ZGEQR2__     
#define zgeqrf		ZGEQRF__     
#define zgerfs		ZGERFS__     
#define zgerq2		ZGERQ2__     
#define zgerqf		ZGERQF__     
#define zgesc2		ZGESC2__     
#define zgesdd		ZGESDD__     
#define zgesv		ZGESV__	     
#define zgesvd		ZGESVD__     
#define zgesvx		ZGESVX__     
#define zgetc2		ZGETC2__     
#define zgetf2		ZGETF2__     
#define zgetrf		ZGETRF__     
#define zgetri		ZGETRI__     
#define zgetrs		ZGETRS__     
#define zggbak		ZGGBAK__     
#define zggbal		ZGGBAL__     
#define zgges		ZGGES__	     
#define zggesx		ZGGESX__     
#define zggev		ZGGEV__	     
#define zggevx		ZGGEVX__     
#define zggglm		ZGGGLM__     
#define zgghrd		ZGGHRD__     
#define zgglse		ZGGLSE__     
#define zggqrf		ZGGQRF__     
#define zggrqf		ZGGRQF__     
#define zggsvd		ZGGSVD__     
#define zggsvp		ZGGSVP__     
#define zgtcon		ZGTCON__     
#define zgtrfs		ZGTRFS__     
#define zgtsv		ZGTSV__	     
#define zgtsvx		ZGTSVX__     
#define zgttrf		ZGTTRF__     
#define zgttrs		ZGTTRS__     
#define zgtts2		ZGTTS2__     
#define zhbev		ZHBEV__	     
#define zhbevd		ZHBEVD__     
#define zhbevx		ZHBEVX__     
#define zhbgst		ZHBGST__     
#define zhbgv		ZHBGV__	     
#define zhbgvd		ZHBGVD__     
#define zhbgvx		ZHBGVX__     
#define zhbtrd		ZHBTRD__     
#define zhecon		ZHECON__     
#define zheev		ZHEEV__	     
#define zheevd		ZHEEVD__     
#define zheevr		ZHEEVR__     
#define zheevx		ZHEEVX__     
#define zhegs2		ZHEGS2__     
#define zhegst		ZHEGST__     
#define zhegv		ZHEGV__	     
#define zhegvd		ZHEGVD__     
#define zhegvx		ZHEGVX__     
#define zherfs		ZHERFS__     
#define zhesv		ZHESV__	     
#define zhesvx		ZHESVX__     
#define zhetd2		ZHETD2__     
#define zhetf2		ZHETF2__     
#define zhetrd		ZHETRD__     
#define zhetrf		ZHETRF__     
#define zhetri		ZHETRI__     
#define zhetrs		ZHETRS__     
#define zhgeqz		ZHGEQZ__     
#define zhpcon		ZHPCON__     
#define zhpev		ZHPEV__	     
#define zhpevd		ZHPEVD__     
#define zhpevx		ZHPEVX__     
#define zhpgst		ZHPGST__     
#define zhpgv		ZHPGV__	     
#define zhpgvd		ZHPGVD__     
#define zhpgvx		ZHPGVX__     
#define zhprfs		ZHPRFS__     
#define zhpsv		ZHPSV__	     
#define zhpsvx		ZHPSVX__     
#define zhptrd		ZHPTRD__     
#define zhptrf		ZHPTRF__     
#define zhptri		ZHPTRI__     
#define zhptrs		ZHPTRS__     
#define zhsein		ZHSEIN__     
#define zhseqr		ZHSEQR__     
#define zlabrd		ZLABRD__     
#define zlacgv		ZLACGV__     
#define zlacon		ZLACON__     
#define zlacp2		ZLACP2__     
#define zlacpy		ZLACPY__     
#define zlacrm		ZLACRM__     
#define zlacrt		ZLACRT__     
#define zladiv		ZLADIV__     
#define zlaed0		ZLAED0__     
#define zlaed7		ZLAED7__     
#define zlaed8		ZLAED8__     
#define zlaein		ZLAEIN__     
#define zlaesy		ZLAESY__     
#define zlaev2		ZLAEV2__     
#define zlags2		ZLAGS2__     
#define zlagtm		ZLAGTM__     
#define zlahef		ZLAHEF__     
#define zlahqr		ZLAHQR__     
#define zlahrd		ZLAHRD__     
#define zlaic1		ZLAIC1__     
#define zlals0		ZLALS0__     
#define zlalsa		ZLALSA__     
#define zlalsd		ZLALSD__     
#define zlangb		ZLANGB__     
#define zlange		ZLANGE__     
#define zlangt		ZLANGT__     
#define zlanhb		ZLANHB__     
#define zlanhe		ZLANHE__     
#define zlanhp		ZLANHP__     
#define zlanhs		ZLANHS__     
#define zlanht		ZLANHT__     
#define zlansb		ZLANSB__     
#define zlansp		ZLANSP__     
#define zlansy		ZLANSY__     
#define zlantb		ZLANTB__     
#define zlantp		ZLANTP__     
#define zlantr		ZLANTR__     
#define zlapll		ZLAPLL__     
#define zlapmt		ZLAPMT__     
#define zlaqgb		ZLAQGB__     
#define zlaqge		ZLAQGE__     
#define zlaqhb		ZLAQHB__     
#define zlaqhe		ZLAQHE__     
#define zlaqhp		ZLAQHP__     
#define zlaqp2		ZLAQP2__     
#define zlaqps		ZLAQPS__     
#define zlaqsb		ZLAQSB__     
#define zlaqsp		ZLAQSP__     
#define zlaqsy		ZLAQSY__     
#define zlar1v		ZLAR1V__     
#define zlar2v		ZLAR2V__     
#define zlarcm		ZLARCM__     
#define zlarf		ZLARF__	     
#define zlarfb		ZLARFB__     
#define zlarfg		ZLARFG__     
#define zlarft		ZLARFT__     
#define zlarfx		ZLARFX__     
#define zlargv		ZLARGV__     
#define zlarnv		ZLARNV__     
#define zlarrv		ZLARRV__     
#define zlartg		ZLARTG__     
#define zlartv		ZLARTV__     
#define zlarz		ZLARZ__	     
#define zlarzb		ZLARZB__     
#define zlarzt		ZLARZT__     
#define zlascl		ZLASCL__     
#define zlaset		ZLASET__     
#define zlasr		ZLASR__	     
#define zlassq		ZLASSQ__     
#define zlaswp		ZLASWP__     
#define zlasyf		ZLASYF__     
#define zlatbs		ZLATBS__     
#define zlatdf		ZLATDF__     
#define zlatps		ZLATPS__     
#define zlatrd		ZLATRD__     
#define zlatrs		ZLATRS__     
#define zlatrz		ZLATRZ__     
#define zlatzm		ZLATZM__     
#define zlauu2		ZLAUU2__     
#define zlauum		ZLAUUM__     
#define zpbcon		ZPBCON__     
#define zpbequ		ZPBEQU__     
#define zpbrfs		ZPBRFS__     
#define zpbstf		ZPBSTF__     
#define zpbsv		ZPBSV__	     
#define zpbsvx		ZPBSVX__     
#define zpbtf2		ZPBTF2__     
#define zpbtrf		ZPBTRF__     
#define zpbtrs		ZPBTRS__     
#define zpocon		ZPOCON__     
#define zpoequ		ZPOEQU__     
#define zporfs		ZPORFS__     
#define zposv		ZPOSV__	     
#define zposvx		ZPOSVX__     
#define zpotf2		ZPOTF2__     
#define zpotrf		ZPOTRF__     
#define zpotri		ZPOTRI__     
#define zpotrs		ZPOTRS__     
#define zppcon		ZPPCON__     
#define zppequ		ZPPEQU__     
#define zpprfs		ZPPRFS__     
#define zppsv		ZPPSV__	     
#define zppsvx		ZPPSVX__     
#define zpptrf		ZPPTRF__     
#define zpptri		ZPPTRI__     
#define zpptrs		ZPPTRS__     
#define zptcon		ZPTCON__     
#define zpteqr		ZPTEQR__     
#define zptrfs		ZPTRFS__     
#define zptsv		ZPTSV__	     
#define zptsvx		ZPTSVX__     
#define zpttrf		ZPTTRF__     
#define zpttrs		ZPTTRS__     
#define zptts2		ZPTTS2__     
#define zrotn		ZROTN__	     
#define zspcon		ZSPCON__     
#define zspmv		ZSPMV__	     
#define zspru		ZSPRU__	     
#define zsprfs		ZSPRFS__     
#define zspsv		ZSPSV__	     
#define zspsvx		ZSPSVX__     
#define zsptrf		ZSPTRF__     
#define zsptri		ZSPTRI__     
#define zsptrs		ZSPTRS__     
#define zstedc		ZSTEDC__     
#define zstegr		ZSTEGR__     
#define zstein		ZSTEIN__     
#define zsteqr		ZSTEQR__     
#define zsycon		ZSYCON__     
#define zsymv		ZSYMV__	     
#define zsyru		ZSYRU__	     
#define zsyrfs		ZSYRFS__     
#define zsysv		ZSYSV__	     
#define zsysvx		ZSYSVX__     
#define zsytf2		ZSYTF2__     
#define zsytrf		ZSYTRF__     
#define zsytri		ZSYTRI__     
#define zsytrs		ZSYTRS__     
#define ztbcon		ZTBCON__     
#define ztbrfs		ZTBRFS__     
#define ztbtrs		ZTBTRS__     
#define ztgevc		ZTGEVC__     
#define ztgex2		ZTGEX2__     
#define ztgexc		ZTGEXC__     
#define ztgsen		ZTGSEN__     
#define ztgsja		ZTGSJA__     
#define ztgsna		ZTGSNA__     
#define ztgsy2		ZTGSY2__     
#define ztgsyl		ZTGSYL__     
#define ztpcon		ZTPCON__     
#define ztprfs		ZTPRFS__     
#define ztptri		ZTPTRI__     
#define ztptrs		ZTPTRS__     
#define ztrcon		ZTRCON__     
#define ztrevc		ZTREVC__     
#define ztrexc		ZTREXC__     
#define ztrrfs		ZTRRFS__     
#define ztrsen		ZTRSEN__     
#define ztrsna		ZTRSNA__     
#define ztrsyl		ZTRSYL__     
#define ztrti2		ZTRTI2__     
#define ztrtri		ZTRTRI__     
#define ztrtrs		ZTRTRS__     
#define ztzrqf		ZTZRQF__     
#define ztzrzf		ZTZRZF__     
#define zung2l		ZUNG2L__     
#define zung2r		ZUNG2R__     
#define zungbr		ZUNGBR__     
#define zunghr		ZUNGHR__     
#define zungl2		ZUNGL2__     
#define zunglq		ZUNGLQ__     
#define zungql		ZUNGQL__     
#define zungqr		ZUNGQR__     
#define zungr2		ZUNGR2__     
#define zungrq		ZUNGRQ__     
#define zungtr		ZUNGTR__     
#define zunm2l		ZUNM2L__     
#define zunm2r		ZUNM2R__     
#define zunmbr		ZUNMBR__     
#define zunmhr		ZUNMHR__     
#define zunml2		ZUNML2__     
#define zunmlq		ZUNMLQ__     
#define zunmql		ZUNMQL__     
#define zunmqr		ZUNMQR__     
#define zunmr2		ZUNMR2__     
#define zunmr3		ZUNMR3__     
#define zunmrq		ZUNMRQ__     
#define zunmrz		ZUNMRZ__     
#define zunmtr		ZUNMTR__     
#define zupgtr		ZUPGTR__     
#define zupmtr		ZUPMTR__     


/* no capital letters but 2 underscores */
#elif defined __2UNDERSCORES__ && !defined __CAPS__

#define cbdsqr        cbdsqr     
#define cgbbrd	      cgbbrd     
#define cgbcon	      cgbcon     
#define cgbequ	      cgbequ     
#define cgbrfs	      cgbrfs     
#define cgbsv	      cgbsv	     
#define cgbsvx	      cgbsvx     
#define cgbtf2	      cgbtf2     
#define cgbtrf	      cgbtrf     
#define cgbtrs	      cgbtrs     
#define cgebak	      cgebak     
#define cgebal	      cgebal     
#define cgebd2	      cgebd2     
#define cgebrd	      cgebrd     
#define cgecon	      cgecon     
#define cgeequ	      cgeequ     
#define cgees	      cgees	     
#define cgeesx	      cgeesx     
#define cgeev	      cgeev	     
#define cgeevx	      cgeevx     
#define cgegs	      cgegs	     
#define cgegv	      cgegv	     
#define cgehd2	      cgehd2     
#define cgehrd	      cgehrd     
#define cgelq2	      cgelq2     
#define cgelqf	      cgelqf     
#define cgels	      cgels	     
#define cgelsd	      cgelsd     
#define cgelss	      cgelss     
#define cgelsx	      cgelsx     
#define cgelsy	      cgelsy     
#define cgeql2	      cgeql2     
#define cgeqlf	      cgeqlf     
#define cgeqp3	      cgeqp3     
#define cgeqpf	      cgeqpf     
#define cgeqr2	      cgeqr2     
#define cgeqrf	      cgeqrf     
#define cgerfs	      cgerfs     
#define cgerq2	      cgerq2     
#define cgerqf	      cgerqf     
#define cgesc2	      cgesc2     
#define cgesdd	      cgesdd     
#define cgesv	      cgesv	     
#define cgesvd	      cgesvd     
#define cgesvx	      cgesvx     
#define cgetc2	      cgetc2     
#define cgetf2	      cgetf2     
#define cgetrf	      cgetrf     
#define cgetri	      cgetri     
#define cgetrs	      cgetrs     
#define cggbak	      cggbak     
#define cggbal	      cggbal     
#define cgges	      cgges	     
#define cggesx	      cggesx     
#define cggev	      cggev	     
#define cggevx	      cggevx     
#define cggglm	      cggglm     
#define cgghrd	      cgghrd     
#define cgglse	      cgglse     
#define cggqrf	      cggqrf     
#define cggrqf	      cggrqf     
#define cggsvd	      cggsvd     
#define cggsvp	      cggsvp     
#define cgtcon	      cgtcon     
#define cgtrfs	      cgtrfs     
#define cgtsv	      cgtsv	     
#define cgtsvx	      cgtsvx     
#define cgttrf	      cgttrf     
#define cgttrs	      cgttrs     
#define cgtts2	      cgtts2     
#define chbev	      chbev	     
#define chbevd	      chbevd     
#define chbevx	      chbevx     
#define chbgst	      chbgst     
#define chbgv	      chbgv	     
#define chbgvd	      chbgvd     
#define chbgvx	      chbgvx     
#define chbtrd	      chbtrd     
#define checon	      checon     
#define cheev	      cheev	     
#define cheevd	      cheevd     
#define cheevr	      cheevr     
#define cheevx	      cheevx     
#define chegs2	      chegs2     
#define chegst	      chegst     
#define chegv	      chegv	     
#define chegvd	      chegvd     
#define chegvx	      chegvx     
#define cherfs	      cherfs     
#define chesv	      chesv	     
#define chesvx	      chesvx     
#define chetd2	      chetd2     
#define chetf2	      chetf2     
#define chetrd	      chetrd     
#define chetrf	      chetrf     
#define chetri	      chetri     
#define chetrs	      chetrs     
#define chgeqz	      chgeqz     
#define chpcon	      chpcon     
#define chpev	      chpev	     
#define chpevd	      chpevd     
#define chpevx	      chpevx     
#define chpgst	      chpgst     
#define chpgv	      chpgv	     
#define chpgvd	      chpgvd     
#define chpgvx	      chpgvx     
#define chprfs	      chprfs     
#define chpsv	      chpsv	     
#define chpsvx	      chpsvx     
#define chptrd	      chptrd     
#define chptrf	      chptrf     
#define chptri	      chptri     
#define chptrs	      chptrs     
#define chsein	      chsein     
#define chseqr	      chseqr     
#define clabrd	      clabrd     
#define clacgv	      clacgv     
#define clacon	      clacon     
#define clacp2	      clacp2     
#define clacpy	      clacpy     
#define clacrm	      clacrm     
#define clacrt	      clacrt     
#define cladiv	      cladiv     
#define claed0	      claed0     
#define claed7	      claed7     
#define claed8	      claed8     
#define claein	      claein     
#define claesy	      claesy     
#define claev2	      claev2     
#define clags2	      clags2     
#define clagtm	      clagtm     
#define clahef	      clahef     
#define clahqr	      clahqr     
#define clahrd	      clahrd     
#define claic1	      claic1     
#define clals0	      clals0     
#define clalsa	      clalsa     
#define clalsd	      clalsd     
#define clangb	      clangb     
#define clange	      clange     
#define clangt	      clangt     
#define clanhb	      clanhb     
#define clanhe	      clanhe     
#define clanhp	      clanhp     
#define clanhs	      clanhs     
#define clanht	      clanht     
#define clansb	      clansb     
#define clansp	      clansp     
#define clansy	      clansy     
#define clantb	      clantb     
#define clantp	      clantp     
#define clantr	      clantr     
#define clapll	      clapll     
#define clapmt	      clapmt     
#define claqgb	      claqgb     
#define claqge	      claqge     
#define claqhb	      claqhb     
#define claqhe	      claqhe     
#define claqhp	      claqhp     
#define claqp2	      claqp2     
#define claqps	      claqps     
#define claqsb	      claqsb     
#define claqsp	      claqsp     
#define claqsy	      claqsy     
#define clar1v	      clar1v     
#define clar2v	      clar2v     
#define clarcm	      clarcm     
#define clarf	      clarf	     
#define clarfb	      clarfb     
#define clarfg	      clarfg     
#define clarft	      clarft     
#define clarfx	      clarfx     
#define clargv	      clargv     
#define clarnv	      clarnv     
#define clarrv	      clarrv     
#define clartg	      clartg     
#define clartv	      clartv     
#define clarz	      clarz	     
#define clarzb	      clarzb     
#define clarzt	      clarzt     
#define clascl	      clascl     
#define claset	      claset     
#define clasr	      clasr	     
#define classq	      classq     
#define claswp	      claswp     
#define clasyf	      clasyf     
#define clatbs	      clatbs     
#define clatdf	      clatdf     
#define clatps	      clatps     
#define clatrd	      clatrd     
#define clatrs	      clatrs     
#define clatrz	      clatrz     
#define clatzm	      clatzm     
#define clauu2	      clauu2     
#define clauum	      clauum     
#define cpbcon	      cpbcon     
#define cpbequ	      cpbequ     
#define cpbrfs	      cpbrfs     
#define cpbstf	      cpbstf     
#define cpbsv	      cpbsv	     
#define cpbsvx	      cpbsvx     
#define cpbtf2	      cpbtf2     
#define cpbtrf	      cpbtrf     
#define cpbtrs	      cpbtrs     
#define cpocon	      cpocon     
#define cpoequ	      cpoequ     
#define cporfs	      cporfs     
#define cposv	      cposv	     
#define cposvx	      cposvx     
#define cpotf2	      cpotf2     
#define cpotrf	      cpotrf     
#define cpotri	      cpotri     
#define cpotrs	      cpotrs     
#define cppcon	      cppcon     
#define cppequ	      cppequ     
#define cpprfs	      cpprfs     
#define cppsv	      cppsv	     
#define cppsvx	      cppsvx     
#define cpptrf	      cpptrf     
#define cpptri	      cpptri     
#define cpptrs	      cpptrs     
#define cptcon	      cptcon     
#define cpteqr	      cpteqr     
#define cptrfs	      cptrfs     
#define cptsv	      cptsv	     
#define cptsvx	      cptsvx     
#define cpttrf	      cpttrf     
#define cpttrs	      cpttrs     
#define cptts2	      cptts2     
#define crotn	      crotn	     
#define cspcon	      cspcon     
#define cspmv	      cspmv	     
#define cspru	      cspru	     
#define csprfs	      csprfs     
#define cspsv	      cspsv	     
#define cspsvx	      cspsvx     
#define csptrf	      csptrf     
#define csptri	      csptri     
#define csptrs	      csptrs     
#define csrot	      csrot	     
#define csrscl	      csrscl     
#define cstedc	      cstedc     
#define cstegr	      cstegr     
#define cstein	      cstein     
#define csteqr	      csteqr     
#define csycon	      csycon     
#define csymv	      csymv	     
#define csyru	      csyru	     
#define csyrfs	      csyrfs     
#define csysv	      csysv	     
#define csysvx	      csysvx     
#define csytf2	      csytf2     
#define csytrf	      csytrf     
#define csytri	      csytri     
#define csytrs	      csytrs     
#define ctbcon	      ctbcon     
#define ctbrfs	      ctbrfs     
#define ctbtrs	      ctbtrs     
#define ctgevc	      ctgevc     
#define ctgex2	      ctgex2     
#define ctgexc	      ctgexc     
#define ctgsen	      ctgsen     
#define ctgsja	      ctgsja     
#define ctgsna	      ctgsna     
#define ctgsy2	      ctgsy2     
#define ctgsyl	      ctgsyl     
#define ctpcon	      ctpcon     
#define ctprfs	      ctprfs     
#define ctptri	      ctptri     
#define ctptrs	      ctptrs     
#define ctrcon	      ctrcon     
#define ctrevc	      ctrevc     
#define ctrexc	      ctrexc     
#define ctrrfs	      ctrrfs     
#define ctrsen	      ctrsen     
#define ctrsna	      ctrsna     
#define ctrsyl	      ctrsyl     
#define ctrti2	      ctrti2     
#define ctrtri	      ctrtri     
#define ctrtrs	      ctrtrs     
#define ctzrqf	      ctzrqf     
#define ctzrzf	      ctzrzf     
#define cung2l	      cung2l     
#define cung2r	      cung2r     
#define cungbr	      cungbr     
#define cunghr	      cunghr     
#define cungl2	      cungl2     
#define cunglq	      cunglq     
#define cungql	      cungql     
#define cungqr	      cungqr     
#define cungr2	      cungr2     
#define cungrq	      cungrq     
#define cungtr	      cungtr     
#define cunm2l	      cunm2l     
#define cunm2r	      cunm2r     
#define cunmbr	      cunmbr     
#define cunmhr	      cunmhr     
#define cunml2	      cunml2     
#define cunmlq	      cunmlq     
#define cunmql	      cunmql     
#define cunmqr	      cunmqr     
#define cunmr2	      cunmr2     
#define cunmr3	      cunmr3     
#define cunmrq	      cunmrq     
#define cunmrz	      cunmrz     
#define cunmtr	      cunmtr     
#define cupgtr	      cupgtr     
#define cupmtr	      cupmtr     
#define dbdsdc	      dbdsdc     
#define dbdsqr	      dbdsqr     
#define ddisna	      ddisna     
#define dgbbrd	      dgbbrd     
#define dgbcon	      dgbcon     
#define dgbequ	      dgbequ     
#define dgbrfs	      dgbrfs     
#define dgbsv	      dgbsv	     
#define dgbsvx	      dgbsvx     
#define dgbtf2	      dgbtf2     
#define dgbtrf	      dgbtrf     
#define dgbtrs	      dgbtrs     
#define dgebak	      dgebak     
#define dgebal	      dgebal     
#define dgebd2	      dgebd2     
#define dgebrd	      dgebrd     
#define dgecon	      dgecon     
#define dgeequ	      dgeequ     
#define dgees	      dgees	     
#define dgeesx	      dgeesx     
#define dgeev	      dgeev	     
#define dgeevx	      dgeevx     
#define dgegs	      dgegs	     
#define dgegv	      dgegv	     
#define dgehd2	      dgehd2     
#define dgehrd	      dgehrd     
#define dgelq2	      dgelq2     
#define dgelqf	      dgelqf     
#define dgels	      dgels	     
#define dgelsd	      dgelsd     
#define dgelss	      dgelss     
#define dgelsx	      dgelsx     
#define dgelsy	      dgelsy     
#define dgeql2	      dgeql2     
#define dgeqlf	      dgeqlf     
#define dgeqp3	      dgeqp3     
#define dgeqpf	      dgeqpf     
#define dgeqr2	      dgeqr2     
#define dgeqrf	      dgeqrf     
#define dgerfs	      dgerfs     
#define dgerq2	      dgerq2     
#define dgerqf	      dgerqf     
#define dgesc2	      dgesc2     
#define dgesdd	      dgesdd     
#define dgesv	      dgesv	     
#define dgesvd	      dgesvd     
#define dgesvx	      dgesvx     
#define dgetc2	      dgetc2     
#define dgetf2	      dgetf2     
#define dgetrf	      dgetrf     
#define dgetri	      dgetri     
#define dgetrs	      dgetrs     
#define dggbak	      dggbak     
#define dggbal	      dggbal     
#define dgges	      dgges	     
#define dggesx	      dggesx     
#define dggev	      dggev	     
#define dggevx	      dggevx     
#define dggglm	      dggglm     
#define dgghrd	      dgghrd     
#define dgglse	      dgglse     
#define dggqrf	      dggqrf     
#define dggrqf	      dggrqf     
#define dggsvd	      dggsvd     
#define dggsvp	      dggsvp     
#define dgtcon	      dgtcon     
#define dgtrfs	      dgtrfs     
#define dgtsv	      dgtsv	     
#define dgtsvx	      dgtsvx     
#define dgttrf	      dgttrf     
#define dgttrs	      dgttrs     
#define dgtts2	      dgtts2     
#define dhgeqz	      dhgeqz     
#define dhsein	      dhsein     
#define dhseqr	      dhseqr     
#define dlabad	      dlabad     
#define dlabrd	      dlabrd     
#define dlacon	      dlacon     
#define dlacpy	      dlacpy     
#define dladiv	      dladiv     
#define dlae2a	      dlae2a     
#define dlaebz	      dlaebz     
#define dlaed0	      dlaed0     
#define dlaed1	      dlaed1     
#define dlaed2	      dlaed2     
#define dlaed3	      dlaed3     
#define dlaed4	      dlaed4     
#define dlaed5	      dlaed5     
#define dlaed6	      dlaed6     
#define dlaed7	      dlaed7     
#define dlaed8	      dlaed8     
#define dlaed9	      dlaed9     
#define dlaeda	      dlaeda     
#define dlaein	      dlaein     
#define dlaev2	      dlaev2     
#define dlaexc	      dlaexc     
#define dlag2a	      dlag2a     
#define dlags2	      dlags2     
#define dlagtf	      dlagtf     
#define dlagtm	      dlagtm     
#define dlagts	      dlagts     
#define dlagv2	      dlagv2     
#define dlahqr	      dlahqr     
#define dlahrd	      dlahrd     
#define dlaic1	      dlaic1     
#define dlaln2	      dlaln2     
#define dlals0	      dlals0     
#define dlalsa	      dlalsa     
#define dlalsd	      dlalsd     
#define dlamch	      dlamch     
#define dlamc1	      dlamc1     
#define dlamc2	      dlamc2     
#define dlamc3	      dlamc3     
#define dlamc4	      dlamc4     
#define dlamc5	      dlamc5     
#define dlamrg	      dlamrg     
#define dlangb	      dlangb     
#define dlange	      dlange     
#define dlangt	      dlangt     
#define dlanhs	      dlanhs     
#define dlansb	      dlansb     
#define dlansp	      dlansp     
#define dlanst	      dlanst     
#define dlansy	      dlansy     
#define dlantb	      dlantb     
#define dlantp	      dlantp     
#define dlantr	      dlantr     
#define dlanv2	      dlanv2     
#define dlapll	      dlapll     
#define dlapmt	      dlapmt     
#define dlapy2	      dlapy2     
#define dlapy3	      dlapy3     
#define dlaqgb	      dlaqgb     
#define dlaqge	      dlaqge     
#define dlaqp2	      dlaqp2     
#define dlaqps	      dlaqps     
#define dlaqsb	      dlaqsb     
#define dlaqsp	      dlaqsp     
#define dlaqsy	      dlaqsy     
#define dlaqtr	      dlaqtr     
#define dlar1v	      dlar1v     
#define dlar2v	      dlar2v     
#define dlarf	      dlarf	     
#define dlarfb	      dlarfb     
#define dlarfg	      dlarfg     
#define dlarft	      dlarft     
#define dlarfx	      dlarfx     
#define dlargv	      dlargv     
#define dlarnv	      dlarnv     
#define dlarrb	      dlarrb     
#define dlarre	      dlarre     
#define dlarrf	      dlarrf     
#define dlarrv	      dlarrv     
#define dlartg	      dlartg     
#define dlartv	      dlartv     
#define dlaruv	      dlaruv     
#define dlarz	      dlarz	     
#define dlarzb	      dlarzb     
#define dlarzt	      dlarzt     
#define dlas2f	      dlas2f     
#define dlascl	      dlascl     
#define dlasd0	      dlasd0     
#define dlasd1	      dlasd1     
#define dlasd2	      dlasd2     
#define dlasd3	      dlasd3     
#define dlasd4	      dlasd4     
#define dlasd5	      dlasd5     
#define dlasd6	      dlasd6     
#define dlasd7	      dlasd7     
#define dlasd8	      dlasd8     
#define dlasd9	      dlasd9     
#define dlasda	      dlasda     
#define dlasdq	      dlasdq     
#define dlasdt	      dlasdt     
#define dlaset	      dlaset     
#define dlasq1	      dlasq1     
#define dlasq2	      dlasq2     
#define dlasq3	      dlasq3     
#define dlasq4	      dlasq4     
#define dlasq5	      dlasq5     
#define dlasq6	      dlasq6     
#define dlasr	      dlasr	     
#define dlasrt	      dlasrt     
#define dlassq	      dlassq     
#define dlasv2	      dlasv2     
#define dlaswp	      dlaswp     
#define dlasy2	      dlasy2     
#define dlasyf	      dlasyf     
#define dlatbs	      dlatbs     
#define dlatdf	      dlatdf     
#define dlatps	      dlatps     
#define dlatrd	      dlatrd     
#define dlatrs	      dlatrs     
#define dlatrz	      dlatrz     
#define dlatzm	      dlatzm     
#define dlauu2	      dlauu2     
#define dlauum	      dlauum     
#define dopgtr	      dopgtr     
#define dopmtr	      dopmtr     
#define dorg2l	      dorg2l     
#define dorg2r	      dorg2r     
#define dorgbr	      dorgbr     
#define dorghr	      dorghr     
#define dorgl2	      dorgl2     
#define dorglq	      dorglq     
#define dorgql	      dorgql     
#define dorgqr	      dorgqr     
#define dorgr2	      dorgr2     
#define dorgrq	      dorgrq     
#define dorgtr	      dorgtr     
#define dorm2l	      dorm2l     
#define dorm2r	      dorm2r     
#define dormbr	      dormbr     
#define dormhr	      dormhr     
#define dorml2	      dorml2     
#define dormlq	      dormlq     
#define dormql	      dormql     
#define dormqr	      dormqr     
#define dormr2	      dormr2     
#define dormr3	      dormr3     
#define dormrq	      dormrq     
#define dormrz	      dormrz     
#define dormtr	      dormtr     
#define dpbcon	      dpbcon     
#define dpbequ	      dpbequ     
#define dpbrfs	      dpbrfs     
#define dpbstf	      dpbstf     
#define dpbsv	      dpbsv	     
#define dpbsvx	      dpbsvx     
#define dpbtf2	      dpbtf2     
#define dpbtrf	      dpbtrf     
#define dpbtrs	      dpbtrs     
#define dpocon	      dpocon     
#define dpoequ	      dpoequ     
#define dporfs	      dporfs     
#define dposv	      dposv	     
#define dposvx	      dposvx     
#define dpotf2	      dpotf2     
#define dpotrf	      dpotrf     
#define dpotri	      dpotri     
#define dpotrs	      dpotrs     
#define dppcon	      dppcon     
#define dppequ	      dppequ     
#define dpprfs	      dpprfs     
#define dppsv	      dppsv	     
#define dppsvx	      dppsvx     
#define dpptrf	      dpptrf     
#define dpptri	      dpptri     
#define dpptrs	      dpptrs     
#define dptcon	      dptcon     
#define dpteqr	      dpteqr     
#define dptrfs	      dptrfs     
#define dptsv	      dptsv	     
#define dptsvx	      dptsvx     
#define dpttrf	      dpttrf     
#define dpttrs	      dpttrs     
#define dptts2	      dptts2     
#define drscl	      drscl	     
#define dsbev	      dsbev	     
#define dsbevd	      dsbevd     
#define dsbevx	      dsbevx     
#define dsbgst	      dsbgst     
#define dsbgv	      dsbgv	     
#define dsbgvd	      dsbgvd     
#define dsbgvx	      dsbgvx     
#define dsbtrd	      dsbtrd     
#define dsecnd	      dsecnd     
#define dspcon	      dspcon     
#define dspev	      dspev	     
#define dspevd	      dspevd     
#define dspevx	      dspevx     
#define dspgst	      dspgst     
#define dspgv	      dspgv	     
#define dspgvd	      dspgvd     
#define dspgvx	      dspgvx     
#define dsprfs	      dsprfs     
#define dspsv	      dspsv	     
#define dspsvx	      dspsvx     
#define dsptrd	      dsptrd     
#define dsptrf	      dsptrf     
#define dsptri	      dsptri     
#define dsptrs	      dsptrs     
#define dstebz	      dstebz     
#define dstedc	      dstedc     
#define dstegr	      dstegr     
#define dstein	      dstein     
#define dsteqr	      dsteqr     
#define dsterf	      dsterf     
#define dstev	      dstev	     
#define dstevd	      dstevd     
#define dstevr	      dstevr     
#define dstevx	      dstevx     
#define dsycon	      dsycon     
#define dsyev	      dsyev	     
#define dsyevd	      dsyevd     
#define dsyevr	      dsyevr     
#define dsyevx	      dsyevx     
#define dsygs2	      dsygs2     
#define dsygst	      dsygst     
#define dsygv	      dsygv	     
#define dsygvd	      dsygvd     
#define dsygvx	      dsygvx     
#define dsyrfs	      dsyrfs     
#define dsysv	      dsysv	     
#define dsysvx	      dsysvx     
#define dsytd2	      dsytd2     
#define dsytf2	      dsytf2     
#define dsytrd	      dsytrd     
#define dsytrf	      dsytrf     
#define dsytri	      dsytri     
#define dsytrs	      dsytrs     
#define dtbcon	      dtbcon     
#define dtbrfs	      dtbrfs     
#define dtbtrs	      dtbtrs     
#define dtgevc	      dtgevc     
#define dtgex2	      dtgex2     
#define dtgexc	      dtgexc     
#define dtgsen	      dtgsen     
#define dtgsja	      dtgsja     
#define dtgsna	      dtgsna     
#define dtgsy2	      dtgsy2     
#define dtgsyl	      dtgsyl     
#define dtpcon	      dtpcon     
#define dtprfs	      dtprfs     
#define dtptri	      dtptri     
#define dtptrs	      dtptrs     
#define dtrcon	      dtrcon     
#define dtrevc	      dtrevc     
#define dtrexc	      dtrexc     
#define dtrrfs	      dtrrfs     
#define dtrsen	      dtrsen     
#define dtrsna	      dtrsna     
#define dtrsyl	      dtrsyl     
#define dtrti2	      dtrti2     
#define dtrtri	      dtrtri     
#define dtrtrs	      dtrtrs     
#define dtzrqf	      dtzrqf     
#define dtzrzf	      dtzrzf     
#define dzsum1	      dzsum1     
#define icmax1	      icmax1     
#define ieeeck	      ieeeck     
#define ilaenv	      ilaenv     
#define izmax1	      izmax1     
#define lsamech	      lsamech    
#define lsamen	      lsamen     
#define sbdsdc	      sbdsdc     
#define sbdsqr	      sbdsqr     
#define scsum1	      scsum1     
#define sdisna	      sdisna     
#define secondv	      secondv    
#define sgbbrd	      sgbbrd     
#define sgbcon	      sgbcon     
#define sgbequ	      sgbequ     
#define sgbrfs	      sgbrfs     
#define sgbsv	      sgbsv	     
#define sgbsvx	      sgbsvx     
#define sgbtf2	      sgbtf2     
#define sgbtrf	      sgbtrf     
#define sgbtrs	      sgbtrs     
#define sgebak	      sgebak     
#define sgebal	      sgebal     
#define sgebd2	      sgebd2     
#define sgebrd	      sgebrd     
#define sgecon	      sgecon     
#define sgeequ	      sgeequ     
#define sgees	      sgees	     
#define sgeesx	      sgeesx     
#define sgeev	      sgeev	     
#define sgeevx	      sgeevx     
#define sgegs	      sgegs	     
#define sgegv	      sgegv	     
#define sgehd2	      sgehd2     
#define sgehrd	      sgehrd     
#define sgelq2	      sgelq2     
#define sgelqf	      sgelqf     
#define sgels	      sgels	     
#define sgelsd	      sgelsd     
#define sgelss	      sgelss     
#define sgelsx	      sgelsx     
#define sgelsy	      sgelsy     
#define sgeql2	      sgeql2     
#define sgeqlf	      sgeqlf     
#define sgeqp3	      sgeqp3     
#define sgeqpf	      sgeqpf     
#define sgeqr2	      sgeqr2     
#define sgeqrf	      sgeqrf     
#define sgerfs	      sgerfs     
#define sgerq2	      sgerq2     
#define sgerqf	      sgerqf     
#define sgesc2	      sgesc2     
#define sgesdd	      sgesdd     
#define sgesv	      sgesv	     
#define sgesvd	      sgesvd     
#define sgesvx	      sgesvx     
#define sgetc2	      sgetc2     
#define sgetf2	      sgetf2     
#define sgetrf	      sgetrf     
#define sgetri	      sgetri     
#define sgetrs	      sgetrs     
#define sggbak	      sggbak     
#define sggbal	      sggbal     
#define sgges	      sgges	     
#define sggesx	      sggesx     
#define sggev	      sggev	     
#define sggevx	      sggevx     
#define sggglm	      sggglm     
#define sgghrd	      sgghrd     
#define sgglse	      sgglse     
#define sggqrf	      sggqrf     
#define sggrqf	      sggrqf     
#define sggsvd	      sggsvd     
#define sggsvp	      sggsvp     
#define sgtcon	      sgtcon     
#define sgtrfs	      sgtrfs     
#define sgtsv	      sgtsv	     
#define sgtsvx	      sgtsvx     
#define sgttrf	      sgttrf     
#define sgttrs	      sgttrs     
#define sgtts2	      sgtts2     
#define shgeqz	      shgeqz     
#define shsein	      shsein     
#define shseqr	      shseqr     
#define slabadr	      slabadr    
#define slabrd	      slabrd     
#define slacon	      slacon     
#define slacpy	      slacpy     
#define sladivr	      sladivr    
#define slae2re	      slae2re    
#define slaebz	      slaebz     
#define slaed0	      slaed0     
#define slaed1	      slaed1     
#define slaed2	      slaed2     
#define slaed3	      slaed3     
#define slaed4	      slaed4     
#define slaed5	      slaed5     
#define slaed6	      slaed6     
#define slaed7	      slaed7     
#define slaed8	      slaed8     
#define slaed9	      slaed9     
#define slaeda	      slaeda     
#define slaein	      slaein     
#define slaev2r	      slaev2r    
#define slaexc	      slaexc     
#define slag2re	      slag2re    
#define slags2	      slags2     
#define slagtf	      slagtf     
#define slagtm	      slagtm     
#define slagts	      slagts     
#define slagv2r	      slagv2r    
#define slahqr	      slahqr     
#define slahrd	      slahrd     
#define slaic1	      slaic1     
#define slaln2	      slaln2     
#define slals0	      slals0     
#define slalsa	      slalsa     
#define slalsd	      slalsd     
#define slamch	      slamch     
#define slamc1	      slamc1     
#define slamc2	      slamc2     
#define slamc3r	      slamc3r    
#define slamc4	      slamc4     
#define slamc5	      slamc5     
#define slamrg	      slamrg     
#define slangb	      slangb     
#define slange	      slange     
#define slangt	      slangt     
#define slanhs	      slanhs     
#define slansb	      slansb     
#define slansp	      slansp     
#define slanst	      slanst     
#define slansy	      slansy     
#define slantb	      slantb     
#define slantp	      slantp     
#define slantr	      slantr     
#define slanv2r	      slanv2r    
#define slapll	      slapll     
#define slapmt	      slapmt     
#define slapy2r	      slapy2r    
#define slapy3r	      slapy3r    
#define slaqgb	      slaqgb     
#define slaqge	      slaqge     
#define slaqp2	      slaqp2     
#define slaqps	      slaqps     
#define slaqsb	      slaqsb     
#define slaqsp	      slaqsp     
#define slaqsy	      slaqsy     
#define slaqtr	      slaqtr     
#define slar1v	      slar1v     
#define slar2v	      slar2v     
#define slarf	      slarf	     
#define slarfb	      slarfb     
#define slarfg	      slarfg     
#define slarft	      slarft     
#define slarfx	      slarfx     
#define slargv	      slargv     
#define slarnv	      slarnv     
#define slarrb	      slarrb     
#define slarre	      slarre     
#define slarrf	      slarrf     
#define slarrv	      slarrv     
#define slartgr	      slartgr    
#define slartv	      slartv     
#define slaruv	      slaruv     
#define slarz	      slarz	     
#define slarzb	      slarzb     
#define slarzt	      slarzt     
#define slas2re	      slas2re    
#define slascl	      slascl     
#define slasd0	      slasd0     
#define slasd1	      slasd1     
#define slasd2	      slasd2     
#define slasd3	      slasd3     
#define slasd4	      slasd4     
#define slasd5	      slasd5     
#define slasd6	      slasd6     
#define slasd7	      slasd7     
#define slasd8	      slasd8     
#define slasd9	      slasd9     
#define slasda	      slasda     
#define slasdq	      slasdq     
#define slasdt	      slasdt     
#define slaset	      slaset     
#define slasq1	      slasq1     
#define slasq2	      slasq2     
#define slasq3	      slasq3     
#define slasq4	      slasq4     
#define slasq5	      slasq5     
#define slasq6	      slasq6     
#define slasr	      slasr	     
#define slasrt	      slasrt     
#define slassq	      slassq     
#define slasv2r	      slasv2r    
#define slaswp	      slaswp     
#define slasy2	      slasy2     
#define slasyf	      slasyf     
#define slatbs	      slatbs     
#define slatdf	      slatdf     
#define slatps	      slatps     
#define slatrd	      slatrd     
#define slatrs	      slatrs     
#define slatrz	      slatrz     
#define slatzm	      slatzm     
#define slauu2	      slauu2     
#define slauum	      slauum     
#define sopgtr	      sopgtr     
#define sopmtr	      sopmtr     
#define sorg2l	      sorg2l     
#define sorg2r	      sorg2r     
#define sorgbr	      sorgbr     
#define sorghr	      sorghr     
#define sorgl2	      sorgl2     
#define sorglq	      sorglq     
#define sorgql	      sorgql     
#define sorgqr	      sorgqr     
#define sorgr2	      sorgr2     
#define sorgrq	      sorgrq     
#define sorgtr	      sorgtr     
#define sorm2l	      sorm2l     
#define sorm2r	      sorm2r     
#define sormbr	      sormbr     
#define sormhr	      sormhr     
#define sorml2	      sorml2     
#define sormlq	      sormlq     
#define sormql	      sormql     
#define sormqr	      sormqr     
#define sormr2	      sormr2     
#define sormr3	      sormr3     
#define sormrq	      sormrq     
#define sormrz	      sormrz     
#define sormtr	      sormtr     
#define spbcon	      spbcon     
#define spbequ	      spbequ     
#define spbrfs	      spbrfs     
#define spbstf	      spbstf     
#define spbsv	      spbsv	     
#define spbsvx	      spbsvx     
#define spbtf2	      spbtf2     
#define spbtrf	      spbtrf     
#define spbtrs	      spbtrs     
#define spocon	      spocon     
#define spoequ	      spoequ     
#define sporfs	      sporfs     
#define sposv	      sposv	     
#define sposvx	      sposvx     
#define spotf2	      spotf2     
#define spotrf	      spotrf     
#define spotri	      spotri     
#define spotrs	      spotrs     
#define sppcon	      sppcon     
#define sppequ	      sppequ     
#define spprfs	      spprfs     
#define sppsv	      sppsv	     
#define sppsvx	      sppsvx     
#define spptrf	      spptrf     
#define spptri	      spptri     
#define spptrs	      spptrs     
#define sptcon	      sptcon     
#define spteqr	      spteqr     
#define sptrfs	      sptrfs     
#define sptsv	      sptsv	     
#define sptsvx	      sptsvx     
#define spttrf	      spttrf     
#define spttrs	      spttrs     
#define sptts2	      sptts2     
#define srscl	      srscl	     
#define ssbev	      ssbev	     
#define ssbevd	      ssbevd     
#define ssbevx	      ssbevx     
#define ssbgst	      ssbgst     
#define ssbgv	      ssbgv	     
#define ssbgvd	      ssbgvd     
#define ssbgvx	      ssbgvx     
#define ssbtrd	      ssbtrd     
#define sspcon	      sspcon     
#define sspev	      sspev	     
#define sspevd	      sspevd     
#define sspevx	      sspevx     
#define sspgst	      sspgst     
#define sspgv	      sspgv	     
#define sspgvd	      sspgvd     
#define sspgvx	      sspgvx     
#define ssprfs	      ssprfs     
#define sspsv	      sspsv	     
#define sspsvx	      sspsvx     
#define ssptrd	      ssptrd     
#define ssptrf	      ssptrf     
#define ssptri	      ssptri     
#define ssptrs	      ssptrs     
#define sstebz	      sstebz     
#define sstedc	      sstedc     
#define sstegr	      sstegr     
#define sstein	      sstein     
#define ssteqr	      ssteqr     
#define ssterf	      ssterf     
#define sstev	      sstev	     
#define sstevd	      sstevd     
#define sstevr	      sstevr     
#define sstevx	      sstevx     
#define ssycon	      ssycon     
#define ssyev	      ssyev	     
#define ssyevd	      ssyevd     
#define ssyevr	      ssyevr     
#define ssyevx	      ssyevx     
#define ssygs2	      ssygs2     
#define ssygst	      ssygst     
#define ssygv	      ssygv	     
#define ssygvd	      ssygvd     
#define ssygvx	      ssygvx     
#define ssyrfs	      ssyrfs     
#define ssysv	      ssysv	     
#define ssysvx	      ssysvx     
#define ssytd2	      ssytd2     
#define ssytf2	      ssytf2     
#define ssytrd	      ssytrd     
#define ssytrf	      ssytrf     
#define ssytri	      ssytri     
#define ssytrs	      ssytrs     
#define stbcon	      stbcon     
#define stbrfs	      stbrfs     
#define stbtrs	      stbtrs     
#define stgevc	      stgevc     
#define stgex2	      stgex2     
#define stgexc	      stgexc     
#define stgsen	      stgsen     
#define stgsja	      stgsja     
#define stgsna	      stgsna     
#define stgsy2	      stgsy2     
#define stgsyl	      stgsyl     
#define stpcon	      stpcon     
#define stprfs	      stprfs     
#define stptri	      stptri     
#define stptrs	      stptrs     
#define strcon	      strcon     
#define strevc	      strevc     
#define strexc	      strexc     
#define strrfs	      strrfs     
#define strsen	      strsen     
#define strsna	      strsna     
#define strsyl	      strsyl     
#define strti2	      strti2     
#define strtri	      strtri     
#define strtrs	      strtrs     
#define stzrqf	      stzrqf     
#define stzrzf	      stzrzf     
#define xerbla	      xerbla     
#define zbdsqr	      zbdsqr     
#define zdrot	      zdrot	     
#define zdrscl	      zdrscl     
#define zgbbrd	      zgbbrd     
#define zgbcon	      zgbcon     
#define zgbequ	      zgbequ     
#define zgbrfs	      zgbrfs     
#define zgbsv	      zgbsv	     
#define zgbsvx	      zgbsvx     
#define zgbtf2	      zgbtf2     
#define zgbtrf	      zgbtrf     
#define zgbtrs	      zgbtrs     
#define zgebak	      zgebak     
#define zgebal	      zgebal     
#define zgebd2	      zgebd2     
#define zgebrd	      zgebrd     
#define zgecon	      zgecon     
#define zgeequ	      zgeequ     
#define zgees	      zgees	     
#define zgeesx	      zgeesx     
#define zgeev	      zgeev	     
#define zgeevx	      zgeevx     
#define zgegs	      zgegs	     
#define zgegv	      zgegv	     
#define zgehd2	      zgehd2     
#define zgehrd	      zgehrd     
#define zgelq2	      zgelq2     
#define zgelqf	      zgelqf     
#define zgels	      zgels	     
#define zgelsd	      zgelsd     
#define zgelss	      zgelss     
#define zgelsx	      zgelsx     
#define zgelsy	      zgelsy     
#define zgeql2	      zgeql2     
#define zgeqlf	      zgeqlf     
#define zgeqp3	      zgeqp3     
#define zgeqpf	      zgeqpf     
#define zgeqr2	      zgeqr2     
#define zgeqrf	      zgeqrf     
#define zgerfs	      zgerfs     
#define zgerq2	      zgerq2     
#define zgerqf	      zgerqf     
#define zgesc2	      zgesc2     
#define zgesdd	      zgesdd     
#define zgesv	      zgesv	     
#define zgesvd	      zgesvd     
#define zgesvx	      zgesvx     
#define zgetc2	      zgetc2     
#define zgetf2	      zgetf2     
#define zgetrf	      zgetrf     
#define zgetri	      zgetri     
#define zgetrs	      zgetrs     
#define zggbak	      zggbak     
#define zggbal	      zggbal     
#define zgges	      zgges	     
#define zggesx	      zggesx     
#define zggev	      zggev	     
#define zggevx	      zggevx     
#define zggglm	      zggglm     
#define zgghrd	      zgghrd     
#define zgglse	      zgglse     
#define zggqrf	      zggqrf     
#define zggrqf	      zggrqf     
#define zggsvd	      zggsvd     
#define zggsvp	      zggsvp     
#define zgtcon	      zgtcon     
#define zgtrfs	      zgtrfs     
#define zgtsv	      zgtsv	     
#define zgtsvx	      zgtsvx     
#define zgttrf	      zgttrf     
#define zgttrs	      zgttrs     
#define zgtts2	      zgtts2     
#define zhbev	      zhbev	     
#define zhbevd	      zhbevd     
#define zhbevx	      zhbevx     
#define zhbgst	      zhbgst     
#define zhbgv	      zhbgv	     
#define zhbgvd	      zhbgvd     
#define zhbgvx	      zhbgvx     
#define zhbtrd	      zhbtrd     
#define zhecon	      zhecon     
#define zheev	      zheev	     
#define zheevd	      zheevd     
#define zheevr	      zheevr     
#define zheevx	      zheevx     
#define zhegs2	      zhegs2     
#define zhegst	      zhegst     
#define zhegv	      zhegv	     
#define zhegvd	      zhegvd     
#define zhegvx	      zhegvx     
#define zherfs	      zherfs     
#define zhesv	      zhesv	     
#define zhesvx	      zhesvx     
#define zhetd2	      zhetd2     
#define zhetf2	      zhetf2     
#define zhetrd	      zhetrd     
#define zhetrf	      zhetrf     
#define zhetri	      zhetri     
#define zhetrs	      zhetrs     
#define zhgeqz	      zhgeqz     
#define zhpcon	      zhpcon     
#define zhpev	      zhpev	     
#define zhpevd	      zhpevd     
#define zhpevx	      zhpevx     
#define zhpgst	      zhpgst     
#define zhpgv	      zhpgv	     
#define zhpgvd	      zhpgvd     
#define zhpgvx	      zhpgvx     
#define zhprfs	      zhprfs     
#define zhpsv	      zhpsv	     
#define zhpsvx	      zhpsvx     
#define zhptrd	      zhptrd     
#define zhptrf	      zhptrf     
#define zhptri	      zhptri     
#define zhptrs	      zhptrs     
#define zhsein	      zhsein     
#define zhseqr	      zhseqr     
#define zlabrd	      zlabrd     
#define zlacgv	      zlacgv     
#define zlacon	      zlacon     
#define zlacp2	      zlacp2     
#define zlacpy	      zlacpy     
#define zlacrm	      zlacrm     
#define zlacrt	      zlacrt     
#define zladiv	      zladiv     
#define zlaed0	      zlaed0     
#define zlaed7	      zlaed7     
#define zlaed8	      zlaed8     
#define zlaein	      zlaein     
#define zlaesy	      zlaesy     
#define zlaev2	      zlaev2     
#define zlags2	      zlags2     
#define zlagtm	      zlagtm     
#define zlahef	      zlahef     
#define zlahqr	      zlahqr     
#define zlahrd	      zlahrd     
#define zlaic1	      zlaic1     
#define zlals0	      zlals0     
#define zlalsa	      zlalsa     
#define zlalsd	      zlalsd     
#define zlangb	      zlangb     
#define zlange	      zlange     
#define zlangt	      zlangt     
#define zlanhb	      zlanhb     
#define zlanhe	      zlanhe     
#define zlanhp	      zlanhp     
#define zlanhs	      zlanhs     
#define zlanht	      zlanht     
#define zlansb	      zlansb     
#define zlansp	      zlansp     
#define zlansy	      zlansy     
#define zlantb	      zlantb     
#define zlantp	      zlantp     
#define zlantr	      zlantr     
#define zlapll	      zlapll     
#define zlapmt	      zlapmt     
#define zlaqgb	      zlaqgb     
#define zlaqge	      zlaqge     
#define zlaqhb	      zlaqhb     
#define zlaqhe	      zlaqhe     
#define zlaqhp	      zlaqhp     
#define zlaqp2	      zlaqp2     
#define zlaqps	      zlaqps     
#define zlaqsb	      zlaqsb     
#define zlaqsp	      zlaqsp     
#define zlaqsy	      zlaqsy     
#define zlar1v	      zlar1v     
#define zlar2v	      zlar2v     
#define zlarcm	      zlarcm     
#define zlarf	      zlarf	     
#define zlarfb	      zlarfb     
#define zlarfg	      zlarfg     
#define zlarft	      zlarft     
#define zlarfx	      zlarfx     
#define zlargv	      zlargv     
#define zlarnv	      zlarnv     
#define zlarrv	      zlarrv     
#define zlartg	      zlartg     
#define zlartv	      zlartv     
#define zlarz	      zlarz	     
#define zlarzb	      zlarzb     
#define zlarzt	      zlarzt     
#define zlascl	      zlascl     
#define zlaset	      zlaset     
#define zlasr	      zlasr	     
#define zlassq	      zlassq     
#define zlaswp	      zlaswp     
#define zlasyf	      zlasyf     
#define zlatbs	      zlatbs     
#define zlatdf	      zlatdf     
#define zlatps	      zlatps     
#define zlatrd	      zlatrd     
#define zlatrs	      zlatrs     
#define zlatrz	      zlatrz     
#define zlatzm	      zlatzm     
#define zlauu2	      zlauu2     
#define zlauum	      zlauum     
#define zpbcon	      zpbcon     
#define zpbequ	      zpbequ     
#define zpbrfs	      zpbrfs     
#define zpbstf	      zpbstf     
#define zpbsv	      zpbsv	     
#define zpbsvx	      zpbsvx     
#define zpbtf2	      zpbtf2     
#define zpbtrf	      zpbtrf     
#define zpbtrs	      zpbtrs     
#define zpocon	      zpocon     
#define zpoequ	      zpoequ     
#define zporfs	      zporfs     
#define zposv	      zposv	     
#define zposvx	      zposvx     
#define zpotf2	      zpotf2     
#define zpotrf	      zpotrf     
#define zpotri	      zpotri     
#define zpotrs	      zpotrs     
#define zppcon	      zppcon     
#define zppequ	      zppequ     
#define zpprfs	      zpprfs     
#define zppsv	      zppsv	     
#define zppsvx	      zppsvx     
#define zpptrf	      zpptrf     
#define zpptri	      zpptri     
#define zpptrs	      zpptrs     
#define zptcon	      zptcon     
#define zpteqr	      zpteqr     
#define zptrfs	      zptrfs     
#define zptsv	      zptsv	     
#define zptsvx	      zptsvx     
#define zpttrf	      zpttrf     
#define zpttrs	      zpttrs     
#define zptts2	      zptts2     
#define zrotn	      zrotn	     
#define zspcon	      zspcon     
#define zspmv	      zspmv	     
#define zspru	      zspru	     
#define zsprfs	      zsprfs     
#define zspsv	      zspsv	     
#define zspsvx	      zspsvx     
#define zsptrf	      zsptrf     
#define zsptri	      zsptri     
#define zsptrs	      zsptrs     
#define zstedc	      zstedc     
#define zstegr	      zstegr     
#define zstein	      zstein     
#define zsteqr	      zsteqr     
#define zsycon	      zsycon     
#define zsymv	      zsymv	     
#define zsyru	      zsyru	     
#define zsyrfs	      zsyrfs     
#define zsysv	      zsysv	     
#define zsysvx	      zsysvx     
#define zsytf2	      zsytf2     
#define zsytrf	      zsytrf     
#define zsytri	      zsytri     
#define zsytrs	      zsytrs     
#define ztbcon	      ztbcon     
#define ztbrfs	      ztbrfs     
#define ztbtrs	      ztbtrs     
#define ztgevc	      ztgevc     
#define ztgex2	      ztgex2     
#define ztgexc	      ztgexc     
#define ztgsen	      ztgsen     
#define ztgsja	      ztgsja     
#define ztgsna	      ztgsna     
#define ztgsy2	      ztgsy2     
#define ztgsyl	      ztgsyl     
#define ztpcon	      ztpcon     
#define ztprfs	      ztprfs     
#define ztptri	      ztptri     
#define ztptrs	      ztptrs     
#define ztrcon	      ztrcon     
#define ztrevc	      ztrevc     
#define ztrexc	      ztrexc     
#define ztrrfs	      ztrrfs     
#define ztrsen	      ztrsen     
#define ztrsna	      ztrsna     
#define ztrsyl	      ztrsyl     
#define ztrti2	      ztrti2     
#define ztrtri	      ztrtri     
#define ztrtrs	      ztrtrs     
#define ztzrqf	      ztzrqf     
#define ztzrzf	      ztzrzf     
#define zung2l	      zung2l     
#define zung2r	      zung2r     
#define zungbr	      zungbr     
#define zunghr	      zunghr     
#define zungl2	      zungl2     
#define zunglq	      zunglq     
#define zungql	      zungql     
#define zungqr	      zungqr     
#define zungr2	      zungr2     
#define zungrq	      zungrq     
#define zungtr	      zungtr     
#define zunm2l	      zunm2l     
#define zunm2r	      zunm2r     
#define zunmbr	      zunmbr     
#define zunmhr	      zunmhr     
#define zunml2	      zunml2     
#define zunmlq	      zunmlq     
#define zunmql	      zunmql     
#define zunmqr	      zunmqr     
#define zunmr2	      zunmr2     
#define zunmr3	      zunmr3     
#define zunmrq	      zunmrq     
#define zunmrz	      zunmrz     
#define zunmtr	      zunmtr     
#define zupgtr	      zupgtr     
#define zupmtr	      zupmtr     

/* no switch defined use lower case letters in FORTRAN */
#else

#define cbdsqr        cbdsqr     
#define cgbbrd	      cgbbrd     
#define cgbcon	      cgbcon     
#define cgbequ	      cgbequ     
#define cgbrfs	      cgbrfs     
#define cgbsv	      cgbsv	     
#define cgbsvx	      cgbsvx     
#define cgbtf2	      cgbtf2     
#define cgbtrf	      cgbtrf     
#define cgbtrs	      cgbtrs     
#define cgebak	      cgebak     
#define cgebal	      cgebal     
#define cgebd2	      cgebd2     
#define cgebrd	      cgebrd     
#define cgecon	      cgecon     
#define cgeequ	      cgeequ     
#define cgees	      cgees	     
#define cgeesx	      cgeesx     
#define cgeev	      cgeev	     
#define cgeevx	      cgeevx     
#define cgegs	      cgegs	     
#define cgegv	      cgegv	     
#define cgehd2	      cgehd2     
#define cgehrd	      cgehrd     
#define cgelq2	      cgelq2     
#define cgelqf	      cgelqf     
#define cgels	      cgels	     
#define cgelsd	      cgelsd     
#define cgelss	      cgelss     
#define cgelsx	      cgelsx     
#define cgelsy	      cgelsy     
#define cgeql2	      cgeql2     
#define cgeqlf	      cgeqlf     
#define cgeqp3	      cgeqp3     
#define cgeqpf	      cgeqpf     
#define cgeqr2	      cgeqr2     
#define cgeqrf	      cgeqrf     
#define cgerfs	      cgerfs     
#define cgerq2	      cgerq2     
#define cgerqf	      cgerqf     
#define cgesc2	      cgesc2     
#define cgesdd	      cgesdd     
#define cgesv	      cgesv	     
#define cgesvd	      cgesvd     
#define cgesvx	      cgesvx     
#define cgetc2	      cgetc2     
#define cgetf2	      cgetf2     
#define cgetrf	      cgetrf     
#define cgetri	      cgetri     
#define cgetrs	      cgetrs     
#define cggbak	      cggbak     
#define cggbal	      cggbal     
#define cgges	      cgges	     
#define cggesx	      cggesx     
#define cggev	      cggev	     
#define cggevx	      cggevx     
#define cggglm	      cggglm     
#define cgghrd	      cgghrd     
#define cgglse	      cgglse     
#define cggqrf	      cggqrf     
#define cggrqf	      cggrqf     
#define cggsvd	      cggsvd     
#define cggsvp	      cggsvp     
#define cgtcon	      cgtcon     
#define cgtrfs	      cgtrfs     
#define cgtsv	      cgtsv	     
#define cgtsvx	      cgtsvx     
#define cgttrf	      cgttrf     
#define cgttrs	      cgttrs     
#define cgtts2	      cgtts2     
#define chbev	      chbev	     
#define chbevd	      chbevd     
#define chbevx	      chbevx     
#define chbgst	      chbgst     
#define chbgv	      chbgv	     
#define chbgvd	      chbgvd     
#define chbgvx	      chbgvx     
#define chbtrd	      chbtrd     
#define checon	      checon     
#define cheev	      cheev	     
#define cheevd	      cheevd     
#define cheevr	      cheevr     
#define cheevx	      cheevx     
#define chegs2	      chegs2     
#define chegst	      chegst     
#define chegv	      chegv	     
#define chegvd	      chegvd     
#define chegvx	      chegvx     
#define cherfs	      cherfs     
#define chesv	      chesv	     
#define chesvx	      chesvx     
#define chetd2	      chetd2     
#define chetf2	      chetf2     
#define chetrd	      chetrd     
#define chetrf	      chetrf     
#define chetri	      chetri     
#define chetrs	      chetrs     
#define chgeqz	      chgeqz     
#define chpcon	      chpcon     
#define chpev	      chpev	     
#define chpevd	      chpevd     
#define chpevx	      chpevx     
#define chpgst	      chpgst     
#define chpgv	      chpgv	     
#define chpgvd	      chpgvd     
#define chpgvx	      chpgvx     
#define chprfs	      chprfs     
#define chpsv	      chpsv	     
#define chpsvx	      chpsvx     
#define chptrd	      chptrd     
#define chptrf	      chptrf     
#define chptri	      chptri     
#define chptrs	      chptrs     
#define chsein	      chsein     
#define chseqr	      chseqr     
#define clabrd	      clabrd     
#define clacgv	      clacgv     
#define clacon	      clacon     
#define clacp2	      clacp2     
#define clacpy	      clacpy     
#define clacrm	      clacrm     
#define clacrt	      clacrt     
#define cladiv	      cladiv     
#define claed0	      claed0     
#define claed7	      claed7     
#define claed8	      claed8     
#define claein	      claein     
#define claesy	      claesy     
#define claev2	      claev2     
#define clags2	      clags2     
#define clagtm	      clagtm     
#define clahef	      clahef     
#define clahqr	      clahqr     
#define clahrd	      clahrd     
#define claic1	      claic1     
#define clals0	      clals0     
#define clalsa	      clalsa     
#define clalsd	      clalsd     
#define clangb	      clangb     
#define clange	      clange     
#define clangt	      clangt     
#define clanhb	      clanhb     
#define clanhe	      clanhe     
#define clanhp	      clanhp     
#define clanhs	      clanhs     
#define clanht	      clanht     
#define clansb	      clansb     
#define clansp	      clansp     
#define clansy	      clansy     
#define clantb	      clantb     
#define clantp	      clantp     
#define clantr	      clantr     
#define clapll	      clapll     
#define clapmt	      clapmt     
#define claqgb	      claqgb     
#define claqge	      claqge     
#define claqhb	      claqhb     
#define claqhe	      claqhe     
#define claqhp	      claqhp     
#define claqp2	      claqp2     
#define claqps	      claqps     
#define claqsb	      claqsb     
#define claqsp	      claqsp     
#define claqsy	      claqsy     
#define clar1v	      clar1v     
#define clar2v	      clar2v     
#define clarcm	      clarcm     
#define clarf	      clarf	     
#define clarfb	      clarfb     
#define clarfg	      clarfg     
#define clarft	      clarft     
#define clarfx	      clarfx     
#define clargv	      clargv     
#define clarnv	      clarnv     
#define clarrv	      clarrv     
#define clartg	      clartg     
#define clartv	      clartv     
#define clarz	      clarz	     
#define clarzb	      clarzb     
#define clarzt	      clarzt     
#define clascl	      clascl     
#define claset	      claset     
#define clasr	      clasr	     
#define classq	      classq     
#define claswp	      claswp     
#define clasyf	      clasyf     
#define clatbs	      clatbs     
#define clatdf	      clatdf     
#define clatps	      clatps     
#define clatrd	      clatrd     
#define clatrs	      clatrs     
#define clatrz	      clatrz     
#define clatzm	      clatzm     
#define clauu2	      clauu2     
#define clauum	      clauum     
#define cpbcon	      cpbcon     
#define cpbequ	      cpbequ     
#define cpbrfs	      cpbrfs     
#define cpbstf	      cpbstf     
#define cpbsv	      cpbsv	     
#define cpbsvx	      cpbsvx     
#define cpbtf2	      cpbtf2     
#define cpbtrf	      cpbtrf     
#define cpbtrs	      cpbtrs     
#define cpocon	      cpocon     
#define cpoequ	      cpoequ     
#define cporfs	      cporfs     
#define cposv	      cposv	     
#define cposvx	      cposvx     
#define cpotf2	      cpotf2     
#define cpotrf	      cpotrf     
#define cpotri	      cpotri     
#define cpotrs	      cpotrs     
#define cppcon	      cppcon     
#define cppequ	      cppequ     
#define cpprfs	      cpprfs     
#define cppsv	      cppsv	     
#define cppsvx	      cppsvx     
#define cpptrf	      cpptrf     
#define cpptri	      cpptri     
#define cpptrs	      cpptrs     
#define cptcon	      cptcon     
#define cpteqr	      cpteqr     
#define cptrfs	      cptrfs     
#define cptsv	      cptsv	     
#define cptsvx	      cptsvx     
#define cpttrf	      cpttrf     
#define cpttrs	      cpttrs     
#define cptts2	      cptts2     
#define crotn	      crotn	     
#define cspcon	      cspcon     
#define cspmv	      cspmv	     
#define cspru	      cspru	     
#define csprfs	      csprfs     
#define cspsv	      cspsv	     
#define cspsvx	      cspsvx     
#define csptrf	      csptrf     
#define csptri	      csptri     
#define csptrs	      csptrs     
#define csrot	      csrot	     
#define csrscl	      csrscl     
#define cstedc	      cstedc     
#define cstegr	      cstegr     
#define cstein	      cstein     
#define csteqr	      csteqr     
#define csycon	      csycon     
#define csymv	      csymv	     
#define csyru	      csyru	     
#define csyrfs	      csyrfs     
#define csysv	      csysv	     
#define csysvx	      csysvx     
#define csytf2	      csytf2     
#define csytrf	      csytrf     
#define csytri	      csytri     
#define csytrs	      csytrs     
#define ctbcon	      ctbcon     
#define ctbrfs	      ctbrfs     
#define ctbtrs	      ctbtrs     
#define ctgevc	      ctgevc     
#define ctgex2	      ctgex2     
#define ctgexc	      ctgexc     
#define ctgsen	      ctgsen     
#define ctgsja	      ctgsja     
#define ctgsna	      ctgsna     
#define ctgsy2	      ctgsy2     
#define ctgsyl	      ctgsyl     
#define ctpcon	      ctpcon     
#define ctprfs	      ctprfs     
#define ctptri	      ctptri     
#define ctptrs	      ctptrs     
#define ctrcon	      ctrcon     
#define ctrevc	      ctrevc     
#define ctrexc	      ctrexc     
#define ctrrfs	      ctrrfs     
#define ctrsen	      ctrsen     
#define ctrsna	      ctrsna     
#define ctrsyl	      ctrsyl     
#define ctrti2	      ctrti2     
#define ctrtri	      ctrtri     
#define ctrtrs	      ctrtrs     
#define ctzrqf	      ctzrqf     
#define ctzrzf	      ctzrzf     
#define cung2l	      cung2l     
#define cung2r	      cung2r     
#define cungbr	      cungbr     
#define cunghr	      cunghr     
#define cungl2	      cungl2     
#define cunglq	      cunglq     
#define cungql	      cungql     
#define cungqr	      cungqr     
#define cungr2	      cungr2     
#define cungrq	      cungrq     
#define cungtr	      cungtr     
#define cunm2l	      cunm2l     
#define cunm2r	      cunm2r     
#define cunmbr	      cunmbr     
#define cunmhr	      cunmhr     
#define cunml2	      cunml2     
#define cunmlq	      cunmlq     
#define cunmql	      cunmql     
#define cunmqr	      cunmqr     
#define cunmr2	      cunmr2     
#define cunmr3	      cunmr3     
#define cunmrq	      cunmrq     
#define cunmrz	      cunmrz     
#define cunmtr	      cunmtr     
#define cupgtr	      cupgtr     
#define cupmtr	      cupmtr     
#define dbdsdc	      dbdsdc     
#define dbdsqr	      dbdsqr     
#define ddisna	      ddisna     
#define dgbbrd	      dgbbrd     
#define dgbcon	      dgbcon     
#define dgbequ	      dgbequ     
#define dgbrfs	      dgbrfs     
#define dgbsv	      dgbsv	     
#define dgbsvx	      dgbsvx     
#define dgbtf2	      dgbtf2     
#define dgbtrf	      dgbtrf     
#define dgbtrs	      dgbtrs     
#define dgebak	      dgebak     
#define dgebal	      dgebal     
#define dgebd2	      dgebd2     
#define dgebrd	      dgebrd     
#define dgecon	      dgecon     
#define dgeequ	      dgeequ     
#define dgees	      dgees	     
#define dgeesx	      dgeesx     
#define dgeev	      dgeev	     
#define dgeevx	      dgeevx     
#define dgegs	      dgegs	     
#define dgegv	      dgegv	     
#define dgehd2	      dgehd2     
#define dgehrd	      dgehrd     
#define dgelq2	      dgelq2     
#define dgelqf	      dgelqf     
#define dgels	      dgels	     
#define dgelsd	      dgelsd     
#define dgelss	      dgelss     
#define dgelsx	      dgelsx     
#define dgelsy	      dgelsy     
#define dgeql2	      dgeql2     
#define dgeqlf	      dgeqlf     
#define dgeqp3	      dgeqp3     
#define dgeqpf	      dgeqpf     
#define dgeqr2	      dgeqr2     
#define dgeqrf	      dgeqrf     
#define dgerfs	      dgerfs     
#define dgerq2	      dgerq2     
#define dgerqf	      dgerqf     
#define dgesc2	      dgesc2     
#define dgesdd	      dgesdd     
#define dgesv	      dgesv	     
#define dgesvd	      dgesvd     
#define dgesvx	      dgesvx     
#define dgetc2	      dgetc2     
#define dgetf2	      dgetf2     
#define dgetrf	      dgetrf     
#define dgetri	      dgetri     
#define dgetrs	      dgetrs     
#define dggbak	      dggbak     
#define dggbal	      dggbal     
#define dgges	      dgges	     
#define dggesx	      dggesx     
#define dggev	      dggev	     
#define dggevx	      dggevx     
#define dggglm	      dggglm     
#define dgghrd	      dgghrd     
#define dgglse	      dgglse     
#define dggqrf	      dggqrf     
#define dggrqf	      dggrqf     
#define dggsvd	      dggsvd     
#define dggsvp	      dggsvp     
#define dgtcon	      dgtcon     
#define dgtrfs	      dgtrfs     
#define dgtsv	      dgtsv	     
#define dgtsvx	      dgtsvx     
#define dgttrf	      dgttrf     
#define dgttrs	      dgttrs     
#define dgtts2	      dgtts2     
#define dhgeqz	      dhgeqz     
#define dhsein	      dhsein     
#define dhseqr	      dhseqr     
#define dlabad	      dlabad     
#define dlabrd	      dlabrd     
#define dlacon	      dlacon     
#define dlacpy	      dlacpy     
#define dladiv	      dladiv     
#define dlae2a	      dlae2a     
#define dlaebz	      dlaebz     
#define dlaed0	      dlaed0     
#define dlaed1	      dlaed1     
#define dlaed2	      dlaed2     
#define dlaed3	      dlaed3     
#define dlaed4	      dlaed4     
#define dlaed5	      dlaed5     
#define dlaed6	      dlaed6     
#define dlaed7	      dlaed7     
#define dlaed8	      dlaed8     
#define dlaed9	      dlaed9     
#define dlaeda	      dlaeda     
#define dlaein	      dlaein     
#define dlaev2	      dlaev2     
#define dlaexc	      dlaexc     
#define dlag2a	      dlag2a     
#define dlags2	      dlags2     
#define dlagtf	      dlagtf     
#define dlagtm	      dlagtm     
#define dlagts	      dlagts     
#define dlagv2	      dlagv2     
#define dlahqr	      dlahqr     
#define dlahrd	      dlahrd     
#define dlaic1	      dlaic1     
#define dlaln2	      dlaln2     
#define dlals0	      dlals0     
#define dlalsa	      dlalsa     
#define dlalsd	      dlalsd     
#define dlamch	      dlamch     
#define dlamc1	      dlamc1     
#define dlamc2	      dlamc2     
#define dlamc3	      dlamc3     
#define dlamc4	      dlamc4     
#define dlamc5	      dlamc5     
#define dlamrg	      dlamrg     
#define dlangb	      dlangb     
#define dlange	      dlange     
#define dlangt	      dlangt     
#define dlanhs	      dlanhs     
#define dlansb	      dlansb     
#define dlansp	      dlansp     
#define dlanst	      dlanst     
#define dlansy	      dlansy     
#define dlantb	      dlantb     
#define dlantp	      dlantp     
#define dlantr	      dlantr     
#define dlanv2	      dlanv2     
#define dlapll	      dlapll     
#define dlapmt	      dlapmt     
#define dlapy2	      dlapy2     
#define dlapy3	      dlapy3     
#define dlaqgb	      dlaqgb     
#define dlaqge	      dlaqge     
#define dlaqp2	      dlaqp2     
#define dlaqps	      dlaqps     
#define dlaqsb	      dlaqsb     
#define dlaqsp	      dlaqsp     
#define dlaqsy	      dlaqsy     
#define dlaqtr	      dlaqtr     
#define dlar1v	      dlar1v     
#define dlar2v	      dlar2v     
#define dlarf	      dlarf	     
#define dlarfb	      dlarfb     
#define dlarfg	      dlarfg     
#define dlarft	      dlarft     
#define dlarfx	      dlarfx     
#define dlargv	      dlargv     
#define dlarnv	      dlarnv     
#define dlarrb	      dlarrb     
#define dlarre	      dlarre     
#define dlarrf	      dlarrf     
#define dlarrv	      dlarrv     
#define dlartg	      dlartg     
#define dlartv	      dlartv     
#define dlaruv	      dlaruv     
#define dlarz	      dlarz	     
#define dlarzb	      dlarzb     
#define dlarzt	      dlarzt     
#define dlas2f	      dlas2f     
#define dlascl	      dlascl     
#define dlasd0	      dlasd0     
#define dlasd1	      dlasd1     
#define dlasd2	      dlasd2     
#define dlasd3	      dlasd3     
#define dlasd4	      dlasd4     
#define dlasd5	      dlasd5     
#define dlasd6	      dlasd6     
#define dlasd7	      dlasd7     
#define dlasd8	      dlasd8     
#define dlasd9	      dlasd9     
#define dlasda	      dlasda     
#define dlasdq	      dlasdq     
#define dlasdt	      dlasdt     
#define dlaset	      dlaset     
#define dlasq1	      dlasq1     
#define dlasq2	      dlasq2     
#define dlasq3	      dlasq3     
#define dlasq4	      dlasq4     
#define dlasq5	      dlasq5     
#define dlasq6	      dlasq6     
#define dlasr	      dlasr	     
#define dlasrt	      dlasrt     
#define dlassq	      dlassq     
#define dlasv2	      dlasv2     
#define dlaswp	      dlaswp     
#define dlasy2	      dlasy2     
#define dlasyf	      dlasyf     
#define dlatbs	      dlatbs     
#define dlatdf	      dlatdf     
#define dlatps	      dlatps     
#define dlatrd	      dlatrd     
#define dlatrs	      dlatrs     
#define dlatrz	      dlatrz     
#define dlatzm	      dlatzm     
#define dlauu2	      dlauu2     
#define dlauum	      dlauum     
#define dopgtr	      dopgtr     
#define dopmtr	      dopmtr     
#define dorg2l	      dorg2l     
#define dorg2r	      dorg2r     
#define dorgbr	      dorgbr     
#define dorghr	      dorghr     
#define dorgl2	      dorgl2     
#define dorglq	      dorglq     
#define dorgql	      dorgql     
#define dorgqr	      dorgqr     
#define dorgr2	      dorgr2     
#define dorgrq	      dorgrq     
#define dorgtr	      dorgtr     
#define dorm2l	      dorm2l     
#define dorm2r	      dorm2r     
#define dormbr	      dormbr     
#define dormhr	      dormhr     
#define dorml2	      dorml2     
#define dormlq	      dormlq     
#define dormql	      dormql     
#define dormqr	      dormqr     
#define dormr2	      dormr2     
#define dormr3	      dormr3     
#define dormrq	      dormrq     
#define dormrz	      dormrz     
#define dormtr	      dormtr     
#define dpbcon	      dpbcon     
#define dpbequ	      dpbequ     
#define dpbrfs	      dpbrfs     
#define dpbstf	      dpbstf     
#define dpbsv	      dpbsv	     
#define dpbsvx	      dpbsvx     
#define dpbtf2	      dpbtf2     
#define dpbtrf	      dpbtrf     
#define dpbtrs	      dpbtrs     
#define dpocon	      dpocon     
#define dpoequ	      dpoequ     
#define dporfs	      dporfs     
#define dposv	      dposv	     
#define dposvx	      dposvx     
#define dpotf2	      dpotf2     
#define dpotrf	      dpotrf     
#define dpotri	      dpotri     
#define dpotrs	      dpotrs     
#define dppcon	      dppcon     
#define dppequ	      dppequ     
#define dpprfs	      dpprfs     
#define dppsv	      dppsv	     
#define dppsvx	      dppsvx     
#define dpptrf	      dpptrf     
#define dpptri	      dpptri     
#define dpptrs	      dpptrs     
#define dptcon	      dptcon     
#define dpteqr	      dpteqr     
#define dptrfs	      dptrfs     
#define dptsv	      dptsv	     
#define dptsvx	      dptsvx     
#define dpttrf	      dpttrf     
#define dpttrs	      dpttrs     
#define dptts2	      dptts2     
#define drscl	      drscl	     
#define dsbev	      dsbev	     
#define dsbevd	      dsbevd     
#define dsbevx	      dsbevx     
#define dsbgst	      dsbgst     
#define dsbgv	      dsbgv	     
#define dsbgvd	      dsbgvd     
#define dsbgvx	      dsbgvx     
#define dsbtrd	      dsbtrd     
#define dsecnd	      dsecnd     
#define dspcon	      dspcon     
#define dspev	      dspev	     
#define dspevd	      dspevd     
#define dspevx	      dspevx     
#define dspgst	      dspgst     
#define dspgv	      dspgv	     
#define dspgvd	      dspgvd     
#define dspgvx	      dspgvx     
#define dsprfs	      dsprfs     
#define dspsv	      dspsv	     
#define dspsvx	      dspsvx     
#define dsptrd	      dsptrd     
#define dsptrf	      dsptrf     
#define dsptri	      dsptri     
#define dsptrs	      dsptrs     
#define dstebz	      dstebz     
#define dstedc	      dstedc     
#define dstegr	      dstegr     
#define dstein	      dstein     
#define dsteqr	      dsteqr     
#define dsterf	      dsterf     
#define dstev	      dstev	     
#define dstevd	      dstevd     
#define dstevr	      dstevr     
#define dstevx	      dstevx     
#define dsycon	      dsycon     
#define dsyev	      dsyev	     
#define dsyevd	      dsyevd     
#define dsyevr	      dsyevr     
#define dsyevx	      dsyevx     
#define dsygs2	      dsygs2     
#define dsygst	      dsygst     
#define dsygv	      dsygv	     
#define dsygvd	      dsygvd     
#define dsygvx	      dsygvx     
#define dsyrfs	      dsyrfs     
#define dsysv	      dsysv	     
#define dsysvx	      dsysvx     
#define dsytd2	      dsytd2     
#define dsytf2	      dsytf2     
#define dsytrd	      dsytrd     
#define dsytrf	      dsytrf     
#define dsytri	      dsytri     
#define dsytrs	      dsytrs     
#define dtbcon	      dtbcon     
#define dtbrfs	      dtbrfs     
#define dtbtrs	      dtbtrs     
#define dtgevc	      dtgevc     
#define dtgex2	      dtgex2     
#define dtgexc	      dtgexc     
#define dtgsen	      dtgsen     
#define dtgsja	      dtgsja     
#define dtgsna	      dtgsna     
#define dtgsy2	      dtgsy2     
#define dtgsyl	      dtgsyl     
#define dtpcon	      dtpcon     
#define dtprfs	      dtprfs     
#define dtptri	      dtptri     
#define dtptrs	      dtptrs     
#define dtrcon	      dtrcon     
#define dtrevc	      dtrevc     
#define dtrexc	      dtrexc     
#define dtrrfs	      dtrrfs     
#define dtrsen	      dtrsen     
#define dtrsna	      dtrsna     
#define dtrsyl	      dtrsyl     
#define dtrti2	      dtrti2     
#define dtrtri	      dtrtri     
#define dtrtrs	      dtrtrs     
#define dtzrqf	      dtzrqf     
#define dtzrzf	      dtzrzf     
#define dzsum1	      dzsum1     
#define icmax1	      icmax1     
#define ieeeck	      ieeeck     
#define ilaenv	      ilaenv     
#define izmax1	      izmax1     
#define lsamech	      lsamech    
#define lsamen	      lsamen     
#define sbdsdc	      sbdsdc     
#define sbdsqr	      sbdsqr     
#define scsum1	      scsum1     
#define sdisna	      sdisna     
#define secondv	      secondv    
#define sgbbrd	      sgbbrd     
#define sgbcon	      sgbcon     
#define sgbequ	      sgbequ     
#define sgbrfs	      sgbrfs     
#define sgbsv	      sgbsv	     
#define sgbsvx	      sgbsvx     
#define sgbtf2	      sgbtf2     
#define sgbtrf	      sgbtrf     
#define sgbtrs	      sgbtrs     
#define sgebak	      sgebak     
#define sgebal	      sgebal     
#define sgebd2	      sgebd2     
#define sgebrd	      sgebrd     
#define sgecon	      sgecon     
#define sgeequ	      sgeequ     
#define sgees	      sgees	     
#define sgeesx	      sgeesx     
#define sgeev	      sgeev	     
#define sgeevx	      sgeevx     
#define sgegs	      sgegs	     
#define sgegv	      sgegv	     
#define sgehd2	      sgehd2     
#define sgehrd	      sgehrd     
#define sgelq2	      sgelq2     
#define sgelqf	      sgelqf     
#define sgels	      sgels	     
#define sgelsd	      sgelsd     
#define sgelss	      sgelss     
#define sgelsx	      sgelsx     
#define sgelsy	      sgelsy     
#define sgeql2	      sgeql2     
#define sgeqlf	      sgeqlf     
#define sgeqp3	      sgeqp3     
#define sgeqpf	      sgeqpf     
#define sgeqr2	      sgeqr2     
#define sgeqrf	      sgeqrf     
#define sgerfs	      sgerfs     
#define sgerq2	      sgerq2     
#define sgerqf	      sgerqf     
#define sgesc2	      sgesc2     
#define sgesdd	      sgesdd     
#define sgesv	      sgesv	     
#define sgesvd	      sgesvd     
#define sgesvx	      sgesvx     
#define sgetc2	      sgetc2     
#define sgetf2	      sgetf2     
#define sgetrf	      sgetrf     
#define sgetri	      sgetri     
#define sgetrs	      sgetrs     
#define sggbak	      sggbak     
#define sggbal	      sggbal     
#define sgges	      sgges	     
#define sggesx	      sggesx     
#define sggev	      sggev	     
#define sggevx	      sggevx     
#define sggglm	      sggglm     
#define sgghrd	      sgghrd     
#define sgglse	      sgglse     
#define sggqrf	      sggqrf     
#define sggrqf	      sggrqf     
#define sggsvd	      sggsvd     
#define sggsvp	      sggsvp     
#define sgtcon	      sgtcon     
#define sgtrfs	      sgtrfs     
#define sgtsv	      sgtsv	     
#define sgtsvx	      sgtsvx     
#define sgttrf	      sgttrf     
#define sgttrs	      sgttrs     
#define sgtts2	      sgtts2     
#define shgeqz	      shgeqz     
#define shsein	      shsein     
#define shseqr	      shseqr     
#define slabadr	      slabadr    
#define slabrd	      slabrd     
#define slacon	      slacon     
#define slacpy	      slacpy     
#define sladivr	      sladivr    
#define slae2re	      slae2re    
#define slaebz	      slaebz     
#define slaed0	      slaed0     
#define slaed1	      slaed1     
#define slaed2	      slaed2     
#define slaed3	      slaed3     
#define slaed4	      slaed4     
#define slaed5	      slaed5     
#define slaed6	      slaed6     
#define slaed7	      slaed7     
#define slaed8	      slaed8     
#define slaed9	      slaed9     
#define slaeda	      slaeda     
#define slaein	      slaein     
#define slaev2r	      slaev2r    
#define slaexc	      slaexc     
#define slag2re	      slag2re    
#define slags2	      slags2     
#define slagtf	      slagtf     
#define slagtm	      slagtm     
#define slagts	      slagts     
#define slagv2r	      slagv2r    
#define slahqr	      slahqr     
#define slahrd	      slahrd     
#define slaic1	      slaic1     
#define slaln2	      slaln2     
#define slals0	      slals0     
#define slalsa	      slalsa     
#define slalsd	      slalsd     
#define slamch	      slamch     
#define slamc1	      slamc1     
#define slamc2	      slamc2     
#define slamc3r	      slamc3r    
#define slamc4	      slamc4     
#define slamc5	      slamc5     
#define slamrg	      slamrg     
#define slangb	      slangb     
#define slange	      slange     
#define slangt	      slangt     
#define slanhs	      slanhs     
#define slansb	      slansb     
#define slansp	      slansp     
#define slanst	      slanst     
#define slansy	      slansy     
#define slantb	      slantb     
#define slantp	      slantp     
#define slantr	      slantr     
#define slanv2r	      slanv2r    
#define slapll	      slapll     
#define slapmt	      slapmt     
#define slapy2r	      slapy2r    
#define slapy3r	      slapy3r    
#define slaqgb	      slaqgb     
#define slaqge	      slaqge     
#define slaqp2	      slaqp2     
#define slaqps	      slaqps     
#define slaqsb	      slaqsb     
#define slaqsp	      slaqsp     
#define slaqsy	      slaqsy     
#define slaqtr	      slaqtr     
#define slar1v	      slar1v     
#define slar2v	      slar2v     
#define slarf	      slarf	     
#define slarfb	      slarfb     
#define slarfg	      slarfg     
#define slarft	      slarft     
#define slarfx	      slarfx     
#define slargv	      slargv     
#define slarnv	      slarnv     
#define slarrb	      slarrb     
#define slarre	      slarre     
#define slarrf	      slarrf     
#define slarrv	      slarrv     
#define slartgr	      slartgr    
#define slartv	      slartv     
#define slaruv	      slaruv     
#define slarz	      slarz	     
#define slarzb	      slarzb     
#define slarzt	      slarzt     
#define slas2re	      slas2re    
#define slascl	      slascl     
#define slasd0	      slasd0     
#define slasd1	      slasd1     
#define slasd2	      slasd2     
#define slasd3	      slasd3     
#define slasd4	      slasd4     
#define slasd5	      slasd5     
#define slasd6	      slasd6     
#define slasd7	      slasd7     
#define slasd8	      slasd8     
#define slasd9	      slasd9     
#define slasda	      slasda     
#define slasdq	      slasdq     
#define slasdt	      slasdt     
#define slaset	      slaset     
#define slasq1	      slasq1     
#define slasq2	      slasq2     
#define slasq3	      slasq3     
#define slasq4	      slasq4     
#define slasq5	      slasq5     
#define slasq6	      slasq6     
#define slasr	      slasr	     
#define slasrt	      slasrt     
#define slassq	      slassq     
#define slasv2r	      slasv2r    
#define slaswp	      slaswp     
#define slasy2	      slasy2     
#define slasyf	      slasyf     
#define slatbs	      slatbs     
#define slatdf	      slatdf     
#define slatps	      slatps     
#define slatrd	      slatrd     
#define slatrs	      slatrs     
#define slatrz	      slatrz     
#define slatzm	      slatzm     
#define slauu2	      slauu2     
#define slauum	      slauum     
#define sopgtr	      sopgtr     
#define sopmtr	      sopmtr     
#define sorg2l	      sorg2l     
#define sorg2r	      sorg2r     
#define sorgbr	      sorgbr     
#define sorghr	      sorghr     
#define sorgl2	      sorgl2     
#define sorglq	      sorglq     
#define sorgql	      sorgql     
#define sorgqr	      sorgqr     
#define sorgr2	      sorgr2     
#define sorgrq	      sorgrq     
#define sorgtr	      sorgtr     
#define sorm2l	      sorm2l     
#define sorm2r	      sorm2r     
#define sormbr	      sormbr     
#define sormhr	      sormhr     
#define sorml2	      sorml2     
#define sormlq	      sormlq     
#define sormql	      sormql     
#define sormqr	      sormqr     
#define sormr2	      sormr2     
#define sormr3	      sormr3     
#define sormrq	      sormrq     
#define sormrz	      sormrz     
#define sormtr	      sormtr     
#define spbcon	      spbcon     
#define spbequ	      spbequ     
#define spbrfs	      spbrfs     
#define spbstf	      spbstf     
#define spbsv	      spbsv	     
#define spbsvx	      spbsvx     
#define spbtf2	      spbtf2     
#define spbtrf	      spbtrf     
#define spbtrs	      spbtrs     
#define spocon	      spocon     
#define spoequ	      spoequ     
#define sporfs	      sporfs     
#define sposv	      sposv	     
#define sposvx	      sposvx     
#define spotf2	      spotf2     
#define spotrf	      spotrf     
#define spotri	      spotri     
#define spotrs	      spotrs     
#define sppcon	      sppcon     
#define sppequ	      sppequ     
#define spprfs	      spprfs     
#define sppsv	      sppsv	     
#define sppsvx	      sppsvx     
#define spptrf	      spptrf     
#define spptri	      spptri     
#define spptrs	      spptrs     
#define sptcon	      sptcon     
#define spteqr	      spteqr     
#define sptrfs	      sptrfs     
#define sptsv	      sptsv	     
#define sptsvx	      sptsvx     
#define spttrf	      spttrf     
#define spttrs	      spttrs     
#define sptts2	      sptts2     
#define srscl	      srscl	     
#define ssbev	      ssbev	     
#define ssbevd	      ssbevd     
#define ssbevx	      ssbevx     
#define ssbgst	      ssbgst     
#define ssbgv	      ssbgv	     
#define ssbgvd	      ssbgvd     
#define ssbgvx	      ssbgvx     
#define ssbtrd	      ssbtrd     
#define sspcon	      sspcon     
#define sspev	      sspev	     
#define sspevd	      sspevd     
#define sspevx	      sspevx     
#define sspgst	      sspgst     
#define sspgv	      sspgv	     
#define sspgvd	      sspgvd     
#define sspgvx	      sspgvx     
#define ssprfs	      ssprfs     
#define sspsv	      sspsv	     
#define sspsvx	      sspsvx     
#define ssptrd	      ssptrd     
#define ssptrf	      ssptrf     
#define ssptri	      ssptri     
#define ssptrs	      ssptrs     
#define sstebz	      sstebz     
#define sstedc	      sstedc     
#define sstegr	      sstegr     
#define sstein	      sstein     
#define ssteqr	      ssteqr     
#define ssterf	      ssterf     
#define sstev	      sstev	     
#define sstevd	      sstevd     
#define sstevr	      sstevr     
#define sstevx	      sstevx     
#define ssycon	      ssycon     
#define ssyev	      ssyev	     
#define ssyevd	      ssyevd     
#define ssyevr	      ssyevr     
#define ssyevx	      ssyevx     
#define ssygs2	      ssygs2     
#define ssygst	      ssygst     
#define ssygv	      ssygv	     
#define ssygvd	      ssygvd     
#define ssygvx	      ssygvx     
#define ssyrfs	      ssyrfs     
#define ssysv	      ssysv	     
#define ssysvx	      ssysvx     
#define ssytd2	      ssytd2     
#define ssytf2	      ssytf2     
#define ssytrd	      ssytrd     
#define ssytrf	      ssytrf     
#define ssytri	      ssytri     
#define ssytrs	      ssytrs     
#define stbcon	      stbcon     
#define stbrfs	      stbrfs     
#define stbtrs	      stbtrs     
#define stgevc	      stgevc     
#define stgex2	      stgex2     
#define stgexc	      stgexc     
#define stgsen	      stgsen     
#define stgsja	      stgsja     
#define stgsna	      stgsna     
#define stgsy2	      stgsy2     
#define stgsyl	      stgsyl     
#define stpcon	      stpcon     
#define stprfs	      stprfs     
#define stptri	      stptri     
#define stptrs	      stptrs     
#define strcon	      strcon     
#define strevc	      strevc     
#define strexc	      strexc     
#define strrfs	      strrfs     
#define strsen	      strsen     
#define strsna	      strsna     
#define strsyl	      strsyl     
#define strti2	      strti2     
#define strtri	      strtri     
#define strtrs	      strtrs     
#define stzrqf	      stzrqf     
#define stzrzf	      stzrzf     
#define xerbla	      xerbla     
#define zbdsqr	      zbdsqr     
#define zdrot	      zdrot	     
#define zdrscl	      zdrscl     
#define zgbbrd	      zgbbrd     
#define zgbcon	      zgbcon     
#define zgbequ	      zgbequ     
#define zgbrfs	      zgbrfs     
#define zgbsv	      zgbsv	     
#define zgbsvx	      zgbsvx     
#define zgbtf2	      zgbtf2     
#define zgbtrf	      zgbtrf     
#define zgbtrs	      zgbtrs     
#define zgebak	      zgebak     
#define zgebal	      zgebal     
#define zgebd2	      zgebd2     
#define zgebrd	      zgebrd     
#define zgecon	      zgecon     
#define zgeequ	      zgeequ     
#define zgees	      zgees	     
#define zgeesx	      zgeesx     
#define zgeev	      zgeev	     
#define zgeevx	      zgeevx     
#define zgegs	      zgegs	     
#define zgegv	      zgegv	     
#define zgehd2	      zgehd2     
#define zgehrd	      zgehrd     
#define zgelq2	      zgelq2     
#define zgelqf	      zgelqf     
#define zgels	      zgels	     
#define zgelsd	      zgelsd     
#define zgelss	      zgelss     
#define zgelsx	      zgelsx     
#define zgelsy	      zgelsy     
#define zgeql2	      zgeql2     
#define zgeqlf	      zgeqlf     
#define zgeqp3	      zgeqp3     
#define zgeqpf	      zgeqpf     
#define zgeqr2	      zgeqr2     
#define zgeqrf	      zgeqrf     
#define zgerfs	      zgerfs     
#define zgerq2	      zgerq2     
#define zgerqf	      zgerqf     
#define zgesc2	      zgesc2     
#define zgesdd	      zgesdd     
#define zgesv	      zgesv	     
#define zgesvd	      zgesvd     
#define zgesvx	      zgesvx     
#define zgetc2	      zgetc2     
#define zgetf2	      zgetf2     
#define zgetrf	      zgetrf     
#define zgetri	      zgetri     
#define zgetrs	      zgetrs     
#define zggbak	      zggbak     
#define zggbal	      zggbal     
#define zgges	      zgges	     
#define zggesx	      zggesx     
#define zggev	      zggev	     
#define zggevx	      zggevx     
#define zggglm	      zggglm     
#define zgghrd	      zgghrd     
#define zgglse	      zgglse     
#define zggqrf	      zggqrf     
#define zggrqf	      zggrqf     
#define zggsvd	      zggsvd     
#define zggsvp	      zggsvp     
#define zgtcon	      zgtcon     
#define zgtrfs	      zgtrfs     
#define zgtsv	      zgtsv	     
#define zgtsvx	      zgtsvx     
#define zgttrf	      zgttrf     
#define zgttrs	      zgttrs     
#define zgtts2	      zgtts2     
#define zhbev	      zhbev	     
#define zhbevd	      zhbevd     
#define zhbevx	      zhbevx     
#define zhbgst	      zhbgst     
#define zhbgv	      zhbgv	     
#define zhbgvd	      zhbgvd     
#define zhbgvx	      zhbgvx     
#define zhbtrd	      zhbtrd     
#define zhecon	      zhecon     
#define zheev	      zheev	     
#define zheevd	      zheevd     
#define zheevr	      zheevr     
#define zheevx	      zheevx     
#define zhegs2	      zhegs2     
#define zhegst	      zhegst     
#define zhegv	      zhegv	     
#define zhegvd	      zhegvd     
#define zhegvx	      zhegvx     
#define zherfs	      zherfs     
#define zhesv	      zhesv	     
#define zhesvx	      zhesvx     
#define zhetd2	      zhetd2     
#define zhetf2	      zhetf2     
#define zhetrd	      zhetrd     
#define zhetrf	      zhetrf     
#define zhetri	      zhetri     
#define zhetrs	      zhetrs     
#define zhgeqz	      zhgeqz     
#define zhpcon	      zhpcon     
#define zhpev	      zhpev	     
#define zhpevd	      zhpevd     
#define zhpevx	      zhpevx     
#define zhpgst	      zhpgst     
#define zhpgv	      zhpgv	     
#define zhpgvd	      zhpgvd     
#define zhpgvx	      zhpgvx     
#define zhprfs	      zhprfs     
#define zhpsv	      zhpsv	     
#define zhpsvx	      zhpsvx     
#define zhptrd	      zhptrd     
#define zhptrf	      zhptrf     
#define zhptri	      zhptri     
#define zhptrs	      zhptrs     
#define zhsein	      zhsein     
#define zhseqr	      zhseqr     
#define zlabrd	      zlabrd     
#define zlacgv	      zlacgv     
#define zlacon	      zlacon     
#define zlacp2	      zlacp2     
#define zlacpy	      zlacpy     
#define zlacrm	      zlacrm     
#define zlacrt	      zlacrt     
#define zladiv	      zladiv     
#define zlaed0	      zlaed0     
#define zlaed7	      zlaed7     
#define zlaed8	      zlaed8     
#define zlaein	      zlaein     
#define zlaesy	      zlaesy     
#define zlaev2	      zlaev2     
#define zlags2	      zlags2     
#define zlagtm	      zlagtm     
#define zlahef	      zlahef     
#define zlahqr	      zlahqr     
#define zlahrd	      zlahrd     
#define zlaic1	      zlaic1     
#define zlals0	      zlals0     
#define zlalsa	      zlalsa     
#define zlalsd	      zlalsd     
#define zlangb	      zlangb     
#define zlange	      zlange     
#define zlangt	      zlangt     
#define zlanhb	      zlanhb     
#define zlanhe	      zlanhe     
#define zlanhp	      zlanhp     
#define zlanhs	      zlanhs     
#define zlanht	      zlanht     
#define zlansb	      zlansb     
#define zlansp	      zlansp     
#define zlansy	      zlansy     
#define zlantb	      zlantb     
#define zlantp	      zlantp     
#define zlantr	      zlantr     
#define zlapll	      zlapll     
#define zlapmt	      zlapmt     
#define zlaqgb	      zlaqgb     
#define zlaqge	      zlaqge     
#define zlaqhb	      zlaqhb     
#define zlaqhe	      zlaqhe     
#define zlaqhp	      zlaqhp     
#define zlaqp2	      zlaqp2     
#define zlaqps	      zlaqps     
#define zlaqsb	      zlaqsb     
#define zlaqsp	      zlaqsp     
#define zlaqsy	      zlaqsy     
#define zlar1v	      zlar1v     
#define zlar2v	      zlar2v     
#define zlarcm	      zlarcm     
#define zlarf	      zlarf	     
#define zlarfb	      zlarfb     
#define zlarfg	      zlarfg     
#define zlarft	      zlarft     
#define zlarfx	      zlarfx     
#define zlargv	      zlargv     
#define zlarnv	      zlarnv     
#define zlarrv	      zlarrv     
#define zlartg	      zlartg     
#define zlartv	      zlartv     
#define zlarz	      zlarz	     
#define zlarzb	      zlarzb     
#define zlarzt	      zlarzt     
#define zlascl	      zlascl     
#define zlaset	      zlaset     
#define zlasr	      zlasr	     
#define zlassq	      zlassq     
#define zlaswp	      zlaswp     
#define zlasyf	      zlasyf     
#define zlatbs	      zlatbs     
#define zlatdf	      zlatdf     
#define zlatps	      zlatps     
#define zlatrd	      zlatrd     
#define zlatrs	      zlatrs     
#define zlatrz	      zlatrz     
#define zlatzm	      zlatzm     
#define zlauu2	      zlauu2     
#define zlauum	      zlauum     
#define zpbcon	      zpbcon     
#define zpbequ	      zpbequ     
#define zpbrfs	      zpbrfs     
#define zpbstf	      zpbstf     
#define zpbsv	      zpbsv	     
#define zpbsvx	      zpbsvx     
#define zpbtf2	      zpbtf2     
#define zpbtrf	      zpbtrf     
#define zpbtrs	      zpbtrs     
#define zpocon	      zpocon     
#define zpoequ	      zpoequ     
#define zporfs	      zporfs     
#define zposv	      zposv	     
#define zposvx	      zposvx     
#define zpotf2	      zpotf2     
#define zpotrf	      zpotrf     
#define zpotri	      zpotri     
#define zpotrs	      zpotrs     
#define zppcon	      zppcon     
#define zppequ	      zppequ     
#define zpprfs	      zpprfs     
#define zppsv	      zppsv	     
#define zppsvx	      zppsvx     
#define zpptrf	      zpptrf     
#define zpptri	      zpptri     
#define zpptrs	      zpptrs     
#define zptcon	      zptcon     
#define zpteqr	      zpteqr     
#define zptrfs	      zptrfs     
#define zptsv	      zptsv	     
#define zptsvx	      zptsvx     
#define zpttrf	      zpttrf     
#define zpttrs	      zpttrs     
#define zptts2	      zptts2     
#define zrotn	      zrotn	     
#define zspcon	      zspcon     
#define zspmv	      zspmv	     
#define zspru	      zspru	     
#define zsprfs	      zsprfs     
#define zspsv	      zspsv	     
#define zspsvx	      zspsvx     
#define zsptrf	      zsptrf     
#define zsptri	      zsptri     
#define zsptrs	      zsptrs     
#define zstedc	      zstedc     
#define zstegr	      zstegr     
#define zstein	      zstein     
#define zsteqr	      zsteqr     
#define zsycon	      zsycon     
#define zsymv	      zsymv	     
#define zsyru	      zsyru	     
#define zsyrfs	      zsyrfs     
#define zsysv	      zsysv	     
#define zsysvx	      zsysvx     
#define zsytf2	      zsytf2     
#define zsytrf	      zsytrf     
#define zsytri	      zsytri     
#define zsytrs	      zsytrs     
#define ztbcon	      ztbcon     
#define ztbrfs	      ztbrfs     
#define ztbtrs	      ztbtrs     
#define ztgevc	      ztgevc     
#define ztgex2	      ztgex2     
#define ztgexc	      ztgexc     
#define ztgsen	      ztgsen     
#define ztgsja	      ztgsja     
#define ztgsna	      ztgsna     
#define ztgsy2	      ztgsy2     
#define ztgsyl	      ztgsyl     
#define ztpcon	      ztpcon     
#define ztprfs	      ztprfs     
#define ztptri	      ztptri     
#define ztptrs	      ztptrs     
#define ztrcon	      ztrcon     
#define ztrevc	      ztrevc     
#define ztrexc	      ztrexc     
#define ztrrfs	      ztrrfs     
#define ztrsen	      ztrsen     
#define ztrsna	      ztrsna     
#define ztrsyl	      ztrsyl     
#define ztrti2	      ztrti2     
#define ztrtri	      ztrtri     
#define ztrtrs	      ztrtrs     
#define ztzrqf	      ztzrqf     
#define ztzrzf	      ztzrzf     
#define zung2l	      zung2l     
#define zung2r	      zung2r     
#define zungbr	      zungbr     
#define zunghr	      zunghr     
#define zungl2	      zungl2     
#define zunglq	      zunglq     
#define zungql	      zungql     
#define zungqr	      zungqr     
#define zungr2	      zungr2     
#define zungrq	      zungrq     
#define zungtr	      zungtr     
#define zunm2l	      zunm2l     
#define zunm2r	      zunm2r     
#define zunmbr	      zunmbr     
#define zunmhr	      zunmhr     
#define zunml2	      zunml2     
#define zunmlq	      zunmlq     
#define zunmql	      zunmql     
#define zunmqr	      zunmqr     
#define zunmr2	      zunmr2     
#define zunmr3	      zunmr3     
#define zunmrq	      zunmrq     
#define zunmrz	      zunmrz     
#define zunmtr	      zunmtr     
#define zupgtr	      zupgtr     
#define zupmtr	      zupmtr     


#endif

#endif /* _NAMESLAPACK_H */
